C  File:  n1_nplex_it.for

! Autor: G. Schnell

! 16.01.2008

C  Untersuchen Zahlen N zwischen 3 und 2^25-1 auf psp/apsp.

C  Test: ( a0, a1, a2, ... )^n == ( r1, r2, r3, ... ) mod n

      IMPLICIT NONE

      REAL*8 dE0, dE1, dE2, dE3             ! zu: e
      REAL*8 dY                             ! zu: y
      REAL*8 dM                             ! Modul M
      COMMON /  NPLEX  / dE0, dE1, dE2, dE3, dY, dM

      REAL*8 dY_anf, dY_end                 ! zu: y
      REAL*8 dE0_anf, dE0_end               ! zu: e
      INTEGER*4 iY, iE0, iE1, iE2, iE3      ! zu: y, e

      INTEGER*4 PSP_COUNT, APSP_COUNT, N_COUNT, PRIM_COUNT
      INTEGER*4 T_COUNT     ! Anzahl der ausgewaehlten N mit gefundenem Teiler 
      INTEGER*4 NT_COUNT    ! Anzahl als teilbar erkannten, ausgewaehlten N

      INTEGER*4 N_anf, N_end, N
      INTEGER*4 NNT/ 0 /         ! letztes teilbares N ohne gefundenen Teiler
      INTEGER*4 IE_MAX, I, J, Je, Js
      INTEGER*4 K, T, IBAS
      INTEGER*4 iST_KZ

      LOGICAL*4 LFLAG
      LOGICAL*4 LPRIM, LP, LFOUND

      LOGICAL*4 LPSP             ! True, wenn Zahl N psp
      LOGICAL*4 LAPSP            ! True, wenn Zahl N absolut psp
      LOGICAL*4 LTF              ! True, wenn Teiler eines N gefunden
      LOGICAL*4 LMP              ! True, wenn Muster prim/pseudoprim gefunden
      LOGICAL*4 LNT              ! True, wenn N definitiv teilbar

      LOGICAL*4 LMAT             ! True, wenn NPLEX-Matrizen. zu drucken
      LOGICAL*4 LMOD             ! True, wenn Kongruenzmatrizen zu drucken
      COMMON / MATRIX / LMAT, LMOD

      CHARACTER*(*) FMT1
      PARAMETER ( FMT1 = '(4X,1P,5E14.6)' )

      INTEGER*4 NPL, NPL_MAX
      PARAMETER ( NPL_MAX =   4 )
      REAL*8 Fa( NPL_MAX ), Fr( NPL_MAX )

      REAL*8 P, RS, BAS, FrS, dDUMMY

      INTEGER*4 Fid( NPL_MAX ), Fit( NPL_MAX ), Fiac( NPL_MAX )
      INTEGER*4 IMP, iMP_C

      INTEGER*4 FT( 25 ), IANZ

      CHARACTER*72 TXT
      CHARACTER*6 CH6

      INTEGER*4 IO_LI         ! I/O unit Liste
      INTEGER*4 IO_DAT        ! I/O unit Data
      CHARACTER*80 FILE_LI    ! Listfile
      CHARACTER*80 FILE_DAT   ! Datafile

      DATA dE1, dE2, dE3 / 0, 0, 0 /

C     DATA IE_MAX/ 1 073 741 823 /   ! 2^30 - 1
      DATA IE_MAX/    33 554 431 /   ! 2^25 - 1
C     DATA IE_MAX/     8 388 607 /   ! 2^23 - 1
C     DATA IE_MAX/     4 194 303 /   ! 2^22 - 1
C     DATA IE_MAX/     2 097 151 /   ! 2^21 - 1
C     DATA IE_MAX/     1 048 575 /   ! 2^20 - 1


      IO_DAT = 19   ! I/O Units setzen
      IO_LI  = 22   !

      ! Dateinamen:
      FILE_DAT = 'n1_nplex_it.dat'
      FILE_LI  = 'n1_nplex_it.ls'

      OPEN( UNIT=IO_DAT, FILE = FILE_DAT )
      OPEN( UNIT=IO_LI,  FILE = FILE_LI )

C  Daten von Datafile lesen

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! IO_DAT auf Datenzeile pos.
      READ(IO_DAT, '(A)' ) TXT          ! Text zur Aufgabe

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Zahlenbereich N
      READ(IO_DAT, * ) N_anf, N_end
      IF( IABS(N_anf) .LT. 3            ) THEN
         WRITE(IO_LI,*) 'N_anf = ', N_anf, ' abs. zu klein.'
         STOP
      END IF
      IF( IABS(N_end) .GT. IE_MAX       ) THEN
         WRITE(IO_LI,*) 'N_end = ', N_end, ' abs. zu gross.'
      !  STOP
      END IF
      IF( ( N_anf .GT. N_end  )         ) THEN
         WRITE(IO_LI,*) 'N_anf groesser als N_end nicht erlaubt.'
         STOP
      END IF
      IF( MOD( N_anf, 2 ) .NE. 1       ) THEN
!        WRITE(IO_LI,*) 'Gerades N_anf nicht erlaubt.'
!        STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Laenge Nplex
      READ(IO_DAT, * ) NPL
      IF( (NPL.LT.1) .OR. (NPL.GT.NPL_MAX) ) THEN
         WRITE(IO_LI,*) 'Laenge Nplex = ', NPL, ' nicht erlaubt.'
         STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Steuerung Auswahl von N
      READ(IO_DAT, * ) iST_KZ           ! 1 = alle teilbaren N
      IF( ( iST_KZ .LT. 0 ) .OR.        ! 2 = nur psp und apsp N
     +    ( iST_KZ .GT. 3 ) ) THEN      ! 3 = nur apsp N
                                        ! 0 = nur prime N
         WRITE(IO_LI,*) 'Steuer-Kz fuer Auswahl N = ', iST_KZ,
     +                  ' nicht erlaubt.'
         STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Basis psp-Kriterium
      READ(IO_DAT, * ) iBAS
      IF( (iBAS.LT.2) .OR. (iBAS.GT.1024) ) THEN
         WRITE(IO_LI,*)'Basis psp-Kriterium = ', iBAS, ' nicht erlaubt.'
         STOP
      END IF
      BAS = IBAS  ! Basis fuer Test auf pseudoprim

      CALL UP_IN_POS( IO_DAT, IO_LI )  ! Drucken: Nplex-Matrix, Modulo-M
      READ(IO_DAT, * ) LMat, LMod

      CALL UP_IN_POS( IO_DAT, IO_LI )    ! Bereich y-Parameter
      READ(IO_DAT, * ) dY_anf, dY_end
      IF( DABS(dY_anf).GT. IE_MAX   ) THEN
         WRITE(IO_LI,*) 'dY_anf = ', dY_anf, ' nicht erlaubt.'
         STOP
      END IF
      IF( DABS(dY_end).GT. IE_MAX   ) THEN
         WRITE(IO_LI,*) 'dY_end = ', dY_end, ' nicht erlaubt.'
         STOP
      END IF
      IF( dY_anf .GT. dY_end ) THEN
         WRITE(IO_LI,*) 'dY_anf groesser dY_end nicht erlaubt.'
         STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )     ! Bereich e-Parameter
      READ(IO_DAT, * ) dE0_anf, dE0_end
      IF( DABS(dE0_anf).GT. 8019.0D0 ) THEN
         WRITE(IO_LI,*) 'dE0_anf = ', dE0_anf, ' nicht erlaubt.'
         STOP
      END IF
      IF( DABS(dE0_end).GT. 8019.0D0 ) THEN
         WRITE(IO_LI,*) 'dE0_end = ', dE0_end, ' nicht erlaubt.'
         STOP
      END IF
      IF( dE0_anf .GT. dE0_end ) THEN
         WRITE(IO_LI,*) 'dE0_anf .groesser dE0_end nicht erlaubt.'
         STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! restliche Koeffizienten zu e
      IF( NPL .EQ. 2 ) THEN
         READ(IO_DAT, * ) dE1
      ELSE IF( NPL .EQ. 3 ) THEN
         READ(IO_DAT, * ) dE1, dE2
      ELSE IF( NPL .EQ. 4 ) THEN
         READ(IO_DAT, * ) dE1, dE2, dE3
      ELSE
         ! NPL = 1
         READ(IO_DAT, * ) dDUMMY
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Koeffizienten des Nplex
      READ(IO_DAT, * ) ( Fa(J), J = 1, NPL )

      LFLAG = .TRUE.
      DO J = 1, NPL       ! Mindestens ein Wert des Nplex nicht Null ?
         IF( Fa( j ) .NE. 0.0D0 ) LFLAG = .FALSE.
      END DO
      IF( LFLAG ) THEN    ! Nplex ist Null.
         WRITE(IO_LI,*) 'Nplex a ist Null.'
         STOP
      END IF

      CLOSE ( IO_DAT )

      N_COUNT    = 0   ! Anzahl untersuchter Zahlen N
      PRIM_COUNT = 0   ! davon Anzahl Primzahlen
      PSP _COUNT = 0   ! davon Anzahl psp-Pseudoprimzahlen
      APSP_COUNT = 0   ! davon Anzahl absolute Pseudoprimzahlen
      T_COUNT    = 0   ! Anzahl der ausgewaehlten N mit gefundenem Teiler
      NT_COUNT   = 0   ! Anzahl von als teilbar erkannten, ausgewaehlten N


      ! Zur Erinnerung: zwischen 2 und 100 000 liegen 9592 Primzahlen
      !                          2     1 000 000  "   78 498   "

      WRITE(IO_LI,*) 'Programm: n1_nplex_it.exe'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) TXT
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Testen Zahlen N im Bereich N_anf bis N_end:'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'N_anf =', N_anf
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'N_end =', N_end
      WRITE(IO_LI,*)
      WRITE(IO_LI,2000) NPL
      WRITE(IO_LI,*)
      IF( iST_KZ .EQ. 1 ) THEN
         WRITE(IO_LI,*)  'iST_KZ = 1: Es werden alle teilbaren N ',
     +                   'untersucht.'
      ELSE IF( iST_KZ .EQ. 2 ) THEN
         WRITE(IO_LI,*)  'iST_KZ = 2: Es werden nur psp N ',
     +                   'untersucht.'
      ELSE IF( iST_KZ .EQ. 3 ) THEN
         WRITE(IO_LI,*)  'iST_KZ = 3: Es werden nur apsp N ',
     +                   'untersucht.'
      ELSE IF( iST_KZ .EQ. 0 ) THEN
         WRITE(IO_LI,*)  'iST_KZ = 0: Es werden nur prime N ',
     +                   'untersucht.'
      END IF
      WRITE(IO_LI,*)
      WRITE(IO_LI,2010) iBAS
      WRITE(IO_LI,*)
      WRITE(IO_LI,2020) LMat, LMod
      WRITE(IO_LI,*)
      WRITE(IO_LI,2030) dY_anf, dY_end
      WRITE(IO_LI,*)
      WRITE(IO_LI,2040) dE0_anf, dE0_end
      WRITE(IO_LI,*)
      IF( NPL .EQ. 2 ) THEN
      WRITE(IO_LI,2052) dE1
      ELSE IF( NPL .EQ. 3 ) THEN
      WRITE(IO_LI,2053) dE1, dE2
      ELSE IF( NPL .EQ. 4 ) THEN
      WRITE(IO_LI,*) 'e1 =', dE1, '  e2 =', dE2, '  e3 =', dE3
      END IF
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Koeffizienten Nplex a: ( a0, a1, a2, ... )'
      CALL DPUT( Fa(1), IO_LI, FMT1, 1, NPL, 0, 0 )
      WRITE(IO_LI,*)

 2000 FORMAT('Laenge d des N-Plex ist:',I3)
 2010 FORMAT('Basis psp-Kriterium =',I3)
 2020 FORMAT('Drucken: Nplex-Matrix =',L2,'    Modulo-Matrix =',L2)
 2030 FORMAT('y_anf  =',1P,E14.6,'  y_end  =',1P,E14.6)
 2040 FORMAT('e0_anf =',1P,E14.6,'  e0_end =',1P,E14.6)
 2052 FORMAT('e1     =',1P,E14.6)
 2053 FORMAT('e1     =',1P,E14.6,'  e2     =',1P,E14.6)
 2054 FORMAT('e1     =',1P,E14.6,'  e2     =',1P,E14.6,
     +                           '  e3     =',1P,E14.6)

      DO  N = N_anf, N_end, 2     ! Zahlenbereich N

          N_COUNT = N_COUNT + 1   ! Anzahl untersuchter N
          LTF = .FALSE.           ! Reset, Teiler eines N gefunden

      P  = N            ! P = N
      dM = P            ! Modul
      DO I = 1, 4
         FIAC(I) = 0
         FID (I) = 0
         FIT (I) = 0
         FR  (I) = 0
      END DO

      LP = LPRIM( (N), T )   ! LP = prim/not prim ; T = Teiler

      IF( LP ) THEN          ! P = Primzahl ?
         PRIM_COUNT = PRIM_COUNT + 1
         CH6 = '    p '
         LPSP  = .FALSE.   ! RESETS
         LAPSP = .FALSE.   !    "
      ELSE
         CH6 = '    t '
      ! Pruefen ob P pseudoprim bezueglich Basis BAS
         CALL SIEB( BAS, P, -BAS, P, RS )  ! z.B.: 2^P-2 == RS mod P
         IF( RS .EQ. 0.0D0 ) THEN
            CH6 = '  psp '  ! P psp bzgl. Basis: BAS
            LPSP = .TRUE.
         ELSE
            LPSP = .FALSE.
         END IF
      END IF

      ! alle Teiler von P = N best., LAPSP = TRUE wenn P abs. psp
      CALL TEILER( P, FT, IANZ, LAPSP )
      IF( IANZ .EQ. 1 ) THEN    ! N ist prim
         F T( 1 ) = N
         FIT( 1 ) = N
      END IF

      IF( LAPSP ) THEN
         CH6 = ' apsp '    ! N absolut pseudoprim
         APSP _COUNT = APSP _COUNT + 1
      ELSE
         IF( LPSP ) PSP_COUNT = PSP_COUNT + 1         
      END IF

      DO J = 1, NPL                   ! Koeff. von a als Integer
         Fiac( J ) = Fa( J )
      END DO

         ! Auswaehlen Zahlen N
         ! iST_KZ = 0 : nur prime      Zahlen N auswaehlen
         ! iST_KZ = 1 : alle teilbaren Zahlen N auswaehlen
         ! iST_KZ = 2 : nur psp        Zahlen N auswaehlen
         ! iST_KZ = 3 : nur apsp       Zahlen N auswaehlen

         IF( IST_KZ.EQ.0 .AND. .NOT. LP    ) GO TO 800
         IF( IST_KZ.EQ.1 .AND.       LP    ) GO TO 800
         IF( IST_KZ.EQ.2 .AND. (     LP
     +        .OR. LAPSP .OR.  .NOT. LPSP )) GO TO 800
         IF( IST_KZ.EQ.3 .AND. .NOT. LAPSP ) GO TO 800

      WRITE(IO_LI,1000) N, CH6
      WRITE(IO_LI,1400) ( FT(J),J=1,IANZ)   ! alle Teiler P = N
      WRITE(IO_LI,*)

      FT( IANZ ) = IABS( FT( IANZ ) )   ! Teiler pos. falls N negativ

      LNT = .FALSE.                     ! True, wenn N als teilbar erkannt

      DO dY = dY_anf, dY_end

      IF( dY .EQ. 0.0D0 ) GO TO 700   ! y = 0 ueberlesen

      DO dE0 = dE0_anf, dE0_end

      iY  = dY
      iE0 = dE0
      iE1 = dE1
      iE2 = dE2
      iE3 = dE3
      IF( NPL .EQ. 1 ) THEN
         WRITE(IO_LI,1301) iY, iE0
      ELSE IF( NPL .EQ. 2 ) THEN
         WRITE(IO_LI,1302) iY, iE0, iE1
      ELSE IF( NPL .EQ. 3 ) THEN
         WRITE(IO_LI,1303) iY, iE0, iE1, iE2
      ELSE IF( NPL .EQ. 4 ) THEN
         WRITE(IO_LI,1304) iY, iE0, iE1, iE2, iE3
      END IF

      CALL SIEB_NPLEX( NPL, Fa, P, Fr )

      ! Pruefen fuer NPL=2 ob N nplex-psp
      IF( NPL .EQ. 2 ) THEN
         FrS = Fr(1) + Fr(2)
         IF( ( FrS .EQ. P ) .OR.
     +       ( FrS .EQ. Fa(1) + Fa(2) ) .OR.
     +       ( FrS .EQ. 0.0D0 ) ) THEN
!*!          GO TO 700    ! Diese Kombination y,e ueberlesen
         END IF
      END IF

      Je = NPL
      Js = Je

      IF( NPL .EQ. 1 ) THEN
          WRITE(IO_LI,1200) (Fiac(J),J=1,1), (Fr(J),J=1,Js)
      ELSE IF( NPL .EQ. 2 ) THEN
          WRITE(IO_LI,1201) (Fiac(J),J=1,2), (Fr(J),J=1,Js)
      ELSE IF( NPL .EQ. 3 ) THEN
          WRITE(IO_LI,1202) (Fiac(J),J=1,3), (Fr(J),J=1,Js)
      ELSE
          WRITE(IO_LI,1203) (Fiac(J),J=1,4), (Fr(J),J=1,Js)
      END IF

      IF( .NOT. LP ) THEN   ! N ist nicht prim

         IF( NNT .EQ. 0 ) NNT = N

      DO iMP_C = 1, IANZ

         iMP = FT( iMP_C )  ! Teiler von N

         K = iMP
         IF( (iMP_C .GT. 1) .AND. ( K .EQ. FT(iMP_C-1) ) ) iMP=K**2

        DO K = 1, NPL
           IF( Fr( K ) .EQ. 0.0D0 ) THEN
              Fid( K ) = 0
              Fit( K ) = 0
           ELSE
              Fid( K ) = 0
              CALL UP_IT( Fid(K), Fr(K), Fit(K), iMP, LFOUND )
              IF( .NOT. LFOUND ) THEN
                 Fid(K) = 0
                 Fit(K) = 0
              END IF
           END IF
        END DO

        LMP = .TRUE.   ! statt call up_mp(  ... )

         IF( NPL. EQ. 1 ) THEN
            WRITE(IO_LI,1100) (Fid(J),Fit(J),J=1,Js)
         ELSE IF( NPL. EQ. 2 ) THEN
            WRITE(IO_LI,1101) (Fid(J),Fit(J),J=1,Js)
         ELSE IF( NPL. EQ. 3 ) THEN
            WRITE(IO_LI,1102) (Fid(J),Fit(J),J=1,Js)
         ELSE
            WRITE(IO_LI,1103) (Fid(J),Fit(J),J=1,Js)
         END IF

  600 CONTINUE ! Einsprung: Ueberlesen gleiche Teiler von N

      END DO   ! Ende: iMP_C Schleife

      CALL UP_T_COUNT( P, NPL, Fa, Fr, LTF )    ! LTF =.T. wenn Teiler gefunden

      CALL UP_NT_COUNT( P, NPL, Fa, Fr, LNT )   ! LNT =.T. wenn als teilbar erkannt 

      END IF   ! ( N .not. prim )  Ende

      END DO   ! Ende Schleife dE0

  700 CONTINUE   ! Label: dY ueberspringen

      END DO   ! Ende Schleife dY

      WRITE(IO_LI,*)

      IF( LTF ) THEN
         T_COUNT = T_COUNT + 1
         IF( NNT .EQ. N ) NNT = 0
      END IF

      IF( LNT ) THEN
         NT_COUNT = NT_COUNT + 1
      END IF

  800 CONTINUE   ! Label: N ueberspringen

      END DO    ! Schleife Zahlenbereich N Ende

      WRITE(IO_LI,*)
      WRITE(IO_LI,3000) N_COUNT
      WRITE(IO_LI,*)
      WRITE(IO_LI,3010) PRIM_COUNT
      IF( IST_KZ .NE. 0 ) THEN   ! nicht prime N ?

         WRITE(IO_LI,*)
         WRITE(IO_LI,3020) PSP _COUNT
         WRITE(IO_LI,*)
         WRITE(IO_LI,3030) APSP_COUNT
         WRITE(IO_LI,*)
         IF( IST_KZ .EQ. 2 ) THEN   ! N psp ?
            WRITE(IO_LI,3042) T_COUNT,  PSP_COUNT
         ELSE IF( IST_KZ .EQ. 3 ) THEN   ! N apsp ?
            WRITE(IO_LI,3043) T_COUNT, APSP_COUNT
         ELSE IF( IST_KZ .EQ. 1 ) THEN   ! N teilbar ?
            WRITE(IO_LI,3041) T_COUNT, NT_COUNT
         ELSE
            WRITE(IO_LI,3040) T_COUNT
         END IF
         WRITE(IO_LI,*)
         WRITE(IO_LI,3050) NT_COUNT

         IF( IST_KZ .NE. 0 ) THEN
            WRITE(IO_LI,*)
            WRITE(IO_LI,3060) NNT
         END IF

      END IF

 1000 FORMAT(1X,I8,1A6,'  Teiler N:')

 1100 FORMAT(9X,4(I6,I8))
 1101 FORMAT(17X,4(I6,I8))
 1102 FORMAT(25X,4(I6,I8))
 1103 FORMAT(24X,4(I6,I8))

 1200 FORMAT(1X,I8,1P,4E14.6)
 1201 FORMAT(1X,I8,I8,1P,4E14.6)
 1202 FORMAT(1X,I8,I8,I8,1P,4E14.6)
 1203 FORMAT(1X,I8,3I5,1P,4E14.6)
 1204 FORMAT(24X,4E14.7)

 1301 FORMAT(1X,'y = ',I4,'  e0 = ',I4)
 1302 FORMAT(1X,'y = ',I4,'  e0 = ',I4,'  e1 = ',I4)
 1303 FORMAT(1X,'y = ',I4,'  e0 = ',I4,'  e1 = ',I4,'  e2 = ',I4)
 1304 FORMAT(1X,'y = ',I4,'  e0 = ',I4,'  e1 = ',I4,'  e2 = ',I3,
     +                    '  e3 = ',I4)

 1400 FORMAT(1X,8I8,6(/1X,8I8))

 3000 FORMAT('   N_COUNT   =',I9)
 3010 FORMAT('PRIM_COUNT   =',I9)
 3020 FORMAT(' PSP_COUNT   =',I9)
 3030 FORMAT('APSP_COUNT   =',I9)
 3040 FORMAT('   T_COUNT   =',I9)
 3041 FORMAT('   T_COUNT   =',I9,'  von',I9)
 3042 FORMAT('   T_COUNT   =',I9,'  von',I9)
 3043 FORMAT('   T_COUNT   =',I9,'  von',I9)
 3050 FORMAT('  NT_COUNT   =',I9)
 3060 FORMAT('       NNT   =',I9)

      CLOSE ( IO_LI )

      STOP

      END
C  ------------------------------------------------------
C  FILE_DAT = 'n1_nplex_it.dat' fuers Lesen positionieren
C  und Kommentar- und Leer-Zeilen ueberlesen.

      SUBROUTINE UP_IN_POS( IO_IN, IO_LI )

      IMPLICIT NONE

      INTEGER*4 IO_IN, IO_LI, I
      CHARACTER*136 REC

   10 READ( IO_IN, '(A)', ERR=800, END=900 ) REC
      IF( REC(1:1) .EQ. '!' ) GO TO 10   ! Kommentarzeile ueberlesen
      DO 20, I = 1, 136
         IF( REC(I:I) .NE. ' ' ) THEN
            BACKSPACE IO_IN
            RETURN                       ! Datenzeile gefunden
         END IF
   20 CONTINUE
      GO TO 10                           ! Leerzeile ueberlesen

  800 WRITE( IO_LI, * ) 'Error beim Lesen von n1_nplex_it.dat'
      STOP

  900 WRITE( IO_LI, * ) 'EOF erreicht beim Lesen von n1_nplex_it.dat'
      STOP
      END
C  ------------------------------------------------
C  Testen ob Teiler zu P gefunden wird ( LTF = .T.)
C  gegeben: P, NPL, Fa(NPL), Fr(NPL), LTF

      SUBROUTINE UP_T_COUNT( P, NPL, Fa, Fr, LTF )

      IMPLICIT NONE

      INTEGER*4 NPL,  I
      LOGICAL*4 LTF
      REAL*8 P, Fa(NPL), Fr(NPL)

      REAL*8 GGT, T, a, r, r_a, ra

      DO I = 1, NPL

         a = Fa(I)
         r = Fr(I)

         ! GGT( P, r-a ) = Teiler ?
         r_a = r - a
         IF( (r_a .NE. 0.0D0) .AND. (r_a .NE. P ) ) THEN
            T = GGT( P, r_a )
            IF( T .NE. 1.0D0 ) THEN
               LTF = .TRUE.
               RETURN       ! Teiler gefunden
            END IF
         END IF

         ! GGT( P, r+a ) = Teiler ?
         ra = r + a
         IF( (ra .NE. 0.0D0) .AND. (ra .NE. P ) ) THEN
            T = GGT( P, ra )
            IF( T .NE. 1.0D0 ) THEN
               LTF = .TRUE.
               RETURN       ! Teiler gefunden
            END IF
         END IF

      END DO

      RETURN

      END
C  ---------------------------------
C  Testen ob P teilbar  ( LNT = .T.)
C  gegeben: P, NPL, Fa(NPL), Fr(NPL), LNT

      SUBROUTINE UP_NT_COUNT( P, NPL, Fa, Fr, LNT )

      IMPLICIT NONE

      INTEGER*4 NPL,  I
      LOGICAL*4 LNT
      REAL*8 P, Fa(NPL), Fr(NPL)

      REAL*8 a, r

      DO I = 1, NPL

         a = Fa(I)
         r = Fr(I)

         IF( a .GT. 0.0D0 ) THEN
            IF( r .NE. a ) THEN
               LNT = .TRUE.
               RETURN
            END IF
         ELSE IF( a .LT. 0.0D0 ) THEN
            IF( r .NE. a+P ) THEN
               LNT = .TRUE.
               RETURN
            END IF
         ELSE
            ! nothing  (a=0)
         END IF

      END DO

      RETURN

      END
C  ----------------------------------------------
C  GGT = Groesster gemeinsamer Teiler von A und B

      REAL*8 FUNCTION GGT( A, B )

      IMPLICIT NONE

      REAL*8 A, B
      REAL*8 X, Y, TEMP

      ! Division durch Null abfangen
      IF( ( A .EQ. 0.0D0 ) .OR. ( B .EQ. 0.0D0 ) ) THEN
         GGT = 0.0D0
         RETURN
      END IF

      X = A
      Y = B
   10 TEMP = Y
      Y = DMOD( X, Y )
      X = TEMP
      IF( Y .NE. 0.0D0 ) GO TO 10
      GGT = X

      RETURN
      END
C  ---------- DPUT ---------------------------
C  Drucken Matrix oder Vektor FD[M,N],  Real*8
C  FD    = Matrix[M,N]
C  IOU   = Output-Unit
C  IVOR  = Anzahl Leer-Zeilen vor dem Drucken
C  INACH = Anzahl Leer-Zeilen nach dem Drucken
C  HFORM = Vektor der das Druck-Format enthaelt

      SUBROUTINE DPUT( FD, IOU, HFORM, M, N, IVOR, INACH )

      IMPLICIT NONE

      INTEGER*4 IOU
      INTEGER*4 N, M, IVOR, INACH, I, J
      REAL*8 FD(M,N)
      CHARACTER*(*) HFORM

      IF( IVOR .LE. 0 ) GO TO 9

      DO 5, I = 1, IVOR
         WRITE(IOU,2000)
    5 CONTINUE

    9 CONTINUE

      DO 10, I = 1, M
       WRITE(IOU,HFORM) ( FD(I,J), J = 1, N )
   10 CONTINUE

      IF( INACH .LE. 0 ) RETURN

      DO 15, I = 1, INACH
         WRITE(IOU,2000)
   15 CONTINUE

      RETURN

 2000 FORMAT(2H  )
      END
C  ---------------------------
C  Alle Teiler von P bestimmen
C  Anzahl der Teiler stehen in IANZ
C  IANZ = 1 wenn P prim
C  Teiler von P stehen in FT ( aufsteigend )
C  LAPSP = True wenn P absolut pseudoprim

C  Formeln:
C  Eine zusammengesetzte Zahl n ist absolut pseudoprim bzw.
C  eine Carmichael-Zahl wenn gilt:  n | a^n - a  fuer alle a mit
C  ggT( a, n ) = 1 .

C  und wenn n = q1 * q2 * ... * qk mit k >= 3,
C  wobei q1, q2, ... ,qk verschiedene Primzahlen
C  mit  qi-1 | n-1 ( i = 1, 2, ... ,k ) sind.

      SUBROUTINE TEILER( P, FT, IANZ, LAPSP )

      IMPLICIT NONE

      REAL*8 P
      INTEGER*4 FT(*), IANZ,  I, G, A
      LOGICAL*4 LAPSP, LPRIM, L

      LAPSP = .FALSE.
      G = P
      I = 1
      IANZ = 1
      FT(1)= 1

      L = LPRIM( G, A )
      IF( L ) RETURN      ! P ist prim

  100 CONTINUE
      FT( I ) = A
      I = I + 1
      G = G / A

      L = LPRIM( G, A )
      IF( L ) THEN
         FT( I ) = G
         IANZ = I
         GO TO 200   ! alle Teiler bestimmt
      ELSE
         GO TO 100
      END IF

  200 CONTINUE
      IF(IANZ .LT. 3) RETURN   ! nicht abs. pseudoprim, Anzahl zu klein

      DO 250, I = 2, IANZ
         IF( FT(I) .LE. FT(I-1) ) RETURN   ! nicht alle Teiler ungleich
  250 CONTINUE

      G = P - 1
      DO 300, I = 1, IANZ
         IF( MOD( G, FT(I) - 1 ) .NE. 0 ) RETURN
  300 CONTINUE

      LAPSP = .TRUE.

      RETURN

      END
C  -------------------------
C  LPRIM = true falls P prim
C  Teiler P

      LOGICAL*4 FUNCTION LPRIM( P, T )

      IMPLICIT NONE

      INTEGER*4 P, T, L, LE
      REAL*8 D

      T = 1

      IF( P .EQ. 2 ) THEN
         LPRIM = .TRUE.
         RETURN
      END IF

      LPRIM = .FALSE.

      IF( MOD( P, 2 ) .EQ. 0 ) THEN
         T = 2
         RETURN
      END IF

      D = P
      LE = DSQRT( DABS( D ) ) + .1D0

      DO 100, L = 3, LE, 2
         IF( MOD( P, L ) .EQ. 0 ) THEN
            T = L
            RETURN
         END IF
  100 CONTINUE

      LPRIM = .TRUE.

      RETURN

      END
C  --------------------------
C  ( a^n + b ) == r  modulo m

      SUBROUTINE SIEB( A, N, B, M, R )

      IMPLICIT NONE

      REAL*8 A, N, B, M, R

      REAL*8 G, D, S, Q

      LOGICAL*4 START

      START = .TRUE.
      G     = N      ! G wird veraendert
      Q     = A * A

      D = DMOD( G, 2.0D0 )

      IF( D .EQ. 0.0D0 ) THEN
         S = 1.0D0
      ELSE
         S = A
      END IF

  100 CONTINUE
      G = ( G - D ) / 2.0D0

      IF( G .EQ. 0.0D0 ) GO TO 200   ! fertig

      D = DMOD( G, 2.0D0 )

      IF( START ) THEN
         START = .FALSE.
      ELSE
         Q = DMOD( Q*Q, M )
      END IF

      IF( D .NE. 0.0D0 ) THEN
         S = DMOD( Q * S, M )
      END IF

      GO TO 100

  200 R = DMOD( S + B, M )

      RETURN

      END
C  -------------------
C  NPLEX ^ n modulo dM
C  Koeffizienten des Nplex in Fa( NPL )
C  Reste in Fr( NPL )

C  ( a0 + a1*x + a2*x^2 + ... )^n == ( r1, r2*z, r3*z^2 ... )  modulo dM

      SUBROUTINE SIEB_NPLEX( NPL, Fa, N, Fr )

      IMPLICIT NONE

      INTEGER*4 NPL                ! Laenge Nplex
      REAL*8 Fa( NPL ), Fr( NPL )  ! Nplex a und Modulo-Reste
      REAL*8 N                     ! Exponent, Modul

      REAL*8 dE0, dE1, dE2, dE3         ! zu: e
      REAL*8 dY                         ! zu: y
      REAL*8 dM                         ! Modul
      COMMON /  NPLEX  / dE0, dE1, dE2, dE3, dY, dM

      INTEGER*4 I, NPL_MAX
      PARAMETER ( NPL_MAX =   4 )
      REAL*8 G, RM

      REAL*8 MA( NPL_MAX, NPL_MAX )   ! Nplex a als Matrix mit e und x !
      REAL*8 QT( NPL_MAX, NPL_MAX )
      REAL*8 ST( NPL_MAX, NPL_MAX )
      REAL*8 ZT( NPL_MAX, NPL_MAX )   ! Zwischenspeicher

      LOGICAL*4 LMAT, LMOD
      COMMON / MATRIX / LMAT, LMOD

      LOGICAL*4 START

      CHARACTER*(*) FMT1
      PARAMETER ( FMT1 = '(4X,5E14.7)' )
      INTEGER*4 IO_LI         ! I/O unit Liste
      IO_LI  = 22   !

      START = .TRUE.
      G     = N - 1    ! G = Exponent, G wird veraendert

      ! Nplex a als Matrix mit e und x !
      CALL GEN_MA( NPL, Fa, MA )
      IF( LMat ) THEN
         CALL DPUT( MA, IO_LI, FMT1, NPL, NPL, 0, 0 )
         WRITE(IO_LI,*)
      END IF
      CALL UP_DMOD( MA, MA, dM, NPL, NPL )   ! MA = DMOD( MA, dM )

C     QT = Ma * Ma     ! QT = ( a0, a1, a2, ... )^2
      CALL DMLTM( MA, NPL, NPL, MA, NPL, QT )
      CALL UP_DMOD( QT, QT, dM, NPL, NPL )   ! QT = DMOD( QT, dM )

      RM = DMOD( G, 2.0D0 )

      IF( RM .EQ. 0.0D0 ) THEN
         ! ST = E
         CALL DKLARM( ST, NPL, NPL )
         CALL DEADD ( ST, NPL )
      ELSE
         ! ST = MA
         CALL DMOVEM( ST, MA, NPL, NPL )
      END IF

  100 CONTINUE                       ! Schleife G Anfang
      G = ( G - RM ) / 2.0D0

      IF( G .EQ. 0.0D0 ) GO TO 200   ! fertig

      RM = DMOD( G, 2.0D0 )

      IF( START ) THEN
         START = .FALSE.
      ELSE
         !  Q  = Q * Q
         CALL DMLTM( QT, NPL, NPL, QT, NPL, ZT )
         CALL UP_DMOD( QT, ZT, dM, NPL, NPL )
      END IF

      IF( RM .NE. 0.0D0 ) THEN
         !  S  = Q * S
         CALL DMLTM( QT, NPL, NPL, ST, NPL, ZT )
         CALL UP_DMOD( ST, ZT, dM, NPL, NPL )
      END IF

      GO TO 100                      ! Schleife G Ende

  200 CONTINUE

      IF( LMod ) THEN
         CALL DPUT( ST, IO_LI, FMT1, NPL, NPL, 0, 0 )
         WRITE(IO_LI,*)
      END IF

      ! ZT = ST * Fa
      CALL DMLTM( ST, NPL, NPL, Fa, 1, ZT )   ! a^(n-1) * a
      CALL UP_DMOD( Fr, ZT, dM, NPL, 1 )
      DO I = 1, NPL   ! Nur pos. Reste
         IF( Fr( I ) .LT. 0.0D0 ) THEN
            IF( dM .GT. 0.0D0 ) THEN
               Fr( I ) = Fr( I ) + dM
            ELSE
               Fr( I ) = Fr( I ) - dM
            END IF
         END IF
      END DO

      RETURN

      END
C  ------------------------------
C  Matrix MA zu Nplex a erstellen
C  NPL ist Laenge Nplex a
C  Diese Subroutine gilt fuer e = ( e0, e1, e2, ... )

      SUBROUTINE GEN_MA( NPL, A, MA )

      IMPLICIT NONE

      INTEGER*4 NPL,    I, J, K
      REAL*8 A(NPL), MA(NPL,NPL),  dy_PO

      REAL*8 dE0, dE1, dE2, dE3         ! zu: e
      REAL*8 dY                         ! zu: y
      REAL*8 dM                         ! Modul
      COMMON /  NPLEX  / dE0, dE1, dE2, dE3, dY, dM

      IF( NPL .EQ. 1 ) THEN
         MA(1,1) = A(1 )
      ELSE IF( NPL .EQ. 2 ) THEN
         MA(1,1) =  A(1)
         MA(1,2) = -A(2) * dE0
         MA(2,1) =  dY *   A(2)
         MA(2,2) =  dY * ( A(1) - A(2) * dE1 )
      ELSE IF( NPL .EQ. 3 ) THEN
         MA(1,1) =  A(1)
         MA(1,2) = -A(3) * dE0
         MA(1,3) = -A(2) * dE0 + A(3) * dE0 * dE2
         MA(2,1) =  dY * A(2)
         MA(2,2) =  dY * ( A(1) - A(3)*dE1 )
         MA(2,3) =  dY * (-A(2)*dE1 - A(3)*dE0 + A(3)*dE1*dE2 )
         MA(3,1) =  dY*dY * A(3)
         MA(3,2) =  dY*dY*( A(2) - A(3)*dE2 )
         MA(3,3) =  dY*dY*( A(1) - A(2)*dE2 - A(3)*dE1 + A(3)*dE2*dE2 )
      ELSE IF( NPL .GT. 3 ) THEN
      ! Unteres Dreieck von MA und Diagonale von Ma erstellen
      DO J = 1, NPL      ! NPL Spalten
         K = 1
         DO I = J, NPL   ! NPL Zeilen
            MA(I,J) = A(K)
            K = K + 1
         END DO
      END DO

      ! Oberes Dreieck von MA erstellen
      DO I = 1, NPL-1    ! ( NPL - 1 ) Zeilen
         K = NPL
         DO J = I+1, NPL ! ( NPL - 1 ) Spalten
            MA(I,J) = -A(K) * dE0
            K = K - 1
         END DO
      END DO

      ! Potenzen y verrechnen
      dY_PO = 1.0D0
      DO I = 2, NPL
         dY_PO = DMOD( dY_PO * dY, dM )
         DO J = 1, NPL
            MA(I,J) = DMOD( MA(I,J) * dY_PO, dM )
         END DO
      END DO

      END IF

      RETURN
      END
C  ----------------------------------------------------
C  Matrix MA zu Nplex a erstellen, NPL = 4
C  NPL ist Laenge Nplex a
C  Diese Subroutine gilt nur fuer e = ( e0, 0, 0, 0, 0 ) !

      SUBROUTINE GEN_MA_E0( NPL, A, MA )

      IMPLICIT NONE

      INTEGER*4 NPL,    I, J, K
      REAL*8 A(NPL), MA(NPL,NPL),  dy_PO

      REAL*8 dE0, dE1, dE2, dE3         ! zu: e
      REAL*8 dY                         ! zu: y
      REAL*8 dM                         ! Modul
      COMMON /  NPLEX  / dE0, dE1, dE2, dE3, dY, dM

      ! Unteres Dreieck von MA und Diagonale von Ma erstellen
      DO J = 1, NPL      ! NPL Spalten
         K = 1
         DO I = J, NPL   ! NPL Zeilen
            MA(I,J) = A(K)
            K = K + 1
         END DO
      END DO

      ! Oberes Dreieck von MA erstellen
      DO I = 1, NPL-1    ! ( NPL - 1 ) Zeilen
         K = NPL
         DO J = I+1, NPL ! ( NPL - 1 ) Spalten
            MA(I,J) = -A(K) * dE0
            K = K - 1
         END DO
      END DO

      ! Potenzen y verrechnen
      dY_PO = 1.0D0
      DO I = 2, NPL
         dY_PO = DMOD( dY_PO * dY, dM )
         DO J = 1, NPL
            MA(I,J) = DMOD( MA(I,J) * dY_PO, dM )
         END DO
      END DO

      RETURN
      END
C  ----------------------------------------------------
C  Multiplizieren Matrix MA mit Vektor B, Ergebnis in C
C  NPL ist Dimension von MA, B, C.

      SUBROUTINE MLT_M_V( NPL, MA, B, C )

      IMPLICIT NONE

      INTEGER*4 NPL,   I, J
      REAL*8    MA(NPL,NPL), B(NPL), C(NPL)

      DO I = 1, NPL
         C(I) = 0.0D0
         DO J = 1, NPL
            C(I) = C(I) + MA(I,J) * B(J)
         END DO
      END DO
      RETURN
      END
C  -------------------------------
C  Einheitsmatrix addieren  REAL*8
C  D(N,N) = D(N,N) + E(N,N)

      SUBROUTINE DEADD( D, N )

      IMPLICIT NONE

      INTEGER*4 N, I, I1
      REAL*8 D(N,N)
      DATA I1/1/

      DO 10, I = I1, N
      D(I,I) = D(I,I) + 1.0D0
   10 CONTINUE
      RETURN
      END
C  ----------------------------------------
C  Loeschen Matrix A(N,M) auf Null,  REAL*8

      SUBROUTINE DKLARM( A, N, M )

      IMPLICIT NONE

      INTEGER*4 N, M, I, J, I1
      PARAMETER ( I1=1 )
      REAL*8 A(N,M)

      DO 10, J = I1, M
      DO 10, I = I1, N
   10 A(I,J) = 0.0D0
      RETURN
      END
C  -----------------------
C  Zuweisen Matrix B auf A
C  A(N,M) = B(N,M)

      SUBROUTINE DMOVEM( A, B, N, M )

      IMPLICIT NONE

      INTEGER*4 N, M, I, J, I1
      REAL*8 A(N,M), B(N,M)
      DATA I1/1/

      DO 10, J = I1, M
      DO 10, I = I1, N
   10 A(I,J) = B(I,J)
      RETURN
      END
C  -----------------------------------------
C  C(NA,MB) = A(NA,MA) * B(MA,MB)   (REAL*8)

      SUBROUTINE DMLTM( A, NA, MA, B, MB, C )

      IMPLICIT NONE

      INTEGER*4 NA, MA, MB, I, J, K, I1
      PARAMETER ( I1=1 )
      REAL*8 A(NA,MA), B(MA,MB), C(NA,MB)

      CALL DKLARM( C, NA, MB )

      DO 10, I = I1, NA
      DO 20, J = I1, MA
      DO 30, K = I1, MB
      C(I,K) = C(I,K) + A(I,J) * B(J,K)
   30 CONTINUE
   20 CONTINUE
   10 CONTINUE
      RETURN
      END
C  --------------------------------------
C  A == B modulo C, Dimension A, B = N, M

      SUBROUTINE UP_DMOD( A, B, C, N, M )

      IMPLICIT NONE

      INTEGER*4 N, M,   I, J
      REAL*8    A(N,M), B(N,M), C

      DO I = 1, N
      DO J = 1, M
         A(I,J) = DMOD( B(I,J), C )
      END DO
      END DO

      RETURN

      END
C  ------------------------------------------------------------
C  Bestimmen Delta ID zu Nplex - Rest R mit: (R+ID) = MP * ganz

C  ID:  Delta  ( ID wird veraendert !!! )
C  R :  Nplex - Rest  modulo P
C  MP:  Teiler von P
C  IT:  Teiler MP oder Null
C  LF:  LF = .true. wenn Teiler gefunden

      SUBROUTINE UP_IT( ID, R, IT, MP, LF )

      IMPLICIT NONE

      INTEGER*4 ID, IT, MP, I
      REAL*8    R
      LOGICAL*4 LF

      ! MP = Teiler von R
      IF( MP .LE. 1 ) THEN
         LF = .FALSE.
         ID = 0
         IT = 0
         RETURN
      ELSE IF( MP .GT. 1 ) THEN
         LF = .TRUE.
         IT =  MP
         I  =  R
         ID = -MOD( I, MP )
         IF( IABS( ID ) .GT. MP/2 ) ID = ID + MP
      END IF

      RETURN

      END
