C  File:  n1_r_op.for

C  05.03.2008

C  Autor:  G. Schnell

C  Arithmetische Operationen mit rek. Zahlen
C  Ordnung  n = 1,  Orientierung o = r
C  Dimension d = 2, 3, 4
C  Vorzeichen-Parameter y ungleich Null
C  Reduzierungs-Polynom  e = ( e0, e1, e2, e3 ) fr d=4

      IMPLICIT NONE

      INTEGER*4 d1               ! Dimensionen d = 2, 3, 4
      INTEGER*4 I1/1/
      INTEGER*4 I, IERR

      REAL*8 a(4)                ! Max. d1 = 4
      REAL*8 ai(4), aii(4)       ! 1/a, 1/(1/a)
      REAL*8 b(4)                !
      REAL*8 bi(4), bii(4)       ! 1/b, 1/(1/b)
      REAL*8 c(4)                !
      REAL*8 j(4)                ! (1, 0, ... )
      REAL*8 h(4)                !
      REAL*8 u(4)                !

      REAL*8 ma(16), mb(16)      ! Max. d1*d1 = 16
      REAL*8 mc(16)              !
      REAL*8 mai(16), mbi(16)    ! 

      REAL*8 y, e(4), e0, e1, e2, e3
      EQUIVALENCE( e(1), e0 )
      EQUIVALENCE( e(2), e1 )
      EQUIVALENCE( e(3), e2 )
      EQUIVALENCE( e(4), e3 )
      COMMON / n1_com / y, e

      CHARACTER*72 TXT

      INTEGER*4 IO_LI         ! I/O unit Liste
      INTEGER*4 IO_DAT        ! I/O unit Data
      CHARACTER*80 FILE_LI    ! Listfile
      CHARACTER*80 FILE_DAT   ! Datafile

      IO_DAT = 19   ! I/O Units setzen
      IO_LI  = 22   !

      ! Dateinamen:
      FILE_DAT = 'n1_r_op.dat'
      FILE_LI  = 'n1_r_op.ls'

      OPEN( UNIT=IO_DAT, FILE = FILE_DAT )
      OPEN( UNIT=IO_LI,  FILE = FILE_LI )

C  Daten von Datafile lesen

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! IO_DAT auf Datenzeile pos.
      READ(IO_DAT, '(A)' ) TXT          ! Text zur Aufgabe

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Dimension Zahl n1
      READ(IO_DAT, * ) d1
      IF( (d1.LT.2) .OR. (d1.GT.4) ) THEN
         WRITE(IO_LI,*) 'Laenge d1 = ', d1, ' nicht erlaubt.'
         STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Wert y zu n1
      READ(IO_DAT, * ) y

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte e zu n1
      READ(IO_DAT, * ) ( e(I), I = 1, d1 )

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte von a
      READ(IO_DAT, * ) ( a(I), I = 1, d1 )

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte von b
      READ(IO_DAT, * ) ( b(I), I = 1, d1 )

      CLOSE ( IO_DAT )


      WRITE(IO_LI,*) 'Programm: n1_r_op.exe'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Arithmetische Operationen mit rek. Zahlen'
      WRITE(IO_LI,*) 'Ordnung n=1, Orientierung o=r, Dim. d=2,3,4'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) TXT
      WRITE(IO_LI,*)
      WRITE(IO_LI,2000) d1
 2000 FORMAT('Dimension d = ',I1)
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Parameter y:'
      CALL DPUT_v( IO_LI, I1, y )
      WRITE(IO_LI,*)
      IF( d1 .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'Parameter e: ( e0, e1 )'
      ELSE IF( d1 .EQ. 3 ) THEN
         WRITE(IO_LI,*) 'Parameter e: ( e0, e1, e2 )'
      ELSE
         WRITE(IO_LI,*) 'Parameter e: ( e0, e1, e2, e3)'
      END IF
      CALL DPUT_v( IO_LI, d1, e(1) )
      WRITE(IO_LI,*)
      IF( d1 .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'a = ( a0, a1 )'
      ELSE IF( d1 .EQ. 3 ) THEN
         WRITE(IO_LI,*) 'a = ( a0, a1, a2 )'
      ELSE
         WRITE(IO_LI,*) 'a = ( a0, a1, a2, a3)'
      END IF
      CALL DPUT_v( IO_LI, d1, a(1) )
      WRITE(IO_LI,*)
      IF( d1 .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'b = ( b0, b1 )'
      ELSE IF( d1 .EQ. 3 ) THEN
         WRITE(IO_LI,*) 'b = ( b0, b1, b2 )'
      ELSE
         WRITE(IO_LI,*) 'b = ( b0, b1, b2, b3)'
      END IF
      CALL DPUT_v( IO_LI, d1, b(1) )
      WRITE(IO_LI,*)

      ! a + a = 2 (*) a
      CALL n1_add( d1, c, a, a )
      WRITE(IO_LI,*) 'a + a = 2 (*) a'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! ( 2, 0, ... ) * a
      CALL n1_one( d1, u )
      CALL n1_ska( d1, u, 2.0D0 )
      CALL n1_mlt( d1, c, u, a )
      WRITE(IO_LI,*) '( 2, 0, ... ) * a'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! a + b
      CALL n1_add( d1, c, a, b )
      WRITE(IO_LI,*) 'a + b'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! a - b
      CALL n1_sub( d1, c, a, b )
      WRITE(IO_LI,*) 'a - b'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! a * b
      CALL n1_mlt( d1, c, a, b )
      WRITE(IO_LI,*) 'a * b'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! b * a
      CALL n1_mlt( d1, c, b, a )
      WRITE(IO_LI,*) 'b * a'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! ma = m(y,e,a)
      CALL n1_gen_ma_y( d1, a, ma )
      WRITE(IO_LI,*) 'ma = m(y,e,a)'
      CALL DPUT_m( IO_LI, d1, ma )

      ! mb = m(y,e,b)
      CALL n1_gen_ma_y( d1, b, mb )
      WRITE(IO_LI,*) 'mb = m(y,e,b)'
      CALL DPUT_m( IO_LI, d1, mb )

      ! ma * mb
      CALL n1_mltm( d1, mc, ma, mb )
      WRITE(IO_LI,*) 'ma * mb'
      CALL DPUT_m( IO_LI, d1, mc )

      ! mb * ma
      CALL n1_mltm( d1, mc, mb, ma )
      WRITE(IO_LI,*) 'mb * ma'
      CALL DPUT_m( IO_LI, d1, mc )

      ! Inverse mai von ma
      CALL n1_inv( d1, ma, mai, IERR )
      WRITE(IO_LI,*) 'mai = ma^(-1), ma*mai=E'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_m( IO_LI, d1, mai )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF

      ! Inverse mbi von mb
      CALL n1_inv( d1, mb, mbi, IERR )
      WRITE(IO_LI,*) 'mbi = mb^(-1), mb*mbi=E'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_m( IO_LI, d1, mbi )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF

      ! 1/a * a = mai * a  ( f/j )
      CALL n1_div( d1, c, a, a, IERR )
      WRITE(IO_LI,*) '1/a * a = mai * a  ( f/j )'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, c(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! 1/b * b = mbi * b  ( f/j )
      CALL n1_div( d1, c, b, b, IERR )
      WRITE(IO_LI,*) '1/b * b = mbi * b  ( f/j )'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, c(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! j = ( 1, 0, ... )
      CALL n1_one( d1, j )
      WRITE(IO_LI,*) 'j = ( 1, 0, ... )'
      CALL DPUT_v( IO_LI, d1, j(1) )
      WRITE(IO_LI,*)

      ! ai = 1/a * j = mai * j
      CALL n1_div( d1, ai, j, a, IERR)
      WRITE(IO_LI,*) 'ai = 1/a * j = mai * j'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, ai(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! aii = 1/ai * j = a
      CALL n1_div( d1, aii, j, ai, IERR)
      WRITE(IO_LI,*) 'aii = 1/ai * a = a'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, aii(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! bi = 1/b * j = mbi * j
      CALL n1_div( d1, bi, j, b, IERR)
      WRITE(IO_LI,*) 'bi = 1/b *j = mbi * j'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, bi(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! bii = 1/bi * j
      CALL n1_div( d1, bii, j, bi, IERR)
      WRITE(IO_LI,*) 'bii = 1/bi * b = b'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, bii(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! 1/a * j * a 
      CALL n1_div( d1, ai, j, a, IERR)
      CALL n1_mlt( d1, c, ai, a )
      WRITE(IO_LI,*) '1/a * j * a = j'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, c(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! 1/b * a * b = a
      CALL n1_mlt( d1, h, a, b )
      CALL n1_div( d1, c, h, b, IERR )
      WRITE(IO_LI,*) '1/b * a * b = a'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, c(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! sqrt( a )
      WRITE(IO_LI,*) 'c = sqrt( a )'
      CALL n1_sqr( d1, c, a, iERR )
      IF( (iERR .GT. 0) .AND. (iERR .LT. 10 ) ) THEN
         WRITE(IO_LI,*) 'Divisions-Fehler in n1_sqr(a)'
         WRITE(IO_LI,*) 'iERR = ', iERR
      ELSE
         IF( iERR .NE. 0 ) THEN
            WRITE(IO_LI,*) 'Achtung max. Anzahl Iterationen erreicht'
            WRITE(IO_LI,*) 'iERR = ', iERR
         END IF
         CALL DPUT_v( IO_LI, d1, c )
         WRITE(IO_LI,*) 'Probe: c*c = a ?'
         CALL n1_mlt( d1, u, c, c )
         CALL DPUT_v( IO_LI, d1, u )
         WRITE(IO_LI,*) 'Delta: a - c*c'
         CALL n1_sub( d1, h, a, u )
         CALL DPUT_v( IO_LI, d1, h )
      END IF
      WRITE(IO_LI,*)

      ! sqrt( b )
      WRITE(IO_LI,*) 'c = sqrt( b )'
      CALL n1_sqr( d1, c, b, iERR )
      IF( (iERR .GT. 0) .AND. (iERR .LT. 10 ) ) THEN
         WRITE(IO_LI,*) 'Divisions-Fehler in n1_sqr(b)'
         WRITE(IO_LI,*) 'iERR = ', iERR
      ELSE
         IF( iERR .NE. 0 ) THEN
            WRITE(IO_LI,*) 'Achtung max. Anzahl Iterationen erreicht'
            WRITE(IO_LI,*) 'iERR = ', iERR
         END IF
         CALL DPUT_v( IO_LI, d1, c )
         WRITE(IO_LI,*) 'Probe: c*c = b ?'
         CALL n1_mlt( d1, u, c, c )
         CALL DPUT_v( IO_LI, d1, u )
         WRITE(IO_LI,*) 'Delta: b - c*c'
         CALL n1_sub( d1, h, b, u )
         CALL DPUT_v( IO_LI, d1, h )
      END IF
      WRITE(IO_LI,*)

      CLOSE ( IO_LI )

      STOP

      END
C  ---------------------------------------------------
C  FILE_DAT = 'n1_r_op.dat' fuers Lesen positionieren
C  und Kommentar- und Leer-Zeilen ueberlesen.

      SUBROUTINE UP_IN_POS( IO_IN, IO_LI )

      IMPLICIT NONE

      INTEGER*4 IO_IN, IO_LI, I
      CHARACTER*136 REC

   10 READ( IO_IN, '(A)', ERR=800, END=900 ) REC
      IF( REC(1:1) .EQ. '!' ) GO TO 10   ! Kommentarzeile ueberlesen
      DO 20, I = 1, 136
         IF( REC(I:I) .NE. ' ' ) THEN
            BACKSPACE IO_IN
            RETURN                       ! Datenzeile gefunden
         END IF
   20 CONTINUE
      GO TO 10                           ! Leerzeile ueberlesen

  800 WRITE( IO_LI, * ) 'Error beim Lesen von n1_r_op.dat'
      STOP

  900 WRITE( IO_LI, * ) 'EOF erreicht beim Lesen von n1_r_op.dat'
      STOP
      END
C  =====================================
C  ma(d1,d1) drucken

      SUBROUTINE DPUT_m( IO_LI, d1, ma )

      IMPLICIT NONE

      INTEGER*4 IO_LI, d1, I, J
      REAL*8 ma(d1, d1)

      DO I = 1, d1
         WRITE(IO_LI,1000) (ma(I,J), J=1,d1)
      END DO
      WRITE(IO_LI,*)

      RETURN

 1000 FORMAT(1X,4(1P,D14.6))

      END
C  ====================================
C  a(d1) drucken

      SUBROUTINE DPUT_v( IO_LI, d1, a )

      IMPLICIT NONE

      INTEGER*4 IO_LI, d1, I
      REAL*8 a(d1)

      WRITE(IO_LI,1000) (a(I), I=1,d1)

      RETURN

 1000 FORMAT(1X,4(1P,D14.6))

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = 0 = ( 0, 0, ... )

      SUBROUTINE n1_zero( d1, a )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1)

      DO I = 1, d1
         a(I) = 0.0D0
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = 1 = j = ( 1, 0, ... )

      SUBROUTINE n1_one( d1, a )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1)

      a(1) = 1.0D0
      DO I = 2, d1
         a(I) = 0.0D0
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = s * a      s ist ein Skalar

      SUBROUTINE n1_ska( d1, a, s )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1), s

      DO I = 1, d1
         a(I) = a(I) * s
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = b

      SUBROUTINE n1_move( d1, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1), b(d1)

      DO I = 1, d1
         a(I) = b(I)
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a + b

      SUBROUTINE n1_add( d1, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 c(d1), a(d1), b(d1)

      DO I = 1, d1
         c(I) = a(I) + b(i)
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a - b

      SUBROUTINE n1_sub( d1, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 c(d1), a(d1), b(d1)

      DO I = 1, d1
         c(I) = a(I) - b(i)
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  ma aus a    mit y

      SUBROUTINE n1_gen_ma_y( d1, a, ma )

      IMPLICIT NONE

      INTEGER*4 d1
      REAL*8 a(d1), ma(d1,d1), y2, y3

      REAL*8 y, e(4), e0, e1, e2, e3
      EQUIVALENCE( e(1), e0 )
      EQUIVALENCE( e(2), e1 )
      EQUIVALENCE( e(3), e2 )
      EQUIVALENCE( e(4), e3 )
      COMMON / n1_com / y, e

      REAL*8 a0, a1, a2, a3

      IF( d1 .EQ. 2 ) THEN
         ma(1,1) =  a(1)
         ma(1,2) = -a(2) * e0
         ma(2,1) =  y * a(2)
         ma(2,2) =  y * ( a(1) - a(2)*e1 )
      ELSE IF( d1 .EQ. 3 ) THEN
         y2 = y*y
         ma(1,1) =  a(1)
         ma(1,2) = -a(3)*e0
         ma(1,3) = -a(2)*e0 + a(3)*e0*e2
         ma(2,1) =  y * a(2)
         ma(2,2) =  y * ( a(1) - a(3)*e1 )
         ma(2,3) =  y * (-a(2)*e1 - a(3)*e0 + a(3)*e1*e2 )
         ma(3,1) =  y2 * a(3)
         ma(3,2) =  y2 * ( a(2) - a(3)*e2 )
         ma(3,3) =  y2 * ( a(1) - a(2)*e2 + a(3)*e2*e2 )
      ELSE IF( d1 .EQ. 4 ) THEN
         y2 = y*y
         y3 = y*y*y
         a0 = a(1)
         a1 = a(2)
         a2 = a(3)
         a3 = a(4)
         ma(1,1) =  a0
         ma(1,2) = -a3*e0
         ma(1,3) = -a2*e0 + a3*e0*e3
         ma(1,4) = -a1*e0 + a2*e0*e3 + a3*e2*e0
     +             -a3*e3*e3*e0
         ma(2,1) = y * ( a1 )
         ma(2,2) = y * ( a0 - a3*e1 )
         ma(2,3) = y * ( -a2*e1 + a3*(e3*e1-e0) )
         ma(2,4) = y * ( -a1*e1 + a2*(e3*e1-e0) + a3*e2*e1
     +             -a3*e3*(e3*e1-e0) )
         ma(3,1) = y2 * ( a2 )
         ma(3,2) = y2 * ( a1 - a3*e2 )
         ma(3,3) = y2 * ( a0 - a2*e2 + a3*(e3*e2-e1) )
         ma(3,4) = y2 * ( -a1*e2 + a2*(e3*e2-e1) - a3*e0
     +             +a3*e2*e2 - a3*e3*(e3*e2-e1) )
         ma(4,1) = y3 * ( a3 )
         ma(4,2) = y3 * ( a2 - a3*e3 )
         ma(4,3) = y3 * ( a1 - a2*e3 + a3*(e3*e3-e2) )
         ma(4,4) = y3 * ( a0 - a1*e3 + a2*(e3*e3-e2) - a3*e1
     +             +a3*e2*e3 - a3*e3*(e3*e3-e2) )
      END IF

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a * b

      SUBROUTINE n1_mlt( d1, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1
      REAL*8 c(d1), a(d1), b(d1)
      REAL*8 ma(16)       ! 16 = 4*4 = Maximum

      CALL n1_gen_ma_y( d1, a, ma )   ! ma aus a
      CALL n1_ma_v( d1, c, ma, b )    ! c = ma * b

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a / b
C  IERR = 0 = okay,  IERR > 0 = Fehler

      SUBROUTINE n1_div( d1, c, a, b, IERR )

      IMPLICIT NONE

      INTEGER*4 d1, IERR
      REAL*8 c(d1), a(d1), b(d1)
      REAL*8 mb(16), mi(16)              ! 4*4 = Maximum

      CALL n1_gen_ma_y( d1, b, mb )      ! mb aus b
      CALL n1_inv( d1, mb, mi, IERR )    ! mi = mb^(-1)
      CALL n1_ma_v( d1, c, mi, a )       ! c = mi * a

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = ma * b

      SUBROUTINE n1_ma_v( d1, c, ma, b )

      IMPLICIT NONE

      INTEGER*4 d1
      REAL*8 c(d1), ma(d1,d1), b(d1)

      IF( d1 .EQ. 2 ) THEN
         c(1) = ma(1,1)*b(1) + ma(1,2)*b(2)
         c(2) = ma(2,1)*b(1) + ma(2,2)*b(2)
      ELSE IF( d1 .EQ. 3 ) THEN
         c(1) = ma(1,1)*b(1) + ma(1,2)*b(2) + ma(1,3)*b(3)
         c(2) = ma(2,1)*b(1) + ma(2,2)*b(2) + ma(2,3)*b(3)
         c(3) = ma(3,1)*b(1) + ma(3,2)*b(2) + ma(3,3)*b(3)
      ELSE IF( d1 .EQ. 4 ) THEN
         c(1) = ma(1,1)*b(1) + ma(1,2)*b(2) + ma(1,3)*b(3)
     +        + ma(1,4)*b(4)
         c(2) = ma(2,1)*b(1) + ma(2,2)*b(2) + ma(2,3)*b(3)
     +        + ma(2,4)*b(4)
         c(3) = ma(3,1)*b(1) + ma(3,2)*b(2) + ma(3,3)*b(3)
     +        + ma(3,4)*b(4)
         c(4) = ma(4,1)*b(1) + ma(4,2)*b(2) + ma(4,3)*b(3)
     +        + ma(4,4)*b(4)
      END IF

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  Inverse von ma -> mi
C  IERR = 0 = okay, IERR > 0 = Fehler

      SUBROUTINE n1_inv( d1, ma, mi, IERR )

      IMPLICIT NONE

      INTEGER*4 d1, IERR
      REAL*8 ma(d1,d1), mi(d1,d1)

      INTEGER*4 I, J
      REAL*8 EPS/ 1.0D-14 /   ! Schranke Determinante
      REAL*8 Det, Det1, Det2, Det3

      REAL*8 A(4,4), B(4,4), D(4)   ! fuer d1 = 4

      IF( d1 .EQ. 2 ) THEN
         ! Sarrus / Cramer
         Det = ma(1,1)*ma(2,2) - ma(1,2)*ma(2,1)
         IF( DABS(Det) .GT. EPS ) THEN
            IERR = 0
            mi(1,1) =  ma(2,2) / Det
            mi(2,1) = -ma(2,1) / Det
            mi(1,2) = -ma(1,2) / Det
            mi(2,2) =  ma(1,1) / Det
         ELSE
            IERR = 2
            mi(1,1) = 0.0D0
            mi(1,2) = 0.0D0
            mi(2,1) = 0.0D0
            mi(2,2) = 0.0D0
         END IF
      ELSE IF( d1 .EQ. 3 ) THEN
         ! Sarrus / Cramer
         Det = ma(1,1)*ma(2,2)*ma(3,3) + ma(1,2)*ma(2,3)*ma(3,1)
     &       + ma(1,3)*ma(2,1)*ma(3,2) - ma(1,3)*ma(2,2)*ma(3,1)
     &       - ma(1,1)*ma(2,3)*ma(3,2) - ma(1,2)*ma(2,1)*ma(3,3)
         IF( DABS(Det) .GT. EPS ) THEN
            IERR = 0
            Det1 = ma(2,2)*ma(3,3) - ma(2,3)*ma(3,2)
            Det2 = ma(2,3)*ma(3,1) - ma(2,1)*ma(3,3)
            Det3 = ma(2,1)*ma(3,2) - ma(2,2)*ma(3,1)
            mi(1,1) = Det1 / Det
            mi(2,1) = Det2 / Det
            mi(3,1) = Det3 / Det
            Det1 = ma(1,3)*ma(3,2) - ma(1,2)*ma(3,3)
            Det2 = ma(1,1)*ma(3,3) - ma(1,3)*ma(3,1)
            Det3 = ma(1,2)*ma(3,1) - ma(1,1)*ma(3,2)
            mi(1,2) = Det1 / Det
            mi(2,2) = Det2 / Det
            mi(3,2) = Det3 / Det
            Det1 = ma(1,2)*ma(2,3) - ma(1,3)*ma(2,2)
            Det2 = ma(1,3)*ma(2,1) - ma(1,1)*ma(2,3)
            Det3 = ma(1,1)*ma(2,2) - ma(1,2)*ma(2,1)
            mi(1,3) = Det1 / Det
            mi(2,3) = Det2 / Det
            mi(3,3) = Det3 / Det
         ELSE
            IERR = 3
            DO I = 1, 3
            DO J = 1, 3
               mi(I,J) = 0.0D0
            END DO
            END DO
         END IF
      ELSE IF( d1 .EQ. 4 ) THEN
         DO I = 1, 4        ! B = E
         DO J = 1, 4        !
            B(I,J) = 0.0D0  !
         END DO             !
         END DO             !
         B(1,1) = 1.0D0     !
         B(2,2) = 1.0D0     !
         B(3,3) = 1.0D0     !
         B(4,4) = 1.0D0     !

         ! mi = ma^(-1)  nach Householder
         ! A = ma    ( A wird zerstoert !!! )
         DO I = 1, 4           ! A = ma
         DO J = 1, 4           !
            A(I,J) = ma(I,J)   !
         END DO                !
         END DO                !
         CALL UP_HOUSE( A, B, mi, D, d1, d1, IERR )
         IF( IERR .NE. 0 ) THEN
         DO I = 1, 4        ! mi = 0
         DO J = 1, 4        !
           mi(I,J) = 0.0D0  !
         END DO             !
         END DO             !
         END IF
      ELSE
         IERR = 5
      END IF

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  mc = ma * mb

      SUBROUTINE n1_mltm( d1, mc, ma, mb )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 mc(d1,d1), ma(d1,d1), mb(d1,d1)

      DO I = 1, d1

         CALL n1_ma_v( d1, mc(1,I), ma, mb(1,I) )

      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  b = sqrt( a )  babylonisches Verfahren
C  b = a^(1/r)    fuer n1_sqr ist r=2
C  N1 ist 1. Naeherung   z. B.: N1 = ( 1, 1, 1 )
C  N2 = [ (r-1)*N1 + a / N1^(r-1) ] / r
C  iERR = 0 = kein Fehler

      SUBROUTINE n1_sqr( d1, b, a, iERR )

      IMPLICIT NONE

      INTEGER*4 d1, iERR
      REAL*8 b(d1), a(d1)

      LOGICAL*4 L
      INTEGER*4 I, IZ, IMAX/ 100 /
      REAL*8 N1(4), N2(4), Q(4), F/0.5D0/
      REAL*8 Sa, Sd, P(4), D(4), EPS/ 1.0D-15 /

      ! Pruefen ob a = 0
      DO I = 1, d1
         IF( a(I) .NE. 0.0D0 ) GO TO 10
      END DO
      CALL n1_zero( d1, b )   ! b = 0
      iERR = 0
      RETURN

   10 CONTINUE

      CALL n1_zero( d1, b )               ! Naeherung N1
      b(1)  =  0.5D0                      ! b = ( .5, .. )
      b(d1) = -0.5D0                      ! b = ( .5, ...,-.5 )
      CALL n1_div( d1, N1, a, b, iERR )   ! N1 = a / b

      IZ = 0
      ! Abbruchkriterium Teil 1,  abs. Norm
      Sa = 0.0D0
      DO I = 1, d1
         Sa = Sa + DABS( a(I) )
      END DO

      L = .FALSE.

  100 CALL n1_div( d1, Q, a, N1, iERR )   ! Q = a / N1
      IF( iERR .NE. 0 ) THEN
         CALL n1_zero( d1, b )            ! b = 0
         RETURN
      END IF
      CALL n1_add( d1, N2, N1, Q )        ! N2 = N1 + Q
      CALL n1_ska( d1, N2, F )            ! N2 = N2 * 0.5

      IZ = IZ + 1
      ! Abbruchkriterium ab 10 Iterationen
      IF( IZ .GT. 10 ) THEN
         CALL n1_mlt( d1, P, N2, N2 )        ! P = N2 * N2 ==> a
         CALL n1_sub( d1, D, a, P )          ! D = a - P
         Sd = 0.0D0
         DO I = 1, d1
            Sd = Sd + DABS( D(I) )
         END DO
         IF( Sd / Sa .LT. EPS ) L = .TRUE.
         IF( L ) THEN       ! Iteration steht
            CALL n1_move( d1, b, N2 )
            iERR = 0
            RETURN
         END IF
      END IF

      IF( IZ .LT. IMAX ) THEN
         CALL n1_move( d1, N1, N2 )   ! N1 = N2
         GO TO 100
      END IF

      ! max. Anzahl Iterationen ueberschritten
      iERR = IMAX
      CALL n1_move( d1, b, N2 )   ! b = N2
      RETURN

      END
C  =================================================
C  Loesung des linearen Gleichungssystems AX = B mit
C  der Householder-Transformation

C  -------   Die Matrix A wird zerstoert !!!   -----

C  M        : Zeilen-Dimension von A, B, X, D
C  L        : Spalten-Dimension von B, X
C  A(M,M)   : A nur quadratisch
C  B(M,L)   : L rechte Seiten
C  X(M,L)   : L Loesungsvektoren
C  D(M  )   : Hilfsvektor
C  IER      : 0 = okay, 1 = A ist singulaer

      SUBROUTINE UP_HOUSE( A , B , X, D, M, L, IER )

      IMPLICIT NONE

      INTEGER*4 M, L, IER

      REAL*8 A(M,M), b(M,L), x(M,L), D(M)

      INTEGER I , J , K , LL
      REAL*8  DBETA , DSIGMA , DSUM

C  Fehlerargument auf fehlerfrei setzen !

      IER = 0

C  QR-Zerlegung der Matrix A nach Householder

      DO 100, J = 1 , M

C  Euklidische Norm der j-ten Spalte

         DSIGMA = 0.0D0
         DO I = J , M
            DSIGMA = DSIGMA + A(I,J) * A(I,J)
         END DO

         !  A singulaer ?
         IF ( DSIGMA .EQ. 0.0D0 ) THEN
            IER = 1
            GOTO 9999      ! ja, Fehler
         END IF

         D(J)   = -DSQRT( DSIGMA ) * DSIGN( 1.0D0, A(J,J) )

         DBETA  = 1.0D0 / ( D(J)*A(J,J)-DSIGMA )
 
         A(J,J) = A(J,J) - D(J)

         DO K = J+1 , M

            DSUM = 0.0D0
            DO I = J , M
               DSUM = DSUM + A(I,J) * A(I,K)
            END DO

            DSUM = DBETA * DSUM

            DO I = J , M
               A(I,K) = A(I,K) + A(I,J) * DSUM
            END DO

         END DO

         DO LL = 1, L   ! L rechte Seiten

            DSUM = 0.0D0
            DO I = J , M
               DSUM = DSUM + A(I,J) * B(I,LL)
            END DO

            DSUM = DSUM * DBETA

            DO I = J , M
               B(I,LL) = B(I,LL) + A(I,J) * DSUM
            END DO

         END DO

  100 CONTINUE

C  Loesung durch Rueckwaertselimination

      DO LL = 1, L   ! L rechte Seiten

         DO J = M , 1 , -1
            DSUM = 0.0D0
            DO I = J+1 , M
               DSUM = DSUM + A(J,I) * X(I,LL)
            END DO
            X(J,LL) = ( B(J,LL) - DSUM ) / D(J)
         END DO

      END DO

 9999 CONTINUE

      RETURN

      END
