C  File:  n1_r_sinh.for

C  Autor:  G. Schnell

C  23.09.2007

C  Berechnen sinh( a ) und cosh( a ), a ist rek. Zahl
C  Dimension NPL = d = 1 bis 3
C  Parameter sind: y, e0, e1, e2.

      IMPLICIT NONE

      REAL*8 dY                  ! zu: -e * y^-d

      INTEGER*4 NPL, NPL_MAX, J
      PARAMETER ( NPL_MAX =  3 )
      REAL*8 A0, A1, A2
      REAL*8 Fa0( 3 ), Fa1( 3 ), Fa2( 3 )
      REAL*8 Fa( NPL_MAX ), Fe( NPL_MAX ), Fc( NPL_MAX )

      CHARACTER*72 TXT

      CHARACTER*(*) FMT1
      PARAMETER ( FMT1 = '(1X,1P,5E14.6)' )

      INTEGER*4 IO_LI         ! I/O unit Liste
      INTEGER*4 IO_DAT        ! I/O unit Data
      CHARACTER*80 FILE_LI    ! Listfile
      CHARACTER*80 FILE_DAT   ! Datafile


      IO_DAT = 19   ! I/O Units setzen
      IO_LI  = 22   !

      ! Dateinamen:
      FILE_DAT = 'n1_r_sinh.dat'
      FILE_LI  = 'n1_r_sinh.ls'

      OPEN( UNIT=IO_DAT, FILE = FILE_DAT )
      OPEN( UNIT=IO_LI,  FILE = FILE_LI )

C  Daten von Datafile lesen

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! IO_DAT auf Datenzeile pos.
      READ(IO_DAT, '(A)' ) TXT          ! Text zur Aufgabe

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Laenge Nplex
      READ(IO_DAT, * ) NPL
      IF( (NPL.LT.1) .OR. (NPL.GT.NPL_MAX) ) THEN
         WRITE(IO_LI,*) 'Laenge Nplex = ', NPL, ' nicht erlaubt.'
         STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Wert y von: -e * y^-d
      READ(IO_DAT, * ) dY
      IF( ( dY .EQ. 0.0D0 ) .OR. ( DABS(dY).GT. 1000.0D0 ) ) THEN
         WRITE(IO_LI,*) 'y = ', dY, ' nicht erlaubt.'
         STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte der Parameter zu e
      READ(IO_DAT, * ) ( Fe(J), J = 1, NPL )
      DO J = 1, NPL
         IF( DABS( Fe(J) ).GT. 1000.0D0 ) THEN
            WRITE(IO_LI,*) 'Fe(.) = ', Fe(J), ' nicht erlaubt.'
            STOP
         END IF
      END DO

      IF( NPL .EQ. 1 ) THEN
         CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte zu a0 des Nplex
         READ(IO_DAT,*) ( Fa0(J),J=1,3 )   ! Anfang, Ende, Delta
      ELSE IF( NPL .EQ. 2 ) THEN
         CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte zu a0 des Nplex
         READ(IO_DAT,*) ( Fa0(J),J=1,3 )   ! Anfang, Ende, Delta
         CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte zu a1 des Nplex
         READ(IO_DAT,*) ( Fa1(J),J=1,3 )   ! Anfang, Ende, Delta
      ELSE IF( NPL .EQ. 3 ) THEN
         CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte zu a0 des Nplex
         READ(IO_DAT,*) ( Fa0(J),J=1,3 )   ! Anfang, Ende, Delta
         CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte zu a1 des Nplex
         READ(IO_DAT,*) ( Fa1(J),J=1,3 )   ! Anfang, Ende, Delta
         CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte zu a2 des Nplex
         READ(IO_DAT,*) ( Fa2(J),J=1,3 )   ! Anfang, Ende, Delta
      END IF

      CLOSE ( IO_DAT )


      WRITE(IO_LI,*) 'Programm: n1_r_sinh.exe'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Sinh- und Cosh-Funktion mit'
      WRITE(IO_LI,*) 'rekursivem Argument a'  
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) TXT
      WRITE(IO_LI,*)
      WRITE(IO_LI,2000) NPL
 2000 FORMAT('Dimension d des N-Plex = ',I1)
      WRITE(IO_LI,*)
      WRITE(IO_LI,2010) dY
 2010 FORMAT('Parameter y = ',1P,D14.7)
      WRITE(IO_LI,*)
      IF( NPL .EQ. 1 ) THEN
         WRITE(IO_LI,*) 'Parameter e: ( e0 )'
      ELSE IF( NPL .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'Parameter e: ( e0, e1 )'
      ELSE IF( NPL .EQ. 3 ) THEN
         WRITE(IO_LI,*) 'Parameter e: ( e0, e1, e2 )'
      END IF
      CALL DPUT( Fe(1), IO_LI, FMT1, 1, NPL, 0, 0 )
      WRITE(IO_LI,*)
      IF( NPL .EQ. 1 ) THEN
         WRITE(IO_LI,*) 'Werte a0: ( Anfang, Ende, Delta )'
         CALL DPUT( Fa0(1), IO_LI, FMT1, 1, 3, 0, 0 )
         WRITE(IO_LI,*)
      ELSE IF( NPL .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'Werte a0: ( Anfang, Ende, Delta )'
         CALL DPUT( Fa0(1), IO_LI, FMT1, 1, 3, 0, 0 )
         WRITE(IO_LI,*)
         WRITE(IO_LI,*) 'Werte a1: ( Anfang, Ende, Delta )'
         CALL DPUT( Fa1(1), IO_LI, FMT1, 1, 3, 0, 0 )
         WRITE(IO_LI,*)
      ELSE IF( NPL .EQ. 3 ) THEN
         WRITE(IO_LI,*) 'Werte a0: ( Anfang, Ende, Delta )'
         CALL DPUT( Fa0(1), IO_LI, FMT1, 1, 3, 0, 0 )
         WRITE(IO_LI,*)
         WRITE(IO_LI,*) 'Werte a1: ( Anfang, Ende, Delta )'
         CALL DPUT( Fa1(1), IO_LI, FMT1, 1, 3, 0, 0 )
         WRITE(IO_LI,*)
         WRITE(IO_LI,*) 'Werte a2: ( Anfang, Ende, Delta )'
         CALL DPUT( Fa2(1), IO_LI, FMT1, 1, 3, 0, 0 )
         WRITE(IO_LI,*)
      END IF

      ! Nplex-Matrix MA erstellen
!     CALL GEN_MA( NPL, Fa, MA, dY, Fe )

      ! Nplex-Matrix
!     WRITE(IO_LI,*) 'Nplex-Matrix:'
!     CALL DPUT( MA, IO_LI, FMT1, NPL, NPL, 0, 1 )

      IF( NPL .EQ. 1 ) THEN
         WRITE(IO_LI,*) 'Ergebnis: a, sinh(a), cosh(a)'
         DO A0 = Fa0(1), Fa0(2)+Fa0(3)/2, Fa0(3)
            Fa(1) = A0
            CALL DPUT( Fa(1), IO_LI, FMT1, 1, NPL, 0, 0 )
            CALL NPLEX_SINH( NPL, Fa, Fc, dY, Fe, IO_LI)
            CALL DPUT( Fc(1), IO_LI, FMT1, 1, NPL, 0, 0 )
            CALL NPLEX_COSH( NPL, Fa, Fc, dY, Fe, IO_LI)
            CALL DPUT( Fc(1), IO_LI, FMT1, 1, NPL, 0, 1 )
         END DO
      ELSE IF( NPL .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'Ergebnis: a, sinh(a), cosh(a)'
         DO A0 = Fa0(1), Fa0(2)+Fa0(3)/2, Fa0(3)
         DO A1 = Fa1(1), Fa1(2)+Fa1(3)/2, Fa1(3)
            Fa(1) = A0
            Fa(2) = A1
            CALL DPUT( Fa(1), IO_LI, FMT1, 1, NPL, 0, 0 )
            CALL NPLEX_SINH( NPL, Fa, Fc, dY, Fe, IO_LI)
            CALL DPUT( Fc(1), IO_LI, FMT1, 1, NPL, 0, 0 )
            CALL NPLEX_COSH( NPL, Fa, Fc, dY, Fe, IO_LI)
            CALL DPUT( Fc(1), IO_LI, FMT1, 1, NPL, 0, 1 )
         END DO
         END DO
      ELSE IF( NPL .EQ. 3 ) THEN
         WRITE(IO_LI,*) 'Ergebnis: a, sinh(a), cosh(a)'
         DO A0 = Fa0(1), Fa0(2)+Fa0(3)/2, Fa0(3)
         DO A1 = Fa1(1), Fa1(2)+Fa1(3)/2, Fa1(3)
         DO A2 = Fa2(1), Fa2(2)+Fa2(3)/2, Fa2(3)
            Fa(1) = A0
            Fa(2) = A1
            Fa(3) = A2
            CALL DPUT( Fa(1), IO_LI, FMT1, 1, NPL, 0, 0 )
            CALL NPLEX_SINH( NPL, Fa, Fc, dY, Fe, IO_LI)
            CALL DPUT( Fc(1), IO_LI, FMT1, 1, NPL, 0, 0 )
            CALL NPLEX_COSH( NPL, Fa, Fc, dY, Fe, IO_LI)
            CALL DPUT( Fc(1), IO_LI, FMT1, 1, NPL, 0, 1 )
         END DO
         END DO
         END DO
      END IF

      CLOSE ( IO_LI )

      STOP

      END
C  ----------------------------------------------------
C  FILE_DAT = 'n1_r_sinh.dat' fuers Lesen positionieren
C  und Kommentar- und Leer-Zeilen ueberlesen.

      SUBROUTINE UP_IN_POS( IO_IN, IO_LI )

      IMPLICIT NONE

      INTEGER*4 IO_IN, IO_LI, I
      CHARACTER*136 REC

   10 READ( IO_IN, '(A)', ERR=800, END=900 ) REC
      IF( REC(1:1) .EQ. '!' ) GO TO 10   ! Kommentarzeile ueberlesen
      DO 20, I = 1, 136
         IF( REC(I:I) .NE. ' ' ) THEN
            BACKSPACE IO_IN
            RETURN                       ! Datenzeile gefunden
         END IF
   20 CONTINUE
      GO TO 10                           ! Leerzeile ueberlesen

  800 WRITE( IO_LI, * ) 'Error beim Lesen von n1_r_sinh.dat'
      STOP

  900 WRITE( IO_LI, * ) 'EOF erreicht beim Lesen von n1_r_sinh.dat'
      STOP
      END
C  ---------- DPUT ---------------------------
C  Drucken Matrix oder Vektor FD[M,N],  Real*8
C  FD    = Matrix[M,N]
C  IOU   = Output-Unit
C  IVOR  = Anzahl Leer-Zeilen vor dem Drucken
C  INACH = Anzahl Leer-Zeilen nach dem Drucken
C  HFORM = Vektor der das Druck-Format enthaelt

      SUBROUTINE DPUT( FD, IOU, HFORM, M, N, IVOR, INACH )

      IMPLICIT NONE

      INTEGER*4 IOU
      INTEGER*4 N, M, IVOR, INACH, I, J
      REAL*8 FD(M,N)
      CHARACTER*(*) HFORM

      IF( IVOR .LE. 0 ) GO TO 9

      DO 5, I = 1, IVOR
         WRITE(IOU,2000)
    5 CONTINUE

    9 CONTINUE

      DO 10, I = 1, M
       WRITE(IOU,HFORM) ( FD(I,J), J = 1, N )
   10 CONTINUE

      IF( INACH .LE. 0 ) RETURN

      DO 15, I = 1, INACH
         WRITE(IOU,2000)
   15 CONTINUE

      RETURN

 2000 FORMAT(2H  )
      END
C  ---------------------------------------------------
C  Berechnen Sinus-hyperbolicus-funktion eines Nplex a

C  sinh( a ) = a^1 / 1! + a^3 / 3! + a^5 / 5! + ...

      SUBROUTINE NPLEX_SINH( NPL, Fa, Fc, Y, Fe, IO_LI)

      IMPLICIT NONE

      INTEGER*4 NPL, IO_LI
      REAL*8 Fa(NPL), Fc(NPL), Fe(NPL), Y

      INTEGER*4 NPL_MAX
      PARAMETER ( NPL_MAX = 3 )

      REAL*8 MA ( NPL_MAX, NPL_MAX )
      REAL*8 MA2( NPL_MAX, NPL_MAX )
      REAL*8 Fb ( NPL_MAX ), DI, DI1
      REAL*8 Fz ( NPL_MAX ), Fb_alt( NPL_MAX )

      INTEGER*4 I, J
      LOGICAL*4 LOKAY

      ! Nplex-Matrix MA erstellen
      CALL GEN_MA( NPL, Fa, MA, Y, Fe )
      CALL DMLTM( MA, NPL, NPL, MA, NPL, MA2 )   ! MA2 = MA^2

      ! Fc = a, Fz = a,  Fb_alt = 0
      DO I = 1, NPL
         Fc(I) = Fa(I)
         Fz(I) = Fa(I)
         Fb_alt(I) = 0.0D0
      END DO

      DO I = 3, 101, 2   ! 50 Reihenglieder
         DI  = I
         DI1 = DI - 1.0D0
         CALL MLT_M_V( NPL, MA2, Fz, Fb )   ! Fb = MA^2 * Fz
         LOKAY = .TRUE.
         DO J = 1, NPL
            Fz(J) = Fb(J) / DI / DI1
            Fc(J) = Fc(J) + Fz(J)
            IF( Fc(J) .NE. Fb_alt(J) ) LOKAY = .FALSE.
            Fb_alt(J) = Fc(J)
         END DO
         IF( LOKAY ) GO TO 100   ! Ergebnis steht
      END DO
         ! Ergebnis nicht korrekt !
         WRITE(IO_LI,*) 'Sinh nicht korrekt nach 50 Schritten.'

  100 CONTINUE

      RETURN

      END
C  -----------------------------------------------------
C  Berechnen Cosinus-hyperbolicus-funktion eines Nplex a

C  cosh( a ) = 1 + a^2 / 2! + a^4 / 4! + a^6 / 6! + ...

      SUBROUTINE NPLEX_COSH( NPL, Fa, Fc, Y, Fe, IO_LI)

      IMPLICIT NONE

      INTEGER*4 NPL, IO_LI
      REAL*8 Fa(NPL), Fc(NPL),  Fe(NPL), Y

      INTEGER*4 NPL_MAX
      PARAMETER ( NPL_MAX = 3 )

      REAL*8 MA ( NPL_MAX, NPL_MAX )
      REAL*8 MA2( NPL_MAX, NPL_MAX )
      REAL*8 Fb ( NPL_MAX ), DI, DI1
      REAL*8 Fz ( NPL_MAX ), Fb_alt( NPL_MAX )

      INTEGER*4 I, J
      LOGICAL*4 LOKAY

      ! Nplex-Matrix MA erstellen
      CALL GEN_MA( NPL, Fa, MA, Y, Fe )
      CALL DMLTM( MA, NPL, NPL, MA, NPL, MA2 )   ! MA2 = MA^2

      ! Fc = 1, Fb_alt = 0
      DO I = 1, NPL
         Fc(I) = 0.0D0
         Fb_alt(I) = 0.0D0
      END DO
      Fc(1) = 1.0D0   ! 1 aus Cosh-Reihe

      ! Fuer Fz = x^2/2  aus Cosh-Reihe
      CALL MLT_M_V( NPL, MA, Fa, Fz )

      DI = 2.0D0   ! = 2!
      DO J = 1, NPL
         Fz( J ) = Fz( J ) / DI
         Fc( J ) = Fc( J ) + Fz( J )
      END DO

      DO I = 4, 100, 2   ! 50 Reihenglieder
         DI  = I
         DI1 = DI - 1.0D0
         CALL MLT_M_V( NPL, MA2, Fz, Fb )   ! Fb = MA^2 * Fz
         LOKAY = .TRUE.
         DO J = 1, NPL
            Fz(J) = Fb(J) / DI / DI1
            Fc(J) = Fc(J) + Fz(J)
            IF( Fc(J) .NE. Fb_alt(J) ) LOKAY = .FALSE.
            Fb_alt(J) = Fc(J)
         END DO
         IF( LOKAY ) GO TO 100   ! Ergebnis steht
      END DO
         ! Ergebnis nicht korrekt !
         WRITE(IO_LI,*) 'Cosh nicht korrekt nach 50 Schritten.'

  100 CONTINUE

      RETURN

      END
C  ------------------------------
C  Matrix MA zu Nplex a erstellen
C  NPL ist Laenge Nplex a
C  Diese Subroutine gilt nur bis e = ( e0, e1, e2 )

      SUBROUTINE GEN_MA( NPL, Fa, MA, dY, Fe )

      IMPLICIT NONE

      INTEGER*4 NPL,    I, J, K
      REAL*8 Fa(NPL), Ma(NPL,NPL), Fe(NPL), dY,  dy_PO

      REAL*8 dE0, dE1, dE2              ! zu: -e*y^-d

      IF( NPL .EQ. 1 ) THEN
         MA(1,1) = Fa(1 )
      ELSE IF( NPL .EQ. 2 ) THEN
         dE0 = Fe( 1 )
         dE1 = Fe( 2 )
         MA(1,1) =  Fa(1)
         MA(1,2) = -Fa(2) * dE0
         MA(2,1) =  dY *  Fa(2)
         MA(2,2) =  dY * ( Fa(1) - Fa(2) * dE1 )
      ELSE IF( NPL .EQ. 3 ) THEN
         dE0 = Fe( 1 )
         dE1 = Fe( 2 )
         dE2 = Fe( 3 )
         MA(1,1) =  Fa(1)
         MA(1,2) = -Fa(3) * dE0
         MA(1,3) = -Fa(2) * dE0 + Fa(3) * dE0 * dE2
         MA(2,1) =  dY * Fa(2)
         MA(2,2) =  dY * ( Fa(1) - Fa(3)*dE1 )
         MA(2,3) =  dY * (-Fa(2)*dE1 - Fa(3)*dE0 + Fa(3)*dE1*dE2 )
         MA(3,1) =  dY*dY * Fa(3)
         MA(3,2) =  dY*dY*( Fa(2) - Fa(3)*dE2 )
         MA(3,3) =  dY*dY*( Fa(1) - Fa(2)*dE2 - Fa(3)*dE1+Fa(3)*dE2*dE2)
      ELSE IF( NPL .GT. 3 ) THEN
         ! Unteres Dreieck von MA und Diagonale von Ma erstellen
         ! Fuer NPL > 3 wird nur dE0 verwendet !!!
         DO J = 1, NPL      ! NPL Spalten
            K = 1
            DO I = J, NPL   ! NPL Zeilen
               MA(I,J) = Fa(K)
               K = K + 1
            END DO
         END DO

         ! Oberes Dreieck von MA erstellen
         DO I = 1, NPL-1    ! ( NPL - 1 ) Zeilen
            K = NPL
            DO J = I+1, NPL ! ( NPL - 1 ) Spalten
               MA(I,J) = -Fa(K) * dE0
               K = K - 1
            END DO
         END DO
         ! Potenzen y verrechnen
         dY_PO = 1.0D0
         DO I = 2, NPL
            dY_PO = dY_PO * dY
            DO J = 1, NPL
               MA(I,J) = MA(I,J) * dY_PO
            END DO
         END DO
      END IF
      RETURN
      END
C  ----------------------------------------------------
C  Multiplizieren Matrix MA mit Vektor B, Ergebnis in C
C  NPL ist Dimension von Ma, B, C.

      SUBROUTINE MLT_M_V( NPL, MA, B, C )

      IMPLICIT NONE

      INTEGER*4 NPL,   I, J
      REAL*8    MA(NPL,NPL), B(NPL), C(NPL)

      DO I = 1, NPL
         C(I) = 0.0D0
         DO J = 1, NPL
            C(I) = C(I) + MA(I,J) * B(J)
         END DO
      END DO

      RETURN
      END
C  ----------------------------------------
C  Loeschen Matrix A(N,M) auf Null,  REAL*8

      SUBROUTINE DKLARM( A, N, M )

      IMPLICIT NONE

      INTEGER*4 N, M, I, J, I1
      PARAMETER ( I1=1 )
      REAL*8 A(N,M)

      DO 10, J = I1, M
      DO 10, I = I1, N
   10 A(I,J) = 0.0D0
      RETURN
      END
C  -----------------------------------------
C  C(NA,MB) = A(NA,MA) * B(MA,MB)   (REAL*8)

      SUBROUTINE DMLTM( A, NA, MA, B, MB, C )

      IMPLICIT NONE

      INTEGER*4 NA, MA, MB, I, J, K, I1
      PARAMETER ( I1=1 )
      REAL*8 A(NA,MA), B(MA,MB), C(NA,MB)

      CALL DKLARM( C, NA, MB )

      DO 10, I = I1, NA
      DO 20, J = I1, MA
      DO 30, K = I1, MB
      C(I,K) = C(I,K) + A(I,J) * B(J,K)
   30 CONTINUE
   20 CONTINUE
   10 CONTINUE
      RETURN
      END
