C  File:  n1_s_exp.for

C  Autor:  G. Schnell

C  21.02.2008

C Berechnen Exponential-Funktion mit sym. rek. Zahlen
C   speziell fuer dreidimensionale komplexe Zahl
C Ordnung: n=1,  Orientierung: o=s,  Grad: g = 1
C Dimension d = d1 = 3
C n1-Parameter sind:  y, e0, e1

C  Berechnen exp( a ), a rek. Zahl der Laenge 3

      IMPLICIT NONE

      REAL*8 dY

      INTEGER*4 d1/ 3 /         ! Dimension d1
      INTEGER*4 J
      REAL*8 A_1, A0, A1
      REAL*8 Fa_1( 3 ), Fa0( 3 ), Fa1( 3 )
      REAL*8 Fa( 3 ), Fe( 2 ), Fc(3)
      REAL*8 Fb( 3 )

      CHARACTER*72 TXT

      INTEGER*4 IO_LI         ! I/O unit Liste
      INTEGER*4 IO_DAT        ! I/O unit Data
      CHARACTER*80 FILE_LI    ! Listfile
      CHARACTER*80 FILE_DAT   ! Datafile

      CHARACTER*(*) FMT1
      PARAMETER   ( FMT1 = '(1X,1P,5E14.6)' )

      IO_DAT = 19   ! I/O Units setzen
      IO_LI  = 22   !

      ! Dateinamen:
      FILE_DAT = 'n1_s_exp.dat'
      FILE_LI  = 'n1_s_exp.ls'

      OPEN( UNIT=IO_DAT, FILE = FILE_DAT )
      OPEN( UNIT=IO_LI,  FILE = FILE_LI )

C  Daten von Datafile lesen

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! IO_DAT auf Datenzeile pos.
      READ(IO_DAT, '(A)' ) TXT          ! Text zur Aufgabe

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! n1_Parameter y
      READ(IO_DAT, * ) dY
      IF( dY .EQ. 0.0D0 ) THEN
         WRITE(IO_LI,*) 'y = ', dY, ' nicht erlaubt.'
         STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! n1-Parameter e0, e1
      READ(IO_DAT, * ) ( Fe(J), J = 1, 2 )

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte zu a_1
      READ(IO_DAT,*) ( Fa_1(J),J=1,3 )  ! Anfang, Ende, Delta

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte zu a0
      READ(IO_DAT,*) ( Fa0(J),J=1,3 )   ! Anfang, Ende, Delta

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte zu a1
      READ(IO_DAT,*) ( Fa1(J),J=1,3 )   ! Anfang, Ende, Delta

      CLOSE ( IO_DAT )


      WRITE(IO_LI,*) 'Programm: n1_s_exp.exe'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Exponential-Funktion fuer verschiedene '//
     +               'n1-Parameter.'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) TXT
      WRITE(IO_LI,*)
      WRITE(IO_LI,2000) d1
 2000 FORMAT('Dimension d = ',I1)
      WRITE(IO_LI,*)
      WRITE(IO_LI,2010) dY
 2010 FORMAT('Parameter y = ',1P,E14.6)
      WRITE(IO_LI,*)
      WRITE(IO_LI,*)  'Parameter e: ( e0, e1 )'
      CALL DPUT( Fe(1), IO_LI, FMT1, 1, 2, 0, 0 )
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Werte a_1: ( Anfang, Ende, Delta )'
      CALL DPUT( Fa_1(1), IO_LI, FMT1, 1, 3, 0, 0 )
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Werte a0 : ( Anfang, Ende, Delta )'
      CALL DPUT( Fa0(1), IO_LI, FMT1, 1, 3, 0, 0 )
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Werte a1 : ( Anfang, Ende, Delta )'
      CALL DPUT( Fa1(1), IO_LI, FMT1, 1, 3, 0, 0 )
      WRITE(IO_LI,*)

      WRITE(IO_LI,*) 'Ergebnis: a, b=exp(a), c=exp(a)'
      DO A_1 = Fa_1(1), Fa_1(2)+Fa_1(3)/2, Fa_1(3)
      DO A0  = Fa0(1),  Fa0(2) +Fa0(3)/2,  Fa0(3)
      DO A1  = Fa1(1),  Fa1(2) +Fa1(3)/2,  Fa1(3)
         Fa(1) = A_1
         Fa(2) = A0
         Fa(3) = A1
         WRITE(IO_LI,0815) 'a', Fa
         ! CALL DPUT( Fa(1), IO_LI, FMT1, 1, d1, 0, 0 )

         ! Testen direkte Berechnung b = exp( a ) !!!
         IF( ((dy.EQ.1).AND.(Fe(1).EQ.1)) .AND. (Fe(2).EQ.0) ) THEN
            CALL calc_b( Fa, Fb )
            WRITE(IO_LI,0815) 'b', Fb
            ! CALL DPUT( Fb(1), IO_LI, FMT1, 1, d1, 0, 0 )
         END IF

         ! c = exp(a) aus Reihenentwickung
         CALL sn1_exp( d1, Fa, Fc, dY, Fe, IO_LI)
         WRITE(IO_LI,0815) 'c', Fc
         ! CALL DPUT( Fc(1), IO_LI, FMT1, 1, d1, 0, 0 )

         WRITE(IO_LI,*)
      END DO
      END DO
      END DO

      CLOSE ( IO_LI )

      STOP

 0815 FORMAT(1X,A1,1X,1P,3D14.6)

      END
C ----------------------------------------------------
C  FILE_DAT = 'n1_s_exp.dat' fuers Lesen positionieren
C  und Kommentar- und Leer-Zeilen ueberlesen.

      SUBROUTINE UP_IN_POS( IO_IN, IO_LI )

      IMPLICIT NONE

      INTEGER*4 IO_IN, IO_LI, I
      CHARACTER*136 REC

   10 READ( IO_IN, '(A)', ERR=800, END=900 ) REC
      IF( REC(1:1) .EQ. '!' ) GO TO 10   ! Kommentarzeile ueberlesen
      DO 20, I = 1, 136
         IF( REC(I:I) .NE. ' ' ) THEN
            BACKSPACE IO_IN
            RETURN                       ! Datenzeile gefunden
         END IF
   20 CONTINUE
      GO TO 10                           ! Leerzeile ueberlesen

  800 WRITE( IO_LI, * ) 'Error beim Lesen von n1_s_exp.dat'
      STOP

  900 WRITE( IO_LI, * ) 'EOF erreicht beim Lesen von n1_s_exp.dat'
      STOP
      END
C  ---------- DPUT ---------------------------
C  Drucken Matrix oder Vektor FD[M,N],  Real*8
C  FD    = Matrix[M,N]
C  IOU   = Output-Unit
C  IVOR  = Anzahl Leer-Zeilen vor dem Drucken
C  INACH = Anzahl Leer-Zeilen nach dem Drucken
C  HFORM = Vektor der das Druck-Format enthaelt

      SUBROUTINE DPUT( FD, IOU, HFORM, M, N, IVOR, INACH )

      IMPLICIT NONE

      INTEGER*4 IOU
      INTEGER*4 N, M, IVOR, INACH, I, J
      REAL*8 FD(M,N)
      CHARACTER*(*) HFORM

      IF( IVOR .LE. 0 ) GO TO 9

      DO 5, I = 1, IVOR
         WRITE(IOU,2000)
    5 CONTINUE

    9 CONTINUE

      DO 10, I = 1, M
       WRITE(IOU,HFORM) ( FD(I,J), J = 1, N )
   10 CONTINUE

      IF( INACH .LE. 0 ) RETURN

      DO 15, I = 1, INACH
         WRITE(IOU,2000)
   15 CONTINUE

      RETURN

 2000 FORMAT(2H  )
      END
C  ----------------------------------------------------
C  Berechnen Exponentialfunktion einer sym. rek. Zahl a

C  exp( a ) = 1 + a/1! + a^2/2! + a^3/3! + ...

      SUBROUTINE sn1_exp( d1, Fa, Fc, Y, Fe, IO_LI )

      IMPLICIT NONE

      INTEGER*4 d1, IO_LI
      REAL*8 Fa(d1), Fc(d1), Fe(2), Y

      REAL*8 MA( 3, 3 )
      REAL*8 Fb( 3 ), DI
      REAL*8 Fz( 3 ), Fb_alt( 3 )

      INTEGER*4 I, J
      LOGICAL*4 LOKAY

      ! n1-Matrix MA erstellen
      CALL GEN_MA_Y( Fa, MA, Y, Fe )

      ! Fc = Fa, Fz = Fa,  Fb_alt = 0
      DO I = 1, d1
         Fc(I) = Fa(I)
         Fz(I) = Fa(I)
         Fb_alt(I) = 0.0D0
      END DO
         Fc(2) = Fc(2) + 1.0D0   ! e^a = 1 + a/1! + ...

      DO I = 2, 100   ! 100 Reihenglieder sollten reichen
         DI = I
         CALL MLT_M_V( d1, MA, Fz, Fb )   ! Fb = MA * Fz
         LOKAY = .TRUE.
         DO J = 1, d1
            Fz(J) = Fb(J) / DI
            Fc(J) = Fc(J) + Fz(J)
            IF( Fc(J) .NE. Fb_alt(J) ) LOKAY = .FALSE.
            Fb_alt(J) = Fc(J)
         END DO
         IF( LOKAY ) GO TO 100   ! Ergebnis steht
      END DO
         ! Ergebnis nicht korrekt !
         WRITE(IO_LI,*) 'Ergebnis nicht korrekt nach 100 Schritten.'

  100 CONTINUE

      RETURN

      END
C  ----------------------------
C  Berechnen b = exp( a )

      SUBROUTINE CALC_b( a, b )

      IMPLICIT NONE

      REAL*8 a(3), b(3)
      REAL*8 da, ds, de

      da = a(3)-a(1)       ! da = a1 - a_1
      IF( da .EQ. 0.0D0 ) THEN
         b(3) = a(3)
         b(2) = DCOS( da )
         b(1) = a(1)
      ELSE
         ds = DSIN( da )
         b(3) = a(3)*ds/da
         b(2) = DCOS( da )
         b(1) = b(3) - ds
      END IF
      de = DEXP( a(2) )     ! fuer: a(2) = a0 # 0
      b(1) = b(1) * de      !
      b(2) = b(2) * de      !
      b(3) = b(3) * de      !

      RETURN

      END
C  ========================
C  Matrix Ma zu a erstellen
C  Die Dimension d1 von a ist 3
C  Y ist Vorzeichen-Parameter
C  E0, E1 sind Reduktions-Parameter
C  A_1, A0, A1 stehen in Fa

      SUBROUTINE GEN_MA_Y( Fa, ma, Y, Fe )

      IMPLICIT NONE

      REAL*8 Fa(3), Ma(3,3), Y, Fe(2), E0, E1

      E0 = Fe(1)
      E1 = Fe(2)

      MA(1,1) = ( Fa(2) - Fa(1) * E1 / E0 ) / Y
      MA(1,2) =   Fa(1) / Y
      MA(1,3) =   0.0D0
      MA(2,1) =   Fa(3) - Fa(1) / E0
      Ma(2,2) =   Fa(2)
      Ma(2,3) =   Fa(1) - Fa(3) * E0
      Ma(3,1) =   0.0D0
      Ma(3,2) =   Fa(3) * Y
      Ma(3,3) = ( Fa(2) - Fa(3) * E1 ) * Y

      RETURN

      END
C  ----------------------------------------------------
C  Multiplizieren Matrix MA mit Vektor B, Ergebnis in C
C  d1 ist Dimension von Ma, B, C.

      SUBROUTINE MLT_M_V( d1, MA, B, C )

      IMPLICIT NONE

      INTEGER*4 d1,   I, J
      REAL*8    MA(d1,d1), B(d1), C(d1)

      DO I = 1, d1
         C(I) = 0.0D0
         DO J = 1, d1
            C(I) = C(I) + MA(I,J) * B(J)
         END DO
      END DO

      RETURN
      END