C  File:  n1_s_op.for

C  11.03.2008

C  Autor:  G. Schnell

C  rekursive arithmetische Operationen mit sym. rek. Zahlen
C  Ordnung n = 1, Orientierung o = s, Grad g = 1 (d1=3)
C  n1 - Parameter:   y,  e = ( e0 , e1 )

      IMPLICIT NONE

      INTEGER*4 d1               ! Dimensionen zu n1
      INTEGER*4 I1/1/
      INTEGER*4 I, IERR

      REAL*8 a(3)                ! 3 = Max. d1
      REAL*8 b(3)                !
      REAL*8 c(3)                !
      REAL*8 j(3)                !
      REAL*8 h(3)                !
      REAL*8 u(3)                !

      REAL*8 ma(9), mb(9)        ! 9 = Max. d1*d1
      REAL*8 mc(9)               !
      REAL*8 mai(9), mbi(9)      !


      REAL*8 y, e(2), e0, e1
      EQUIVALENCE( e(1), e0 )
      EQUIVALENCE( e(2), e1 )
      COMMON / n1_com / y, e

      CHARACTER*72 TXT

      INTEGER*4 IO_LI         ! I/O unit Liste
      INTEGER*4 IO_DAT        ! I/O unit Data
      CHARACTER*80 FILE_LI    ! Listfile
      CHARACTER*80 FILE_DAT   ! Datafile

      IO_DAT = 19   ! I/O Units setzen
      IO_LI  = 22   !

      ! Dateinamen:
      FILE_DAT = 'n1_s_op.dat'
      FILE_LI  = 'n1_s_op.ls'

      OPEN( UNIT=IO_DAT, FILE = FILE_DAT )
      OPEN( UNIT=IO_LI,  FILE = FILE_LI )

C  Daten von Datafile lesen

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! IO_DAT auf Datenzeile pos.
      READ(IO_DAT, '(A)' ) TXT          ! Text zur Aufgabe

      d1 = 3                            ! Dimension der Zahlen a, b, ...

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Wert y zu n1
      READ(IO_DAT, * ) y

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte e zu n1
      READ(IO_DAT, * ) ( e(I), I = 1, 2 )

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte von a
      READ(IO_DAT, * ) ( a(I), I = 1, d1 )

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte von b
      READ(IO_DAT, * ) ( b(I), I = 1, d1 )

      CLOSE ( IO_DAT )


      WRITE(IO_LI,*) 'Programm: n1_s_op.exe'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Arithmetische Operationen mit sym. rek. Zahlen'
      WRITE(IO_LI,*) 'Ordnung n = 1, Orientierung o = s, Grad g = 1'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) TXT
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Ordnung n = 1, Dimension d1 = 3'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'n1-Parameter y:'
      CALL DPUT_v( IO_LI, I1, y )
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'n1-Parameter e: ( e0, e1 )'
      CALL DPUT_v( IO_LI, 2, e(1) )
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'a=( a_1, a0, a1 )'
      CALL DPUT_v( IO_LI, d1, a(1) )
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'b=( b_1, b0, b1 )'
      CALL DPUT_v( IO_LI, d1, b(1) )
      WRITE(IO_LI,*)

      ! c = a + b
      CALL n1_add( d1, c, a, b )
      WRITE(IO_LI,*) 'a + b'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! c = a - b
      CALL n1_sub( d1, c, a, b )
      WRITE(IO_LI,*) 'a - b'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! h = a * a
      CALL n1_mlt( d1, h, a, a )
      WRITE(IO_LI,*) 'a * a'
      CALL DPUT_v( IO_LI, d1, h(1) )
      WRITE(IO_LI,*)

      ! c = a * a * a
      CALL n1_mlt( d1, c, h, a )
      WRITE(IO_LI,*) 'a * a * a'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! c = a * b
      CALL n1_mlt( d1, c, a, b )
      WRITE(IO_LI,*) 'a * b'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! c = b * a
      CALL n1_mlt( d1, c, b, a )
      WRITE(IO_LI,*) 'b * a'
      CALL DPUT_v( IO_LI, d1, c(1) )
      WRITE(IO_LI,*)

      ! ma = m(y,e,a)
      CALL n1_gen_ma_y( d1, a, ma )
      WRITE(IO_LI,*) 'ma = m(y,e,a)'
      CALL DPUT_m( IO_LI, d1, ma )
      WRITE(IO_LI,*)

      ! mb = m(y,e,b)
      CALL n1_gen_ma_y( d1, b, mb )
      WRITE(IO_LI,*) 'mb = m(y,e,b)'
      CALL DPUT_m( IO_LI, d1, mb )
      WRITE(IO_LI,*)

      ! mc = ma * ma
      CALL n1_mltm( d1, mc, ma, ma )
      WRITE(IO_LI,*) 'ma * ma'
      CALL DPUT_m( IO_LI, d1, mc )
      WRITE(IO_LI,*)

      ! mc = ma * mb
      CALL n1_mltm( d1, mc, ma, mb )
      WRITE(IO_LI,*) 'ma * mb'
      CALL DPUT_m( IO_LI, d1, mc )
      WRITE(IO_LI,*)

      ! mc = mb * ma
      CALL n1_mltm( d1, mc, mb, ma )
      WRITE(IO_LI,*) 'mb * ma'
      CALL DPUT_m( IO_LI, d1, mc )
      WRITE(IO_LI,*)

      ! Inverse mai von ma
      CALL n1_inv( d1, ma, mai, IERR )

      ! mai drucken
      WRITE(IO_LI,*) 'mai = ma^(-1) aus n1_div'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_m( IO_LI, d1, mai )
      ELSE
         WRITE(IO_LI,2000) IERR
         CALL DPUT_m( IO_LI, d1, mai )
      END IF
      WRITE(IO_LI,*)

      ! Inverse mbi von mb
      CALL n1_inv( d1, mb, mbi, IERR )

      ! mbi drucken
      WRITE(IO_LI,*) 'mbi = mb^(-1) aus n1_div'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_m( IO_LI, d1, mbi )
      ELSE
         WRITE(IO_LI,2000) IERR
         CALL DPUT_m( IO_LI, d1, mbi )
      END IF
      WRITE(IO_LI,*)
 2000 FORMAT(1X,'iERR = ',I1)

      ! mc = ma * mai
      CALL n1_inv( d1, ma, mai, IERR )
      CALL n1_mltm( d1, mc, ma, mai )
      WRITE(IO_LI,*) 'ma * mai'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_m( IO_LI, d1, mc )
      ELSE
         WRITE(IO_LI,2000) IERR
         CALL DPUT_m( IO_LI, d1, mc )
      END IF
      WRITE(IO_LI,*)

      ! mc = mb * mbi
      CALL n1_inv( d1, mb, mbi, IERR )
      CALL n1_mltm( d1, mc, mb, mbi )
      WRITE(IO_LI,*) 'mb * mbi'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_m( IO_LI, d1, mc )
      ELSE
         WRITE(IO_LI,2000) IERR
         CALL DPUT_m( IO_LI, d1, mc )
      END IF
      WRITE(IO_LI,*)

      ! ------ Divisionen, speziell mit ------
      ! dreidimensionaler komplexer Arithmetik

      IF( (y.EQ.1.0D0) .AND. 
     +  ( (e0.EQ.1.0D0).AND.(e1.EQ.0.0D0) ) ) THEN

         WRITE(IO_LI,*) 'Ab hier spezielle Divisions-Arithmetik'
         WRITE(IO_LI,*) 'fr dreidimensionale komplexe Zahlen'
         WRITE(IO_LI,*)

         ! j = ( 0, 1, 0 )
         WRITE(IO_LI,*) 'j=( 0, 1, 0 )'
         CALL n1_one( d1, j )
         CALL DPUT_v( IO_LI, d1, j(1) )
         WRITE(IO_LI,*)

         ! c = 1 / a
         CALL n1_s_div( c, j, a, mai, IERR)
         WRITE(IO_LI,*) '1 / a =: 1/a * j'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*) 'Test: mai aus n1_s_div'
         CALL DPUT_m( IO_LI, d1, mai )
         WRITE(IO_LI,*)

         ! c = 1 / b
         CALL n1_s_div( c, j, b, mbi, IERR)
         WRITE(IO_LI,*) '1 / b =: 1/b * j'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*) 'Test: mbi aus n1_s_div'
         CALL DPUT_m( IO_LI, d1, mbi )
         WRITE(IO_LI,*)

         ! c = a / b
         CALL n1_s_div( c, a, b, mbi, IERR)
         WRITE(IO_LI,*) 'a / b =: 1/b * j * a'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*)

         ! c = b / a
         CALL n1_s_div( c, b, a, mai, IERR)
         WRITE(IO_LI,*) 'b / a =: 1/a * j * b'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*)

         ! c = (a * b) / a
         CALL n1_mlt( d1, h, a, b )          ! h = a * b
         CALL n1_s_div( c, h, a, mai, IERR ) ! c = h / a
         WRITE(IO_LI,*) '(a * b) / a'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*)

         ! sqrt( a )
         WRITE(IO_LI,*) 'c = sqrt( a )'
         CALL n1_s_sqr( c, a, iERR )
         IF( (iERR .GT. 1) .AND. (iERR .LT. 10 ) ) THEN
            WRITE(IO_LI,*) 'Divisions-Fehler in n1_s_sqr(a)'
            WRITE(IO_LI,*) 'iERR = ', iERR
         ELSE
            IF( iERR .EQ. 1 ) THEN
               WRITE(IO_LI,*) 'Pseudo Division'
               WRITE(IO_LI,*) 'iERR = ', iERR
            END IF 
            IF( iERR .GT. 10 ) THEN
               WRITE(IO_LI,*) 'Keine Konvergenz fr sqrt(a)'
               WRITE(IO_LI,*) 'iERR = ', iERR
            END IF
            CALL DPUT_v( IO_LI, d1, c )
            WRITE(IO_LI,*) 'Probe: c*c = a ?'
            CALL n1_mlt( d1, u, c, c )
            CALL DPUT_v( IO_LI, d1, u )
            WRITE(IO_LI,*) 'Delta: a - c*c'
            CALL n1_sub( d1, h, a, u )
            CALL DPUT_v( IO_LI, d1, h )
         END IF
         WRITE(IO_LI,*)

         ! sqrt( b )
         WRITE(IO_LI,*) 'c = sqrt( b )'
         CALL n1_s_sqr( c, b, iERR )
         IF( (iERR .GT. 1) .AND. (iERR .LT. 10 ) ) THEN
            WRITE(IO_LI,*) 'Divisions-Fehler in n1_s_sqr(b)'
            WRITE(IO_LI,*) 'iERR = ', iERR
         ELSE
            IF( iERR .EQ. 1 ) THEN
               WRITE(IO_LI,*) 'Pseudo Division'
               WRITE(IO_LI,*) 'iERR = ', iERR
            END IF 
            IF( iERR .GT. 10 ) THEN
               WRITE(IO_LI,*) 'Keine Konvergenz fr sqrt(b)'
               WRITE(IO_LI,*) 'iERR = ', iERR
            END IF
            CALL DPUT_v( IO_LI, d1, c )
            WRITE(IO_LI,*) 'Probe: c*c = b ?'
            CALL n1_mlt( d1, u, c, c )
            CALL DPUT_v( IO_LI, d1, u )
            WRITE(IO_LI,*) 'Delta: b - c*c'
            CALL n1_sub( d1, h, b, u )
            CALL DPUT_v( IO_LI, d1, h )
         END IF
         WRITE(IO_LI,*)
     
      ELSE  ! keine spezielle Division fr komplexe Zahlen


         ! j = ( 0, 1, 0 )
         WRITE(IO_LI,*) 'j=( 0, 1, 0 )'
         CALL n1_one( d1, j )
         CALL DPUT_v( IO_LI, d1, j(1) )
         WRITE(IO_LI,*)

         ! c = 1 / a
         CALL n1_div( d1, c, j, a, IERR)
         WRITE(IO_LI,*) '1 / a =: 1/a * j'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*)

         ! c = 1 / b
         CALL n1_div( d1, c, j, b, IERR)
         WRITE(IO_LI,*) '1 / b =: 1/b * j'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*)

         ! c = a / b
         CALL n1_div( d1, c, a, b, IERR)
         WRITE(IO_LI,*) 'a / b =: 1/b * j * a'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*)

         ! c = b / a
         CALL n1_div( d1, c, b, a, IERR)
         WRITE(IO_LI,*) 'b / a =: 1/a * j * b'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*)

         ! c = (a * b) / a
         CALL n1_mlt( d1, h, a, b )        ! h = a * b
         CALL n1_div( d1, c, h, a, IERR )  ! c = h / a
         WRITE(IO_LI,*) '(a * b) / a'
         IF( IERR .EQ. 0 ) THEN
            CALL DPUT_v( IO_LI, d1, c(1) )
         ELSE
            WRITE(IO_LI,2000) IERR
            CALL DPUT_v( IO_LI, d1, c(1) )
         END IF
         WRITE(IO_LI,*)

         ! sqrt( a )
         WRITE(IO_LI,*) 'c = sqrt( a )'
         CALL n1_sqr( d1, c, a, iERR )
         IF( (iERR .GT. 1) .AND. (iERR .LT. 10 ) ) THEN
            WRITE(IO_LI,*) 'Divisions-Fehler in n1_sqr(a)'
            WRITE(IO_LI,*) 'iERR = ', iERR
         ELSE
            IF( iERR .EQ. 1 ) THEN
               WRITE(IO_LI,*) 'Pseudo Division'
               WRITE(IO_LI,*) 'iERR = ', iERR
            END IF 
            IF( iERR .GT. 10 ) THEN
               WRITE(IO_LI,*) 'Keine Konvergenz fr sqrt(a)'
               WRITE(IO_LI,*) 'iERR = ', iERR
            END IF
            CALL DPUT_v( IO_LI, d1, c )
            WRITE(IO_LI,*) 'Probe: c*c = a ?'
            CALL n1_mlt( d1, u, c, c )
            CALL DPUT_v( IO_LI, d1, u )
            WRITE(IO_LI,*) 'Delta: a - c*c'
            CALL n1_sub( d1, h, a, u )
            CALL DPUT_v( IO_LI, d1, h )
         END IF
         WRITE(IO_LI,*)

         ! sqrt( b )
         WRITE(IO_LI,*) 'c = sqrt( b )'
         CALL n1_sqr( d1, c, b, iERR )
         IF( (iERR .GT. 1) .AND. (iERR .LT. 10 ) ) THEN
            WRITE(IO_LI,*) 'Divisions-Fehler in n1_sqr(b)'
            WRITE(IO_LI,*) 'iERR = ', iERR
         ELSE
            IF( iERR .EQ. 1 ) THEN
               WRITE(IO_LI,*) 'Pseudo Division'
               WRITE(IO_LI,*) 'iERR = ', iERR
            END IF 
            IF( iERR .GT. 10 ) THEN
               WRITE(IO_LI,*) 'Keine Konvergenz fr sqrt(b)'
               WRITE(IO_LI,*) 'iERR = ', iERR
            END IF
            CALL DPUT_v( IO_LI, d1, c )
            WRITE(IO_LI,*) 'Probe: c*c = b ?'
            CALL n1_mlt( d1, u, c, c )
            CALL DPUT_v( IO_LI, d1, u )
            WRITE(IO_LI,*) 'Delta: b - c*c'
            CALL n1_sub( d1, h, b, u )
            CALL DPUT_v( IO_LI, d1, h )
         END IF
         WRITE(IO_LI,*)

      END IF


      CLOSE ( IO_LI )

      STOP

      END
C  --------------------------------------------------
C  FILE_DAT = 'n1_s_op.dat' fuers Lesen positionieren
C  und Kommentar- und Leer-Zeilen ueberlesen.

      SUBROUTINE UP_IN_POS( IO_IN, IO_LI )

      IMPLICIT NONE

      INTEGER*4 IO_IN, IO_LI, I
      CHARACTER*136 REC

   10 READ( IO_IN, '(A)', ERR=800, END=900 ) REC
      IF( REC(1:1) .EQ. '!' ) GO TO 10   ! Kommentarzeile ueberlesen
      DO 20, I = 1, 136
         IF( REC(I:I) .NE. ' ' ) THEN
            BACKSPACE IO_IN
            RETURN                       ! Datenzeile gefunden
         END IF
   20 CONTINUE
      GO TO 10                           ! Leerzeile ueberlesen

  800 WRITE( IO_LI, * ) 'Error beim Lesen von n1_s_op.dat'
      STOP

  900 WRITE( IO_LI, * ) 'EOF erreicht beim Lesen von n1_s_op.dat'
      STOP
      END
C  =====================================
C  ma(d1,d1) drucken

      SUBROUTINE DPUT_m( IO_LI, d1, ma )

      IMPLICIT NONE

      INTEGER*4 IO_LI, d1, I, J
      REAL*8 ma(d1, d1)

      DO I = 1, d1
         WRITE(IO_LI,1000) (ma(I,J), J=1,d1)
      END DO

      RETURN

 1000 FORMAT(1X,3(1P,D14.6))

      END
C  ====================================
C  a(d1) drucken

      SUBROUTINE DPUT_v( IO_LI, d1, a )

      IMPLICIT NONE

      INTEGER*4 IO_LI, d1, I
      REAL*8 a(d1)

      WRITE(IO_LI,1000) (a(I), I=1,d1)

      RETURN

 1000 FORMAT(1X,3(1P,D14.6))

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = 0

      SUBROUTINE n1_zero( d1, a )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1)

      DO I = 1, d1
         a(I) = 0.0D0
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = 1

      SUBROUTINE n1_one( d1, a )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1)

      DO I = 1, d1
         a(I) = 0.0D0
      END DO
      a(2) = 1.0D0

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = s * a      s ist ein Skalar

      SUBROUTINE n1_ska( d1, a, s )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1), s

      DO I = 1, d1
         a(I) = a(I) * s
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = b

      SUBROUTINE n1_move( d1, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1), b(d1)

      DO I = 1, d1
         a(I) = b(I)
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a + b

      SUBROUTINE n1_add( d1, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 c(d1), a(d1), b(d1)

      DO I = 1, d1
         c(I) = a(I) + b(i)
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a - b

      SUBROUTINE n1_sub( d1, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 c(d1), a(d1), b(d1)

      DO I = 1, d1
         c(I) = a(I) - b(i)
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  ma aus a    mit y

      SUBROUTINE n1_gen_ma_y( d1, a, ma )

      IMPLICIT NONE

      INTEGER*4 d1
      REAL*8 a(d1), ma(d1,d1)

      REAL*8 y, e(2), e0, e1
      EQUIVALENCE( e(1), e0 )
      EQUIVALENCE( e(2), e1 )
      COMMON / n1_com / y, e

      ma(1,1) = ( a(2) - a(1) * e1 / e0 ) / y
      ma(1,2) =   a(1) / y
      ma(1,3) =   0.0D0
      ma(2,1) =   a(3) - a(1) / e0
      ma(2,2) =   a(2)
      ma(2,3) =   a(1) - a(3) * e0
      ma(3,1) =   0.0D0
      ma(3,2) =   a(3) * y
      ma(3,3) = ( a(2) - a(3) * e1 ) * y

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a * b

      SUBROUTINE n1_mlt( d1, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1
      REAL*8 c(d1), a(d1), b(d1)
      REAL*8 ma(9)                     ! 9 = 3*3 = Maximum

      CALL n1_gen_ma_y( d1, a, ma )    ! ma aus a
      CALL n1_ma_v( d1, c, ma, b )     ! c = ma * b

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = b / a
C  IERR = 0 = okay,  IERR > 0 = Fehler

      SUBROUTINE n1_div( d1, c, b, a, IERR )

      IMPLICIT NONE

      INTEGER*4 d1, IERR
      REAL*8 c(d1), a(d1), b(d1)
      REAL*8 ma(9), mai(9)              ! 9 = 3*3 = Maximum
      REAL*8  j(3)/0,1,0/, h(3)         !

      CALL n1_gen_ma_y( d1, a, ma )     ! ma aus a
      CALL n1_inv( d1, ma, mai, IERR )  ! mai = ma^(-1)
      IF( iERR .EQ. 0 ) THEN
         CALL n1_ma_v( d1, c, mai, b )  ! c = 1/a * b
      ELSE
         ! c = 1/a * j * b
         CALL n1_ma_v( d1, h, mai, j )  ! h = 1/a * j
         CALL n1_mlt( d1, c, h, b )     ! c = h * b
      END IF

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = ma * b

      SUBROUTINE n1_ma_v( d1, c, ma, b )

      IMPLICIT NONE

      INTEGER*4 d1
      REAL*8 c(d1), ma(d1,d1), b(d1)

      c(1) = ma(1,1)*b(1) + ma(1,2)*b(2) + ma(1,3)*b(3)
      c(2) = ma(2,1)*b(1) + ma(2,2)*b(2) + ma(2,3)*b(3)
      c(3) = ma(3,1)*b(1) + ma(3,2)*b(2) + ma(3,3)*b(3)

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  mc = ma * mb

      SUBROUTINE n1_mltm( d1, mc, ma, mb )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 mc(d1,d1), ma(d1,d1), mb(d1,d1)

      DO I = 1, d1

         CALL n1_ma_v( d1, mc(1,I), ma, mb(1,I) )

      END DO

      RETURN

      END
C  =================================
C  n=n1,  d = d1 = 3          Real*8
C  c = b/a  ( mit y = 1, e = ( 1, 0 )
C  Division mit symmetrischen komplexen Zahlen
C  iERR=0=okay, iERR=1=pseudoinverse
C  iERR = 2 oder 3 = Division durch Null

      SUBROUTINE n1_s_div( c, b, a, mai, iERR )

      IMPLICIT NONE

      INTEGER*4 iERR
      REAL*8 c(-1:1), b(-1:1), a(-1:1), mai(3,3)

      INTEGER*4 I, J, d1/ 3 /
      REAL*8 Det, d, je(3)/0,1,0/, h(3)

      d = a(1) - a(-1)                   ! delta = a1 - a_1
      Det = a(0) * ( a(0)*a(0) + d*d )   ! Determinante

      IF( Det .NE. 0.0D0 ) THEN   ! regulre Division, Det # 0

         iERR = 0

         mai(1,1) = ( a(0)*a(0) + a( 1)*d ) / Det
         mai(1,2) = ( -a(0)*a(-1)         ) / Det
         mai(1,3) = ( -a(-1)*d            ) / Det

         mai(2,1) = ( -a(0)*d             ) / Det
         mai(2,2) = ( a(0)*a(0)           ) / Det
         mai(2,3) = ( a(0)*d              ) / Det

         mai(3,1) = ( a(1)*d              ) / Det
         mai(3,2) = ( -a(0)*a(1)          ) / Det
         mai(3,3) = ( a(0)*a(0) - a(-1)*d ) / Det

         call n1_ma_v( d1, c, mai, b )    ! c = mai * b

      ELSE                                ! Det = 0

         DO I = 1, 3         ! mai = 0
         DO J = 1, 3
            mai(I,J) = 0.0D0
         END DO
         END DO

         IF ( d .EQ. 0.0D0 ) THEN

            IF( a(1) .NE. 0.0D0 ) THEN   ! a(1) = a(-1) # 0
               iERR = 2
               mai(2,1) = 1.0D0 / ( a(1) + a(1) )
               mai(2,3) = mai(2,1)
            ELSE                         ! a(1) = a(-1) = 0
               iERR = 3
            END IF

            call n1_zero( d1, c )   ! formal: mai * j * b = 0

         ELSE

            iERR = 1         ! Pseudoinverse
            mai(1,2) =  1.0D0 / ( d + d )
            mai(2,1) =  a(-1) / ( a(-1)*a(-1) + a(1)*a(1) )
            mai(2,3) =  a( 1) / ( a(-1)*a(-1) + a(1)*a(1) )
            mai(3,2) = -1.0D0 / ( d + d )

            ! c = 1/a * j * b      
            CALL n1_ma_v( d1, h, mai, je )  ! h = 1/a * j
            CALL n1_mlt( d1, c, h, b )      ! c = h * b
     
         END IF

      END IF

      RETURN

      END
C  =================================
C  n=n1,  d=d1=3              Real*8
C  Wurzel aus symmetrischen komplexen Zahlen
C  mit: ( y = 1, e = ( 1, 0 )
C  b = sqrt( a )  babylonisches Verfahren
C  b = a^(1/r)    fuer n1_sqr ist r=2
C  N1 ist 1. Naeherung   z. B.: N1 = ( 1, 1, 1 )
C  N2 = [ (r-1)*N1 + a / N1^(r-1) ] / r
C  iERR = 0 = kein Fehler

      SUBROUTINE n1_s_sqr( b, a, iERR )

      IMPLICIT NONE

      INTEGER*4 d1/ 3 /, iERR
      REAL*8 b(3), a(3)

      LOGICAL*4 L
      INTEGER*4 I, IZ, IMAX/ 100 /
      REAL*8 N1(3), N2(3), Q(3), mi(3,3), F/0.5D0/
      REAL*8 Sa, Sd, P(3), D(3), EPS/ 1.0D-15 /

      ! Pruefen ob a = 0
      DO I = 1, d1
         IF( a(I) .NE. 0.0D0 ) GO TO 10
      END DO
      CALL n1_zero( d1, b )   ! b = 0
      iERR = 0
      RETURN

   10 CONTINUE

      ! Pruefen ob a0=0 und delta = a1 - a_1 = 0 ?
      IF( a(2) .NE. 0.0D0 ) GO TO 20
      IF( a(3)-a(1) .NE. 0.0D0 ) GO TO 20
      CALL n1_zero( d1, b )   ! b = 0
      iERR = 0
      RETURN

   20 CONTINUE

      CALL n1_zero( d1, b )               ! Naeherung N1
      b(1)  =  0.5D0                      ! b_1
      b(2) = -0.5D0                       ! b0
      b(3) = -0.5D0                       ! b1
      CALL n1_s_div( N1, a, b, mi, iERR ) ! N1 = a / b

      IZ = 0
      ! Abbruchkriterium Teil 1,  abs. Norm
      Sa = 0.0D0
      DO I = 1, d1
         Sa = Sa + DABS( a(I) )
      END DO

      L = .FALSE.

  100 CALL n1_s_div( Q, a, N1, mi, iERR ) ! Q = a / N1
      CALL n1_add( d1, N2, N1, Q )        ! N2 = N1 + Q
      CALL n1_ska( d1, N2, F )            ! N2 = N2 * 0.5

      IZ = IZ + 1
      ! Abbruchkriterium ab 10 Iterationen
      IF( IZ .GT. 10 ) THEN
         CALL n1_mlt( d1, P, N2, N2 )        ! P = N2 * N2 ==> a
         CALL n1_sub( d1, D, a, P )          ! D = a - P
         Sd = 0.0D0
         DO I = 1, d1
            Sd = Sd + DABS( D(I) )
         END DO
         IF( Sd / Sa .LT. EPS ) L = .TRUE.
         IF( L ) THEN       ! Iteration steht
            CALL n1_move( d1, b, N2 )
            iERR = 0
            RETURN
         END IF
      END IF

      IF( IZ .LT. IMAX ) THEN
         CALL n1_move( d1, N1, N2 )   ! N1 = N2
         GO TO 100
      END IF

      ! max. Anzahl Iterationen ueberschritten
      iERR = IMAX
      CALL n1_move( d1, b, N2 )   ! b = N2
      RETURN

      END
C  =================================
C  n=n1,  d=d1=3              Real*8
C  Wurzel aus symmetrischen rek. Zahlen
C  mit: ( y # 1 und/oder e # ( 1, 0 )
C  b = sqrt( a )  babylonisches Verfahren
C  b = a^(1/r)    fuer n1_sqr ist r=2
C  N1 ist 1. Naeherung   z. B.: N1 = ( 1, 1, 1 )
C  N2 = [ (r-1)*N1 + a / N1^(r-1) ] / r
C  iERR = 0 = kein Fehler

      SUBROUTINE n1_sqr( d1, b, a, iERR )

      IMPLICIT NONE

      INTEGER*4 d1, iERR
      REAL*8 b(3), a(3)

      LOGICAL*4 L
      INTEGER*4 I, IZ, IMAX/ 100 /
      REAL*8 N1(3), N2(3), Q(3),  F/0.5D0/
      REAL*8 Sa, Sd, P(3), D(3), EPS/ 1.0D-15 /

      ! Pruefen ob a = 0
      DO I = 1, d1
         IF( a(I) .NE. 0.0D0 ) GO TO 10
      END DO
      CALL n1_zero( d1, b )   ! b = 0
      iERR = 0
      RETURN

   10 CONTINUE

   20 CONTINUE

      CALL n1_zero( d1, b )               ! Naeherung N1
      b(1)  =  0.5D0                      ! b_1
      b(2) = -0.5D0                       ! b0
      b(3) = -0.5D0                       ! b1
      CALL n1_div( d1, N1, a, b, iERR )   ! N1 = a / b

      IZ = 0
      ! Abbruchkriterium Teil 1,  abs. Norm
      Sa = 0.0D0
      DO I = 1, d1
         Sa = Sa + DABS( a(I) )
      END DO

      L = .FALSE.

  100 CALL n1_div( d1, Q, a, N1, iERR )   ! Q = a / N1
!      IF( iERR .GT. 0 ) THEN
!         CALL n1_zero( d1, b )            ! b = 0
!         RETURN
!      END IF
      CALL n1_add( d1, N2, N1, Q )        ! N2 = N1 + Q
      CALL n1_ska( d1, N2, F )            ! N2 = N2 * 0.5

      IZ = IZ + 1
      ! Abbruchkriterium ab 10 Iterationen
      IF( IZ .GT. 10 ) THEN
         CALL n1_mlt( d1, P, N2, N2 )        ! P = N2 * N2 ==> a
         CALL n1_sub( d1, D, a, P )          ! D = a - P
         Sd = 0.0D0
         DO I = 1, d1
            Sd = Sd + DABS( D(I) )
         END DO
         IF( Sd / Sa .LT. EPS ) L = .TRUE.
         IF( L ) THEN       ! Iteration steht
            CALL n1_move( d1, b, N2 )
            iERR = 0
            RETURN
         END IF
      END IF

      IF( IZ .LT. IMAX ) THEN
         CALL n1_move( d1, N1, N2 )   ! N1 = N2
         GO TO 100
      END IF

      ! max. Anzahl Iterationen ueberschritten
      iERR = IMAX
      CALL n1_move( d1, b, N2 )   ! b = N2
      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  Inverse von mb -> mi
C  IERR = 0 = okay, IERR > 0 = Fehler

      SUBROUTINE n1_inv( d1, mb, mi, IERR )

      IMPLICIT NONE

      INTEGER*4 d1, IERR
      REAL*8  mb(d1,d1), mi(d1,d1)

      REAL*8 EPS/ 1.0D-13 /   ! Schranke Determinante
      REAL*8 Det, Det1, Det2, Det3

      ! fr DPSEUDO
      INTEGER*2 M/ 3 /, ISTP
      REAL*8 Q1(3,3), Q2(3,3), R1(3,3), D(3)

      ! Sarrus / Cramersche Regel
      Det = mb(1,1)*mb(2,2)*mb(3,3) + mb(1,2)*mb(2,3)*mb(3,1)
     &    + mb(1,3)*mb(2,1)*mb(3,2) - mb(1,3)*mb(2,2)*mb(3,1)
     &    - mb(1,1)*mb(2,3)*mb(3,2) - mb(1,2)*mb(2,1)*mb(3,3)
      IF( DABS(Det) .GT. EPS ) THEN
         IERR = 0
         Det1 = mb(2,2)*mb(3,3) - mb(2,3)*mb(3,2)
         Det2 = mb(2,3)*mb(3,1) - mb(2,1)*mb(3,3)
         Det3 = mb(2,1)*mb(3,2) - mb(2,2)*mb(3,1)
         mi(1,1) = Det1 / Det
         mi(2,1) = Det2 / Det
         mi(3,1) = Det3 / Det
         Det1 = mb(1,3)*mb(3,2) - mb(1,2)*mb(3,3)
         Det2 = mb(1,1)*mb(3,3) - mb(1,3)*mb(3,1)
         Det3 = mb(1,2)*mb(3,1) - mb(1,1)*mb(3,2)
         mi(1,2) = Det1 / Det
         mi(2,2) = Det2 / Det
         mi(3,2) = Det3 / Det
         Det1 = mb(1,2)*mb(2,3) - mb(1,3)*mb(2,2)
         Det2 = mb(1,3)*mb(2,1) - mb(1,1)*mb(2,3)
         Det3 = mb(1,1)*mb(2,2) - mb(1,2)*mb(2,1)
         mi(1,3) = Det1 / Det
         mi(2,3) = Det2 / Det
         mi(3,3) = Det3 / Det
      ELSE
         IERR = 1
         CALL DPSEUDO( mb, M, M, mi, Q1, Q2, R1, D, EPS, ISTP )
      END IF

      RETURN

      END
C  ===========  DEADD  ===========
C  EINHEITSMATRIX ADDIEREN  REAL*8
C  D(N,N) = D(N,N) + E(N,N)

      SUBROUTINE DEADD( D, N )

      IMPLICIT NONE
 
      INTEGER*2 N, I, I1/1/
      REAL*8 D(N,N)
 
      DO 10, I = I1, N
      D(I,I) = D(I,I) + 1.0D0
   10 CONTINUE
      RETURN
      END
C  ============= DKLARm ===================
C  LOESCHEN MATRIX A(N,M) AUF NULL,  REAL*8

      SUBROUTINE DKLARM( A, N, M )

      IMPLICIT NONE

      INTEGER*2 N, M, I, J, I1
      PARAMETER ( I1=1 )
      REAL*8 A(N,M)

      DO 10, J = I1, M
      DO 10, I = I1, N
   10 A(I,J) = 0.0D0
      RETURN
      END
C  =======================
C  ZUWEISEN MATRIX B AUF A
C  A(N,M) = B(N,M)

      SUBROUTINE DMOVEM( A, B, N, M )

      IMPLICIT NONE

      INTEGER*2 N, M, I, J, I1/1/
      REAL*8 A(N,M), B(N,M)

      DO 10, J = I1, M
      DO 10, I = I1, N
   10 A(I,J) = B(I,J)
      RETURN
      END
C  ===================================================
C   TRANSPONIEREN MATRIX X(N,M) NACH XT(M,N)  (REAL-8)

      SUBROUTINE DMATTR( XT, X, N, M )

      IMPLICIT NONE

      INTEGER*2 N, M, I, J
      REAL*8 X(N,M), XT(M,N)

      DO 10, J = 1, M
      DO 10, I = 1, N
   10 XT(J,I)=X(I,J)
      RETURN
      END
C  ================ DMLTM  =================
C  C(NA,MB) = A(NA,MA) * B(MA,MB)   (REAL*8)

      SUBROUTINE DMLTM( A, NA, MA, B, MB, C )

      IMPLICIT NONE

      INTEGER*2 NA, MA, MB, I, J, K, I1
      PARAMETER ( I1=1 )
      REAL*8 A(NA,MA), B(MA,MB), C(NA,MB)

      CALL DKLARM( C, NA, MB )   ! C AUF NULL

      DO 10, I = I1, NA
      DO 20, J = I1, MA
      DO 30, K = I1, MB
      C(I,K) = C(I,K) + A(I,J) * B(J,K)
   30 CONTINUE
   20 CONTINUE
   10 CONTINUE
      RETURN
      END
C  ========= DMLTMTRL ===========================
C  AT(N,M) * B(M,L) = C(N,L)
C  ACHTUNG !!! AT IST ALS A(M,N)  GESPEICHERT !!!
 
      SUBROUTINE DMLTMTRL( AT, N, M, B, L, C )

      IMPLICIT NONE

      INTEGER*2 I, J, K, N, M, L, I1
      PARAMETER ( I1=1 )
      REAL*8 AT(M,N), B(M,L), C(N,L)

      CALL DKLARM( C, N, L )

      DO 10, I = I1, N
      DO 20, J = I1, M
      DO 30, K = I1, L
   30 C(I,K) = C(I,K) + AT(J,I) * B(J,K)
   20 CONTINUE
   10 CONTINUE
      RETURN
      END
C  ============= DPSEUDO ===============================
C  INVERTIEREN A(M,N) => AI(N,M);  M >= N;  A, AI REAL*8
C  ISTP=1 WENN A SPALTENSINGULAER SONST IST ISTP=0.

      SUBROUTINE DPSEUDO(A, M, N, AI, Q1, Q2, R1, D, EPS, ISTP )

      IMPLICIT NONE

      INTEGER*2 M, N, ISTP
      REAL*8 EPS, A(M,N), AI(N,M)
      REAL*8 Q1(M,M), Q2(N,N), R1(M,N), D(N)

      INTEGER*2 I, I0, I1, IP, IL, IA
      PARAMETER ( I0=0, I1=1 )

      CALL DKLARM( Q1, M, M )                 ! Q1 = E
      CALL DEADD ( Q1, M    )
      CALL DMOVEM( R1, A, M, N )              ! R1 = A

      CALL DQR_P( R1, M, N, Q1, D, EPS, ISTP )  ! Q * A = R

      IF( ISTP .EQ. I0 ) THEN
      CALL DKLARM( AI, N, M )                 ! AI(N,M) = 0
      IP = I1
      IL = N
      CALL DINVERSOD_P(R1, M, N, IP, IL, AI ) ! R1**-1 => AI
      CALL DMOVEM( R1, AI, N, M )             ! R1 = AI
      CALL DMLTM( R1, N, M, Q1, M, AI )       ! AI = R1I * Q1
      RETURN
      END IF

      CALL DKLARM( Q2, N, N )
      CALL DEADD ( Q2, N    )
      CALL DMATTR( AI, R1, M, N )
      CALL DQR_P( AI, N, N, Q2, D, EPS, ISTP )  ! Q2 * R1'
      CALL DMATTR( R1, AI, N, M )
      CALL DQR_P( R1, M, N, Q1, D, EPS, ISTP )

      CALL DKLARM( AI, N, M )

      IP = I0
      IL = I1

   10 CONTINUE
      IA = IP + IL
      IF( IA .GT. N ) GO TO 300
      DO 100, I = IA, N
      IF( DABS( R1(I,I)) .GT. EPS ) THEN
      IP = I
      GO TO 150
      END IF
  100 CONTINUE
      GO TO 300

  150 CONTINUE
      IL = I0
      DO 200, I = IP, N
      IF( DABS( R1(I,I)) .GT. EPS ) THEN
      IL = IL + I1
      ELSE
      GO TO 250
      END IF
  200 CONTINUE

  250 CALL DINVERSOD_P( R1, M, N, IP, IL, AI )
      GO TO 10

  300 CONTINUE

      CALL DMLTM( AI, N, M, Q1, M, R1 )
      CALL DMLTMTRL( Q2, N, N, R1, M, AI )

      RETURN
      END
C  ============ DQR_P ===================================
C  QR-ZERLEGUNG DER MATRIX A NACH HOUSEHOLDER (A = Q * R)
C  A(M,N)  = MATRIX A
C  QT(M,M) = MATRIX QT MIT:  QT * A = R
C            QT MUSS AUSSERHALB VON DQR AUF E GESETZT WERDEN !!!
C  R (M,N) = MATRIX R  MIT:  QT * A = R
C                  R IST IN A ABGESPEICHERT
C  D(N)    = HILFSVEKTOR D
C  M, N          = DIMENSIONEN VON A, QT, R, D
C  EPS     = SCHRANKE AB DER A SINGULAER, (GENAUIGKEIT R*8 )
C  ISTP    = ANZEIGE OB A SINGULAER( 0=NICHT SING., 1=SING. )

      SUBROUTINE DQR_P( A, M, N, QT, D ,EPS, ISTP )

      IMPLICIT NONE

      INTEGER*2 M, N, ISTP
      REAL*8 EPS, A(M,N), QT(M,M), D(N)

      REAL*8 SIGMA
      REAL*8 S
      REAL*8 BETA
      REAL*8 SUM

      INTEGER*2 I, J, K
      INTEGER*2 I0, I1
      PARAMETER ( I0=0, I1 = 1 )

      ISTP = I0    ! A NICHT SINGULAER

C  D = NULL
      DO 5, I = I1, N
      D( I )  = 0.0D0    ! D( I )  = 0.0
    5 CONTINUE

      DO 100, J = I1, N

      SIGMA = 0.0D0      ! SIGMA = 0.0

      DO 10, I = J, M
      SIGMA = SIGMA + A(I,J) * A(I,J)   ! SIGMA = SIGMA + A(I,J)**2
   10 CONTINUE

      IF( SIGMA .LT. EPS*EPS ) THEN
      ISTP = I1          ! A SINGULAER
      GO TO 100
      END IF

*     IF( J .LT. N ) THEN
*     IF( DSQRT(SIGMA-A(J,J)*A(J,J)) .LE. EPS ) THEN
*     ISTP = I1          ! A SINGULAER
*     GO TO 100
*     END IF
*     END IF

      IF( A(J,J) .LT. 0.0D0 ) THEN       ! (A(J,J).LT.0.0) ?
      S = DSQRT(SIGMA)                   ! S = SQRT(SIGMA)
      ELSE
      S = - DSQRT(SIGMA)                 ! S = -SQRT(SIGMA)
      END IF

      D(J) = S                           ! D(J) = S

      BETA = 1.0D0 / ( S * A(J,J) - SIGMA )  ! BETA =
      A(J,J) = A(J,J) - S                    ! A(J,J) = A(J,J) - S

      IF( J .EQ. N ) GO TO 45
      DO 20, K = J+I1, N
      SUM = 0.0D0          ! SUM = 0.0
      DO 30, I = J, M
      SUM = SUM + A(I,J) * A(I,K)    ! SUM = SUM + A(I,J) * A(I,K)
   30 CONTINUE
      SUM = BETA * SUM               ! SUM = BETA * SUM

      DO 40, I = J, M
      A(I,K) = A(I,K) + A(I,J) * SUM ! A(I,K) = A(I,K) + H
   40 CONTINUE

   20 CONTINUE

C  QT = P * QT
   45 CONTINUE
      DO 50, K = I1, M
      SUM = 0.0D0          ! SUM = 0.0
      DO 60, I = J, M
      SUM = SUM + A(I,J) * QT(I,K)   ! SUM = SUM + A(I,J) * QT(I,K)
   60 CONTINUE
      SUM = BETA * SUM               ! SUM = BETA * SUM

      DO 70, I = J, M
      QT(I,K) = QT(I,K) + A(I,J) * SUM   ! QT(I,K)=QT(I,K)+H
   70 CONTINUE
   50 CONTINUE

  100 CONTINUE

C  R IN A ZUENDE AUFBAUEN; DIAGONALELEMENTE AUS D
      DO 120, I = I1, N
      DO 120, J = I1, I
      IF( I .EQ. J ) THEN
      A(I,I) = D(I)       ! A(I,I) = D(I)
      ELSE
      A(I,J) = 0.0D0      ! A(I,J) = NULL
      END IF
  120 CONTINUE
      IF( M .GT. N ) THEN   ! NICHTQUADR. TEIL VON R AUF NULL
      DO 130, I = N+I1, M
      DO 130, J = I1, N
  130 A(I,J) = 0.0D0
      END IF

      RETURN
      END
C  ========== DINVERSOD_P ===========================
C  INVERTIEREN OBERE DREIECKSMATRIX A(M,N) => AI(N,M)
C  AI(N,M) MUSS VORHER VON AUSSEN AUF NULL GESETZT SEIN
C  IP IST POSITION AB DER INVERTIERT WIRD
C  IL IST DIMENSION INNERHALB DER A(M,N) INVERTIERT WIRD

      SUBROUTINE DINVERSOD_P( A, M, N, IP, IL, AI )

      IMPLICIT NONE

      INTEGER*2 M, N, IP, IL
      REAL*8 A(M,N), AI(N,M)

      INTEGER*2 I, J, K, II, JJ, KK, I1/1/
      REAL*8 H1

C  AI(I,I) = 1 / A(I,I)
      DO 10, I = I1, IL
      II = IP + I - I1
      AI(II,II) = 1.0D0 / A(II,II)
   10 CONTINUE

      IF( IL .EQ. I1 ) GO TO 900   ! FERTIG

      DO 100, I = I1, IL-I1
      II = IP + I - I1
      DO 200, J = I+I1, IL
      JJ = IP + J - I1
      H1 = 0.0D0
      DO 300, K = I1, J-I1
      KK = IP + K - I1
  300 H1 = H1 + AI(II,KK) * A(KK,JJ)
      AI(II,JJ) = -H1 * AI(JJ,JJ)
  200 CONTINUE
  100 CONTINUE

  900 RETURN
      END
