C  File:  n2_rr_op.for

C  07.03.2008

C  Autor:  G. Schnell

C  Arithmetische Operationen mit rekursiven Zahlen
C  Ordnung: n=2     Orientierung: o1=r, o2=r
C  n1 - Parameter: d1 = 2,3;  y,  e = ( e0 , e1 , e2  )
C  n2 - Parameter: d2 = 2,3; yy, ee = ( ee0, ee1, ee2 )
C  Ausgabe n1-Werte spaltenweise ( z.B.: yy, ee0, a0 ... )

C  n2-Elemente werden im Programm spaltenweise ausgegeben !
C  z. B. :  a = ( a0, a1 ) als
C           a0_0      a1_0
C           a0_1      a1_1


      IMPLICIT NONE

      INTEGER*4 d1, d2           ! Dimensionen zu n1, n2
      INTEGER*4 I1/1/
      INTEGER*4 I, IERR, d

      REAL*8 a(9)                ! 9 = Max. d1*d2
      REAL*8 b(9)                !
      REAL*8 c(9)                !
      REAL*8 j(9)                !
      REAL*8 h(9)                !
      REAL*8 u(9)                !

      REAL*8 ma(27), mb (27)     ! 27 = Max. d1*d2*d2
      REAL*8 mc(27), mai(27)     !


      REAL*8 y, e(3), e0, e1, e2
      EQUIVALENCE( e(1), e0 )
      EQUIVALENCE( e(2), e1 )
      EQUIVALENCE( e(3), e2 )
      COMMON / n1_com / y, e

      REAL*8 yy(3), ee(9)
      COMMON / n2_com / yy, ee


      CHARACTER*72 TXT

      INTEGER*4 IO_LI         ! I/O unit Liste
      INTEGER*4 IO_DAT        ! I/O unit Data
      CHARACTER*80 FILE_LI    ! Listfile
      CHARACTER*80 FILE_DAT   ! Datafile

      IO_DAT = 19   ! I/O Units setzen
      IO_LI  = 22   !

      ! Dateinamen:
      FILE_DAT = 'n2_rr_op.dat'
      FILE_LI  = 'n2_rr_op.ls'

      OPEN( UNIT=IO_DAT, FILE = FILE_DAT )
      OPEN( UNIT=IO_LI,  FILE = FILE_LI )

C  Daten von Datafile lesen

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! IO_DAT auf Datenzeile pos.
      READ(IO_DAT, '(A)' ) TXT          ! Text zur Aufgabe

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Laenge Zahl n1
      READ(IO_DAT, * ) d1
      IF( (d1.LT.2) .OR. (d1.GT.3) ) THEN
         WRITE(IO_LI,*) 'Laenge d1 = ', d1, ' nicht erlaubt.'
         STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Laenge Zahl n2
      READ(IO_DAT, * ) d2
      IF( (d2.LT.2) .OR. (d2.GT.3) ) THEN
         WRITE(IO_LI,*) 'Laenge d2 = ', d2, ' nicht erlaubt.'
         STOP
      END IF

      d = d1 * d2                       ! fuer inputs

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Wert y zu n1
      READ(IO_DAT, * ) y

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte e zu n1
      READ(IO_DAT, * ) ( e(I), I = 1, d1 )

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte y zu n2
      READ(IO_DAT, * ) ( yy(I), I = 1, d1 )

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte e zu n2
      READ(IO_DAT, * ) ( ee(I), I = 1, d )

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte von a
      READ(IO_DAT, * ) ( a(I), I = 1, d )

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Werte von b
      READ(IO_DAT, * ) ( b(I), I = 1, d )

      CLOSE ( IO_DAT )


      WRITE(IO_LI,*) 'Programm: n2_rr_op.exe'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Arithmetische Operationen mit rekursiven Zahlen'
      WRITE(IO_LI,*) 'Ordnung: n=2, Orientierung: o1=r, o2=r'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'n2-Elemente werden spaltenweise ausgegeben'
      WRITE(IO_LI,*) 'z. B. :  a = ( a0, a1 ) als'
      WRITE(IO_LI,*) '         a0_0      a1_0'
      WRITE(IO_LI,*) '         a0_1      a1_1'
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) TXT
      WRITE(IO_LI,*)
      WRITE(IO_LI,2000) d1
 2000 FORMAT('Ordnung n=1, Dimension d1 = ',I1)
      WRITE(IO_LI,*)
      WRITE(IO_LI,2010) d2
 2010 FORMAT('Ordnung n=2, Dimension d2 = ',I1)
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'n1-Parameter y:'
      CALL DPUT_v( IO_LI, I1, I1, y )
      WRITE(IO_LI,*)
      IF( d1 .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'n1-Parameter e: ( e0, e1 )'
      ELSE
         WRITE(IO_LI,*) 'n1-Parameter e: ( e0, e1, e2 )'
      END IF
      CALL DPUT_v( IO_LI, I1, d1, e(1) )
      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'n2-Parameter yy:'
      CALL DPUT_v( IO_LI, d1, I1, yy(1) )
      WRITE(IO_LI,*)
      IF( d2 .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'n2-Parameter ee: ( ee0, ee1 )'
      ELSE
         WRITE(IO_LI,*) 'n2-Parameter ee: ( ee0, ee1, ee2 )'
      END IF
      CALL DPUT_v( IO_LI, d1, d2, ee(1) )
      WRITE(IO_LI,*)
      IF( d2 .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'a=( a0, a1 )'
      ELSE
         WRITE(IO_LI,*) 'a=( a0, a1, a2 )'
      END IF
      CALL DPUT_v( IO_LI, d1, d2, a(1) )
      WRITE(IO_LI,*)
      IF( d2 .EQ. 2 ) THEN
         WRITE(IO_LI,*) 'b=( b0, b1 )'
      ELSE
         WRITE(IO_LI,*) 'b=( b0, b1, b2 )'
      END IF
      CALL DPUT_v( IO_LI, d1, d2, b(1) )
      WRITE(IO_LI,*)

      ! c = a + b
      CALL n2_add( d1, d2, c, a, b )
      WRITE(IO_LI,*) 'a + b'
      CALL DPUT_v( IO_LI, d1, d2, c(1) )
      WRITE(IO_LI,*)

      ! c = a - b
      CALL n2_sub( d1, d2, c, a, b )
      WRITE(IO_LI,*) 'a - b'
      CALL DPUT_v( IO_LI, d1, d2, c(1) )
      WRITE(IO_LI,*)

      ! c = a * b
      CALL n2_mlt( d1, d2, c, a, b )
      WRITE(IO_LI,*) 'a * b'
      CALL DPUT_v( IO_LI, d1, d2, c(1) )
      WRITE(IO_LI,*)

      ! c = b * a
      CALL n2_mlt( d1, d2, c, b, a )
      WRITE(IO_LI,*) 'b * a'
      CALL DPUT_v( IO_LI, d1, d2, c(1) )
      WRITE(IO_LI,*)

      ! c = a / b
      CALL n2_div( d1, d2, c, a, b, IERR)
      WRITE(IO_LI,*) 'a / b = 1/b * a'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, d2, c(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! c = b / a
      CALL n2_div( d1, d2, c, b, a, IERR)
      WRITE(IO_LI,*) 'b / a = 1/a * b'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, d2, c(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! ma = m(y,e,yy,ee,a)
      CALL n2_gen_ma_y( d1, d2, a, ma )
      WRITE(IO_LI,*) 'ma = m(y,e,yy,ee,a)'
      CALL DPUT_m( IO_LI, d1, d2, ma )

      ! mb = m(y,e,yy,ee,b)
      CALL n2_gen_ma_y( d1, d2, b, mb )
      WRITE(IO_LI,*) 'mb = m(y,e,yy,ee,b)'
      CALL DPUT_m( IO_LI, d1, d2, mb )

      ! mc = ma * mb
      CALL n2_mltm( d1, d2, mc, ma, mb )
      WRITE(IO_LI,*) 'ma * mb'
      CALL DPUT_m( IO_LI, d1, d2, mc )

      ! mc = mb * ma
      CALL n2_mltm( d1, d2, mc, mb, ma )
      WRITE(IO_LI,*) 'mb * ma'
      CALL DPUT_m( IO_LI, d1, d2, mc )

      ! Inverse mai von ma
      CALL n2_inv( d1, d2, ma, mai, IERR )

      ! mai drucken
      WRITE(IO_LI,*) 'mai = ma^(-1)'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_m( IO_LI, d1, d2, mai )
         ! mc = ma * mai
         CALL n2_mltm( d1, d2, mc, ma, mai )
         WRITE(IO_LI,*) 'ma * mai'
         CALL DPUT_m( IO_LI, d1, d2, mc )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF

      ! c = a / a = 1/a * a
      CALL n2_div( d1, d2, c, a, a, IERR )
      WRITE(IO_LI,*) 'a / a = 1/a * a = (f/j)'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, d2, c(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! j = ( (1,0,...), (0,0,...), ... )
      CALL n2_one( d1, d2, j )
      WRITE(IO_LI,*) 'j = ( (1,0,...), (0,0,...), ... )'
      CALL DPUT_v( IO_LI, d1, d2, c(1) )
      WRITE(IO_LI,*)

      ! a * j
      CALL n2_mlt( d1, d2, c, a, j )
      WRITE(IO_LI,*) 'a * j'
      CALL DPUT_v( IO_LI, d1, d2, c(1) )
      WRITE(IO_LI,*)

      ! c = 1/a * j * a = 1/a * a * j = j
      CALL n2_mlt( d1, d2, u, a, j )
      CALL n2_div( d1, d2, c, u, a, IERR )
      WRITE(IO_LI,*) ' 1/a * j * a = 1/a * a * j = j'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, d2, c(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! c = 1/a * b * a = 1/a * a * b = b
      CALL n2_mlt( d1, d2, h, a, b )
      CALL n2_div( d1, d2, c, h, a, IERR )
      WRITE(IO_LI,*) '1/a * b * a = 1/a * a * b = b'
      IF( IERR .EQ. 0 ) THEN
         CALL DPUT_v( IO_LI, d1, d2, c(1) )
      ELSE
         WRITE(IO_LI,*) 'iERR = ', IERR
      END IF
      WRITE(IO_LI,*)

      ! sqrt( a )
      WRITE(IO_LI,*) 'c = sqrt( a )'
      CALL n2_sqr( d1, d2, c, a, iERR )
      IF( (iERR .GT. 0) .AND. (iERR .LT. 10 ) ) THEN
         WRITE(IO_LI,*) 'Divisions-Fehler in n2_sqr(a)'
         WRITE(IO_LI,*) 'iERR = ', iERR
      ELSE
         IF( iERR .NE. 0 ) THEN
            WRITE(IO_LI,*) 'Achtung max. Anzahl Iterationen erreicht'
            WRITE(IO_LI,*) 'iERR = ', iERR
         END IF
         CALL DPUT_v( IO_LI, d1, d2, c )
         WRITE(IO_LI,*) 'Probe: c*c = a ?'
         CALL n2_mlt( d1, d2, u, c, c )
         CALL DPUT_v( IO_LI, d1, d2, u )
         WRITE(IO_LI,*) 'Delta: a - c*c'
         CALL n2_sub( d1, d2, h, a, u )
         CALL DPUT_v( IO_LI, d1, d2, h )
      END IF
      WRITE(IO_LI,*)

      ! sqrt( b )
      WRITE(IO_LI,*) 'c = sqrt( b )'
      CALL n2_sqr( d1, d2, c, b, iERR )
      IF( (iERR .GT. 0) .AND. (iERR .LT. 10 ) ) THEN
         WRITE(IO_LI,*) 'Divisions-Fehler in n2_sqr(b)'
         WRITE(IO_LI,*) 'iERR = ', iERR
      ELSE
         IF( iERR .NE. 0 ) THEN
            WRITE(IO_LI,*) 'Achtung max. Anzahl Iterationen erreicht'
            WRITE(IO_LI,*) 'iERR = ', iERR
         END IF
         CALL DPUT_v( IO_LI, d1, d2, c )
         WRITE(IO_LI,*) 'Probe: c*c = b ?'
         CALL n2_mlt( d1, d2, u, c, c )
         CALL DPUT_v( IO_LI, d1, d2, u )
         WRITE(IO_LI,*) 'Delta: b - c*c'
         CALL n2_sub( d1, d2, h, b, u )
         CALL DPUT_v( IO_LI, d1, d2, h )
      END IF

      CLOSE ( IO_LI )

      STOP

      END
C  ---------------------------------------------------
C  FILE_DAT = 'n2_rr_op.dat' fuers Lesen positionieren
C  und Kommentar- und Leer-Zeilen ueberlesen.

      SUBROUTINE UP_IN_POS( IO_IN, IO_LI )

      IMPLICIT NONE

      INTEGER*4 IO_IN, IO_LI, I
      CHARACTER*136 REC

   10 READ( IO_IN, '(A)', ERR=800, END=900 ) REC
      IF( REC(1:1) .EQ. '!' ) GO TO 10   ! Kommentarzeile ueberlesen
      DO 20, I = 1, 136
         IF( REC(I:I) .NE. ' ' ) THEN
            BACKSPACE IO_IN
            RETURN                       ! Datenzeile gefunden
         END IF
   20 CONTINUE
      GO TO 10                           ! Leerzeile ueberlesen

  800 WRITE( IO_LI, * ) 'Error beim Lesen von n2_rr_op.dat'
      STOP

  900 WRITE( IO_LI, * ) 'EOF erreicht beim Lesen von n2_rr_op.dat'
      STOP
      END
C  =========================================
C  ma(d1,d2,d2) drucken

      SUBROUTINE DPUT_m( IO_LI, d1, d2, ma )

      IMPLICIT NONE

      INTEGER*4 IO_LI, d1, d2, I, J, K
      REAL*8 ma(d1, d2, d2 )

      DO J = 1, d2
         DO I = 1, d1
            WRITE(IO_LI,1000) (ma(I,J,K), K=1,d2)
         END DO
         WRITE(IO_LI,*)
      END DO

      RETURN

 1000 FORMAT(1X,3(1P,D14.6,3X))

      END
C  ========================================
C  a(d1,d2) drucken

      SUBROUTINE DPUT_v( IO_LI, d1, d2, a )

      IMPLICIT NONE

      INTEGER*4 IO_LI, d1, d2, I, J
      REAL*8 a(d1, d2 )

      DO I = 1, d1
         WRITE(IO_LI,1000) (a(I,J), J=1,d2)
      END DO

      RETURN

 1000 FORMAT(1X,3(1P,D14.6,3X))

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = 0

      SUBROUTINE n1_zero( d1, a )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1)

      DO I = 1, d1
         a(I) = 0.0D0
      END DO

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  a = 0

      SUBROUTINE n2_zero( d1, d2, a )

      IMPLICIT NONE

      INTEGER*4 d1, d2, I
      REAL*8 a(d1,d2)

      DO I = 1, d2
         CALL n1_zero( d1, a(1,I) )
      END DO

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  a = 1

      SUBROUTINE n2_one( d1, d2, a )

      IMPLICIT NONE

      INTEGER*4 d1, d2, I
      REAL*8 a(d1,d2)

      DO I = 1, d2
         CALL n1_zero( d1, a(1,I) )
      END DO
      a(1,1) = 1.0D0

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = s (*) a      s ist ein Skalar

      SUBROUTINE n1_ska( d1, a, s )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1), s

      DO I = 1, d1
         a(I) = a(I) * s
      END DO

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  a = s (*) a      s ist ein Skalar 

      SUBROUTINE n2_ska( d1, d2, a, s )

      IMPLICIT NONE

      INTEGER*4 d1, d2, I
      REAL*8 a(d1,d2), s

      DO I = 1, d2
         CALL n1_ska( d1, a(1,I), s )
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  a = b

      SUBROUTINE n1_move( d1, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 a(d1), b(d1)

      DO I = 1, d1
         a(I) = b(I)
      END DO

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  a = b

      SUBROUTINE n2_move( d1, d2, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, d2, I
      REAL*8 a(d1,d2), b(d1,d2)

      DO I = 1, d2
         CALL n1_move( d1, a(1,I), b(1,I) )
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a + b

      SUBROUTINE n1_add( d1, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 c(d1), a(d1), b(d1)

      DO I = 1, d1
         c(I) = a(I) + b(i)
      END DO

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  c = a + b

      SUBROUTINE n2_add( d1, d2, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, d2, I
      REAL*8 c(d1,d2), a(d1,d2), b(d1,d2)

      DO I = 1, d2
         CALL n1_add( d1, c(1,I), a(1,I), b(1,I) )
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a - b

      SUBROUTINE n1_sub( d1, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, I
      REAL*8 c(d1), a(d1), b(d1)

      DO I = 1, d1
         c(I) = a(I) - b(i)
      END DO

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  c = a - b

      SUBROUTINE n2_sub( d1, d2, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, d2, I
      REAL*8 c(d1,d2), a(d1,d2), b(d1,d2)

      DO I = 1, d2
         CALL n1_sub( d1, c(1,I), a(1,I), b(1,I) )
      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  ma aus a

      SUBROUTINE n1_gen_ma_y( d1, a, ma )

      IMPLICIT NONE

      INTEGER*4 d1
      REAL*8 a(d1), ma(d1,d1), y2

      REAL*8 y, e(3), e0, e1, e2
      EQUIVALENCE( e(1), e0 )
      EQUIVALENCE( e(2), e1 )
      EQUIVALENCE( e(3), e2 )
      COMMON / n1_com / y, e

      IF( d1 .EQ. 2 ) THEN
         ma(1,1) =  a(1)
         ma(1,2) = -a(2) * e0
         ma(2,1) =  y * a(2)
         ma(2,2) =  y * ( a(1) - a(2)*e1 )
      ELSE IF( d1 .EQ. 3 ) THEN
         y2 = y*y
         ma(1,1) =  a(1)
         ma(1,2) = -a(3)*e0
         ma(1,3) = -a(2)*e0 + a(3)*e0*e2
         ma(2,1) =  y * a(2)
         ma(2,2) =  y * ( a(1) - a(3)*e1 )
         ma(2,3) =  y * (-a(2)*e1 - a(3)*e0 + a(3)*e1*e2 )
         ma(3,1) =  y2 * a(3)
         ma(3,2) =  y2 * ( a(2) - a(3)*e2 )
         ma(3,3) =  y2 * ( a(1) - a(2)*e2 + a(3)*e2*e2 )
      END IF

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  ma aus a

      SUBROUTINE n2_gen_ma_y( d1, d2, a, ma )

      IMPLICIT NONE

      INTEGER*4 d1, d2
      REAL*8 a(d1,d2), ma(d1,d2,d2)

      REAL*8 yy(3), ee(9)
      COMMON / n2_com / yy, ee

      REAL*8 y2(3)
      REAL*8 EE0(3), EE1(3), EE2(3)
      REAL*8 G(3), H(3), Z(3)

      IF( d2 .EQ. 2 ) THEN

         CALL n1_move( d1, EE0, ee(1) )              ! e0
         CALL n1_move( d1, EE1, ee(1+d1) )           ! e1

         ! ma(1,1) = a0
         CALL n1_move( d1, ma(1,1,1), a(1,1) )

         ! ma(1,2) = -a1 * e0
         CALL n1_mlt(  d1, H, a(1,2), EE0 )          ! H=a1*e0
         CALL n1_zero( d1, ma(1,1,2) )               ! ma(1,2)=0
         CALL n1_sub(  d1, ma(1,1,2), ma(1,1,2), H ) ! ma(1,2)=ma(1,2)-H

         ! ma(2,1) = y * a1
         CALL n1_mlt(  d1, ma(1,2,1), yy, a(1,2) )

         ! ma(2,2) = y * ( a0 - a1*e1 )
         CALL n1_mlt(  d1, H, a(1,2), EE1 )          ! H=a1*e1
         CALL n1_sub(  d1, Z, a(1,1), H )            ! Z=a0-H
         CALL n1_mlt(  d1, ma(1,2,2), YY, Z )        ! ma(2,2)=y*Z

      ELSE IF( d2 .EQ. 3 ) THEN

         CALL n1_move( d1, EE0, ee(1) )              ! e0
         CALL n1_move( d1, EE1, ee(1+d1) )           ! e1
         CALL n1_move( d1, EE2, ee(1+d1+d1) )        ! e2
         CALL n1_mlt(  d1, Y2, YY, YY )              ! y*y

         ! ma(1,1) = a0
         CALL n1_move( d1, ma(1,1,1), a(1,1) )

         ! ma(1,2) = -a2 * e0
         CALL n1_mlt(  d1, H, a(1,3), EE0 )          ! H=a2*e0
         CALL n1_zero( d1, ma(1,1,2) )               ! ma(1,2)=0
         CALL n1_sub(  d1, ma(1,1,2), ma(1,1,2), H ) ! ma(1,2)=ma(1,2)-H

         ! ma(1,3) = ( a2*e2 - a1 ) * e0
         CALL n1_mlt(  d1, H, a(1,3), EE2 )          ! H=a2*e2
         CALL n1_sub(  d1, Z, H, a(1,2) )            ! Z=H-a1
         CALL n1_mlt(  d1, ma(1,1,3), Z, EE0 )       ! ma(1,3)=Z*e0

         ! ma(2,1) = y * a1
         CALL n1_mlt(  d1, ma(1,2,1), YY, a(1,2) )

         ! ma(2,2) =  y * ( a0 - a2*e1 )
         CALL n1_mlt(  d1, H, a(1,3), EE1 )          ! H=a2*e1
         CALL n1_sub(  d1, Z, a(1,1), H )            ! Z=a0-H
         CALL n1_mlt(  d1, ma(1,2,2), YY, Z )        ! ma(2,2)=y*Z

         ! ma(2,3) =  y * ( ( a2*e2 - a1 )*e1 - a2*e0 )
         CALL n1_mlt(  d1, H, a(1,3), EE2 )          ! H=a2*e2
         CALL n1_sub(  d1, Z, H, a(1,2) )            ! Z=H-a1
         CALL n1_mlt(  d1, H, a(1,3), EE0 )          ! H=a2*e0
         CALL n1_sub(  d1, Z, Z, H )                 ! Z=Z-H
         CALL n1_mlt(  d1, ma(1,2,3), YY, Z )        ! ma(2,3)=y*Z

         ! ma(3,1) = y * y * a2
         CALL n1_mlt(  d1, ma(1,3,1), Y2, a(1,3) )

         ! ma(3,2) = y * y * ( a1 - a2*e2 )
         CALL n1_mlt(  d1, H, a(1,3), EE2 )          ! H=a2*e2
         CALL n1_sub(  d1, Z, a(1,2), H )            ! Z=a1-H
         CALL n1_mlt(  d1, ma(1,3,2), YY, Z )        ! ma(3,2)=y*y*Z

         ! ma(3,3) = y * y *( a0 - a2*e1 + (a2*e2-a1)*e2 )
         CALL n1_mlt(  d1, H, a(1,3), EE1 )          ! H=a2*e1
         CALL n1_sub(  d1, G, a(1,1), H )            ! G=a0-H
         CALL n1_mlt(  d1, H, a(1,3), EE2 )          ! H=a2*e2
         CALL n1_sub(  d1, Z, H, a(1,2) )            ! Z=H-a1
         CALL n1_mlt(  d1, H, Z, EE2 )               ! H=Z*e2
         CALL n1_add(  d1, Z, G, H )                 ! Z=G+H
         CALL n1_mlt(  d1, ma(1,3,3), Y2, Z )        ! ma(3,3)=y*y*Z

      END IF

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a * b

      SUBROUTINE n1_mlt( d1, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1
      REAL*8 c(d1), a(d1), b(d1)
      REAL*8 ma(9)       ! 9 = 3*3 = Maximum

      CALL n1_gen_ma_y( d1, a, ma )   ! ma aus a
      CALL n1_ma_v( d1, c, ma, b )    ! c = ma * b

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  c = a * b

      SUBROUTINE n2_mlt( d1, d2, c, a, b )

      IMPLICIT NONE

      INTEGER*4 d1, d2
      REAL*8 c(d1,d2), a(d1,d2), b(d1,d2)
      REAL*8 ma(27)          ! 27 = 3*3*3 = Maximum

      CALL n2_gen_ma_y( d1, d2, a, ma )
      CALL n2_ma_v( d1, d2, c, ma, b )

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  mc = ma * mb

      SUBROUTINE n2_mltm( d1, d2, mc, ma, mb )

      IMPLICIT NONE

      INTEGER*4 d1, d2, I
      REAL*8 mc(d1,d2,d2), ma(d1,d2,d2), mb(d1,d2,d2)

      DO I = 1, d2

         CALL n2_ma_v( d1, d2, mc(1,1,I), ma, mb(1,1,I) )

      END DO

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = a / b
C  IERR = 0 = okay,  IERR > 0 = Fehler

      SUBROUTINE n1_div( d1, c, a, b, IERR )

      IMPLICIT NONE

      INTEGER*4 d1, IERR
      REAL*8 c(d1), a(d1), b(d1)
      REAL*8 mb(9), mi(9)                ! 9 = 3*3 = Maximum

      CALL n1_gen_ma_y( d1, b, mb )      ! mb aus b
      CALL n1_inv( d1, mb, mi, IERR )    ! mi = mb^(-1)
      CALL n1_ma_v( d1, c, mi, a )       ! c = 1/b * a

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  c = a / b
C  IERR = 0 = okay,  IERR > 0 = Fehler

      SUBROUTINE n2_div( d1, d2, c, a, b, IERR )

      IMPLICIT NONE

      INTEGER*4 d1, d2, IERR
      REAL*8 c(d1,d2), a(d1,d2), b(d1,d2)
      REAL*8 mb(27), mi(27)     ! 27 = 3*3*3 = Maximum

      CALL n2_gen_ma_y( d1, d2, b, mb )      ! mb aus b
      CALL n2_inv( d1, d2, mb, mi, IERR )    ! mi = mb^(-1)
      CALL n2_ma_v( d1, d2, c, mi, a )       ! c = 1/b * a

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  c = ma * b

      SUBROUTINE n1_ma_v( d1, c, ma, b )

      IMPLICIT NONE

      INTEGER*4 d1
      REAL*8 c(d1), ma(d1,d1), b(d1)

      IF( d1 .EQ. 2 ) THEN
         c(1) = ma(1,1)*b(1) + ma(1,2)*b(2)
         c(2) = ma(2,1)*b(1) + ma(2,2)*b(2)
      ELSE IF( d1 .EQ. 3 ) THEN
         c(1) = ma(1,1)*b(1) + ma(1,2)*b(2) + ma(1,3)*b(3)
         c(2) = ma(2,1)*b(1) + ma(2,2)*b(2) + ma(2,3)*b(3)
         c(3) = ma(3,1)*b(1) + ma(3,2)*b(2) + ma(3,3)*b(3)
      END IF

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  c = ma * b

      SUBROUTINE n2_ma_v( d1, d2, c, ma, b )

      IMPLICIT NONE

      INTEGER*4 d1, d2
      REAL*8 c(d1,d2), ma(d1,d2,d2), b(d1,d2)
      REAL*8 G(3), H(3), Z(3)

      IF( d2 .EQ. 2 ) THEN

         CALL n1_mlt( d1, G, ma(1,1,1), b(1,1) )
         CALL n1_mlt( d1, H, ma(1,1,2), b(1,2) )
         CALL n1_add( d1, c(1,1), G, H )

         CALL n1_mlt( d1, G, ma(1,2,1), b(1,1) )
         CALL n1_mlt( d1, H, ma(1,2,2), b(1,2) )
         CALL n1_add( d1, c(1,2), G, H )

      ELSE IF( d2 .EQ. 3 ) THEN

         CALL n1_mlt( d1, G, ma(1,1,1), b(1,1) )
         CALL n1_mlt( d1, H, ma(1,1,2), b(1,2) )
         CALL n1_mlt( d1, Z, ma(1,1,3), b(1,3) )
         CALL n1_add( d1, c(1,1), G, H )
         CALL n1_add( d1, c(1,1), c(1,1), Z )

         CALL n1_mlt( d1, G, ma(1,2,1), b(1,1) )
         CALL n1_mlt( d1, H, ma(1,2,2), b(1,2) )
         CALL n1_mlt( d1, Z, ma(1,2,3), b(1,3) )
         CALL n1_add( d1, c(1,2), G, H )
         CALL n1_add( d1, c(1,2), c(1,2), Z )

         CALL n1_mlt( d1, G, ma(1,3,1), b(1,1) )
         CALL n1_mlt( d1, H, ma(1,3,2), b(1,2) )
         CALL n1_mlt( d1, Z, ma(1,3,3), b(1,3) )
         CALL n1_add( d1, c(1,3), G, H )
         CALL n1_add( d1, c(1,3), c(1,3), Z )

      END IF

      RETURN

      END
C  =================================
C  n=n1,  d=d1                Real*8
C  Inverse von ma -> mi
C  IERR = 0 = okay, IERR > 0 = Fehler

      SUBROUTINE n1_inv( d1, ma, mi, IERR )

      IMPLICIT NONE

      INTEGER*4 d1, IERR
      REAL*8 ma(d1,d1), mi(d1,d1)

      INTEGER*4 I, J
      REAL*8 EPS/ 1.0D-10 /   ! Schranke Determinante
      REAL*8 Det, Det1, Det2, Det3

      IF( d1 .EQ. 2 ) THEN
         ! Sarrus / Cramer
         Det = ma(1,1)*ma(2,2) - ma(1,2)*ma(2,1)
         IF( DABS(Det) .GT. EPS ) THEN
            IERR = 0
            mi(1,1) =  ma(2,2) / Det
            mi(2,1) = -ma(2,1) / Det
            mi(1,2) = -ma(1,2) / Det
            mi(2,2) =  ma(1,1) / Det
         ELSE
            IERR = 2
            mi(1,1) = 0.0D0
            mi(1,2) = 0.0D0
            mi(2,1) = 0.0D0
            mi(2,2) = 0.0D0
         END IF
      ELSE IF( d1 .EQ. 3 ) THEN
         ! Sarrus / Cramer
         Det = ma(1,1)*ma(2,2)*ma(3,3) + ma(1,2)*ma(2,3)*ma(3,1)
     &       + ma(1,3)*ma(2,1)*ma(3,2) - ma(1,3)*ma(2,2)*ma(3,1)
     &       - ma(1,1)*ma(2,3)*ma(3,2) - ma(1,2)*ma(2,1)*ma(3,3)
         IF( DABS(Det) .GT. EPS ) THEN
            IERR = 0
            Det1 = ma(2,2)*ma(3,3) - ma(2,3)*ma(3,2)
            Det2 = ma(2,3)*ma(3,1) - ma(2,1)*ma(3,3)
            Det3 = ma(2,1)*ma(3,2) - ma(2,2)*ma(3,1)
            mi(1,1) = Det1 / Det
            mi(2,1) = Det2 / Det
            mi(3,1) = Det3 / Det
            Det1 = ma(1,3)*ma(3,2) - ma(1,2)*ma(3,3)
            Det2 = ma(1,1)*ma(3,3) - ma(1,3)*ma(3,1)
            Det3 = ma(1,2)*ma(3,1) - ma(1,1)*ma(3,2)
            mi(1,2) = Det1 / Det
            mi(2,2) = Det2 / Det
            mi(3,2) = Det3 / Det
            Det1 = ma(1,2)*ma(2,3) - ma(1,3)*ma(2,2)
            Det2 = ma(1,3)*ma(2,1) - ma(1,1)*ma(2,3)
            Det3 = ma(1,1)*ma(2,2) - ma(1,2)*ma(2,1)
            mi(1,3) = Det1 / Det
            mi(2,3) = Det2 / Det
            mi(3,3) = Det3 / Det
         ELSE
            IERR = 3
            DO I = 1, 3
            DO J = 1, 3
               mi(I,J) = 0.0D0
            END DO
            END DO
         END IF
      ELSE
         IERR = 4
      END IF

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  Inverse von ma -> mi
C  IERR = 0 = okay, IERR > 0 = Fehler

      SUBROUTINE n2_inv( d1, d2, ma, mi, IERR )

      IMPLICIT NONE

      INTEGER*4 d1, d2, IERR
      REAL*8 ma(d1,d2,d2), mi(d1,d2,d2)

      Real*8 DET(3), DET1(3), DET2(3), DET3(3), DETm(3)
      Real*8 S1(3), S2(3), S3(3), S4(3), S5(3), S6(3)
      Real*8 G(3), H(3), Z(3)

      IF( d2 .EQ. 2 ) THEN

         ! Sarrus / Cramer
         ! DET = ma(1,1)*ma(2,2) - ma(1,2)*ma(2,1)
         CALL n1_mlt(d1, G, ma(1,1,1), ma(1,2,2) )
         CALL n1_mlt(d1, H, ma(1,1,2), ma(1,2,1) )
         CALL n1_sub(d1, DET, G, H )
         DETm(1) = -DET(1)
         DETm(2) = -DET(2)

         CALL n1_div( d1, mi(1,1,1), ma(1,2,2), DET , IERR )
         IF( IERR .NE. 0 ) RETURN
         CALL n1_div( d1, mi(1,2,1), ma(1,2,1), DETm, IERR )
         CALL n1_div( d1, mi(1,1,2), ma(1,1,2), DETm, IERR )
         CALL n1_div( d1, mi(1,2,2), ma(1,1,1), DET , IERR )

      ELSE IF( d2 .EQ. 3 ) THEN

         ! Sarrus / Cramer
!        Det = ma(1,1)*ma(2,2)*ma(3,3) + ma(1,2)*ma(2,3)*ma(3,1)
!            + ma(1,3)*ma(2,1)*ma(3,2) - ma(1,3)*ma(2,2)*ma(3,1)
!            - ma(1,1)*ma(2,3)*ma(3,2) - ma(1,2)*ma(2,1)*ma(3,3)
         CALL n1_mlt( d1, Z, ma(1,2,2), ma(1,3,3) )
         CALL n1_mlt( d1, S1, ma(1,1,1), Z )
         CALL n1_mlt( d1, Z, ma(1,2,3), ma(1,3,1) )
         CALL n1_mlt( d1, S2, ma(1,1,2), Z )
         CALL n1_mlt( d1, Z, ma(1,2,1), ma(1,3,2) )
         CALL n1_mlt( d1, S3, ma(1,1,3), Z )
         CALL n1_mlt( d1, Z, ma(1,2,2), ma(1,3,1) )
         CALL n1_mlt( d1, S4, ma(1,1,3), Z )
         CALL n1_mlt( d1, Z, ma(1,2,3), ma(1,3,2) )
         CALL n1_mlt( d1, S5, ma(1,1,1), Z )
         CALL n1_mlt( d1, Z, ma(1,2,1), ma(1,3,3) )
         CALL n1_mlt( d1, S6, ma(1,1,2), Z )
         CALL n1_add( d1, DET, S1, S2 )
         CALL n1_add( d1, DET, DET, S3 )
         CALL n1_sub( d1, DET, DET, S4 )
         CALL n1_sub( d1, DET, DET, S5 )
         CALL n1_sub( d1, DET, DET, S6 )

         !  Det1 = ma(2,2)*ma(3,3) - ma(2,3)*ma(3,2)
         !  Det2 = ma(2,3)*ma(3,1) - ma(2,1)*ma(3,3)
         !  Det3 = ma(2,1)*ma(3,2) - ma(2,2)*ma(3,1)
         !  mi(1,1) = Det1 / Det
         !  mi(2,1) = Det2 / Det
         !  mi(3,1) = Det3 / Det
         CALL n1_mlt( d1, S1, ma(1,2,2), ma(1,3,3) )
         CALL n1_mlt( d1, S2, ma(1,2,3), ma(1,3,2) )
         CALL n1_sub( d1, DET1, S1, S2 )
         CALL n1_mlt( d1, S1, ma(1,2,3), ma(1,3,1) )
         CALL n1_mlt( d1, S2, ma(1,2,1), ma(1,3,3) )
         CALL n1_sub( d1, DET2, S1, S2 )
         CALL n1_mlt( d1, S1, ma(1,2,1), ma(1,3,2) )
         CALL n1_mlt( d1, S2, ma(1,2,2), ma(1,3,1) )
         CALL n1_sub( d1, DET3, S1, S2 )
         CALL n1_div( d1, mi(1,1,1), DET1, DET , IERR )
         IF( IERR .NE. 0 ) RETURN
         CALL n1_div( d1, mi(1,2,1), DET2, DET , IERR )
         CALL n1_div( d1, mi(1,3,1), DET3, DET , IERR )

         !  Det1 = ma(1,3)*ma(3,2) - ma(1,2)*ma(3,3)
         !  Det2 = ma(1,1)*ma(3,3) - ma(1,3)*ma(3,1)
         !  Det3 = ma(1,2)*ma(3,1) - ma(1,1)*ma(3,2)
         !  mi(1,2) = Det1 / Det
         !  mi(2,2) = Det2 / Det
         !  mi(3,2) = Det3 / Det
         CALL n1_mlt( d1, S1, ma(1,1,3), ma(1,3,2) )
         CALL n1_mlt( d1, S2, ma(1,1,2), ma(1,3,3) )
         CALL n1_sub( d1, DET1, S1, S2 )
         CALL n1_mlt( d1, S1, ma(1,1,1), ma(1,3,3) )
         CALL n1_mlt( d1, S2, ma(1,1,3), ma(1,3,1) )
         CALL n1_sub( d1, DET2, S1, S2 )
         CALL n1_mlt( d1, S1, ma(1,1,2), ma(1,3,1) )
         CALL n1_mlt( d1, S2, ma(1,1,1), ma(1,3,2) )
         CALL n1_sub( d1, DET3, S1, S2 )
         CALL n1_div( d1, mi(1,1,2), DET1, DET , IERR )
         CALL n1_div( d1, mi(1,2,2), DET2, DET , IERR )
         CALL n1_div( d1, mi(1,3,2), DET3, DET , IERR )

         !  Det1 = ma(1,2)*ma(2,3) - ma(1,3)*ma(2,2)
         !  Det2 = ma(1,3)*ma(2,1) - ma(1,1)*ma(2,3)
         !  Det3 = ma(1,1)*ma(2,2) - ma(1,2)*ma(2,1)
         !  mi(1,3) = Det1 / Det
         !  mi(2,3) = Det2 / Det
         !  mi(3,3) = Det3 / Det
         CALL n1_mlt( d1, S1, ma(1,1,2), ma(1,2,3) )
         CALL n1_mlt( d1, S2, ma(1,1,3), ma(1,2,2) )
         CALL n1_sub( d1, DET1, S1, S2 )
         CALL n1_mlt( d1, S1, ma(1,1,3), ma(1,2,1) )
         CALL n1_mlt( d1, S2, ma(1,1,1), ma(1,2,3) )
         CALL n1_sub( d1, DET2, S1, S2 )
         CALL n1_mlt( d1, S1, ma(1,1,1), ma(1,2,2) )
         CALL n1_mlt( d1, S2, ma(1,1,2), ma(1,2,1) )
         CALL n1_sub( d1, DET3, S1, S2 )
         CALL n1_div( d1, mi(1,1,3), DET1, DET , IERR )
         CALL n1_div( d1, mi(1,2,3), DET2, DET , IERR )
         CALL n1_div( d1, mi(1,3,3), DET3, DET , IERR )

      END IF

      RETURN

      END
C  =================================
C  n=n2,  d=d2                Real*8
C  b = sqrt( a )  babylonisches Verfahren
C  b = a^(1/r)    fuer n1_sqr ist r=2
C  N1 ist 1. Naeherung   z. B.: N1 = ( 1, 1, 1 )
C  N2 = [ (r-1)*N1 + a / N1^(r-1) ] / r
C  iERR = 0 = kein Fehler

      SUBROUTINE n2_sqr( d1, d2, b, a, iERR )

      IMPLICIT NONE

      INTEGER*4 d1, d2, iERR
      REAL*8 b(d1,d2), a(d1,d2)

      LOGICAL*4 L
      INTEGER*4 I, J, IZ, IMAX/ 100 /   ! Max. d1*d2=9
      REAL*8 N1(9), N2(9), Q(9), F/0.5D0/
      REAL*8 Sa, Sd, P(9), D(9), EPS/ 1.0D-15 /

      ! Pruefen ob a = 0
      DO I = 1, d1
      DO J = 1, d2
         IF( a(I,J) .NE. 0.0D0 ) GO TO 10
      END DO
      END DO
      CALL n1_zero( d1, b )   ! b = 0
      iERR = 0
      RETURN

   10 CONTINUE
      CALL n2_zero( d1, d2, b )               ! Naeherung N1
      b(1,1)  =  0.5D0                        ! b(1,1)
      b(1,d1) = -0.5D0                        ! b(1,d1) 
      b(1,d2)  =  0.5D0                       ! b(1,d2) 
      b(d1,d2) = -0.5D0                       ! b(d1,d2)
      CALL n2_div( d1, d2, N1, a, b, iERR )   ! N1 = a / b

      IZ = 0
      ! Abbruchkriterium Teil 1,  abs. Norm
      Sa = 0.0D0
      DO I = 1, d1
      DO J = 1, d2
         Sa = Sa + DABS( a(I,J) )
      END DO
      END DO

      L = .FALSE.

  100 CALL n2_div( d1, d2, Q, a, N1, iERR )   ! Q = a / N1
      IF( iERR .NE. 0 ) THEN
         CALL n2_zero( d1, d2, b )            ! b = 0
         RETURN
      END IF
      CALL n2_add( d1, d2, N2, N1, Q )        ! N2 = N1 + Q
      CALL n2_ska( d1, d2, N2, F )            ! N2 = N2 * 0.5

      IZ = IZ + 1
      ! Abbruchkriterium ab 10 Iterationen
      IF( IZ .GT. 10 ) THEN
         CALL n2_mlt( d1, d2, P, N2, N2 )        ! P = N2 * N2 ==> a
         CALL n2_sub( d1, d2, D, a, P )          ! D = a - P
         Sd = 0.0D0
         DO I = 1, d1*d2
            Sd = Sd + DABS( D(I) )
         END DO
         IF( Sd / Sa .LT. EPS ) L = .TRUE.
         IF( L ) THEN       ! Iteration steht
            CALL n2_move( d1, d2, b, N2 )
            iERR = 0
            RETURN
         END IF
      END IF

      IF( IZ .LT. IMAX ) THEN
         CALL n2_move( d1, d2, N1, N2 )   ! N1 = N2
         GO TO 100
      END IF

      ! max. Anzahl Iterationen ueberschritten
      iERR = IMAX
      CALL n2_move( d1, d2, b, N2 )   ! b = N2
      RETURN

      END