C  File:  pascal_it.for

C  28.12.2007

C  Untersuchen FRS-Matrizen,  Primzahltest/Teiler

      IMPLICIT NONE

      LOGICAL*4 LPRIM  ! LOGICAL*4 Function

      INTEGER*4 FN_1   ! F( n-1 )   Modulo - Reste der Folge
      INTEGER*4 FN     ! F( n   )          "
      INTEGER*4 FN1    ! F( n+1 )          "

      LOGICAL*4 LP

      INTEGER*4 NA,  NE , N      ! Anfangs- und Endwert N
      INTEGER*4 NNT/ 0 /         ! letztes teilbares N ohne gefundenen Teiler

      INTEGER*4 N_MAX, M
      INTEGER*4 T, X, Y, Z, iQ
      INTEGER*4 N_COUNT, PRIM_COUNT, PSP_COUNT, APSP_COUNT
      INTEGER*4 T_COUNT     ! Anzahl der ausgewaehlten N mit gefundenem Teiler 
      INTEGER*4 NT_COUNT    ! Anzahl als teilbar erkannten, ausgewaehlten N

      CHARACTER*1 CH_P      ! 'p' = Zahl N ist prim
      CHARACTER*1 CH_P_alt  ! 't' = Zahl N ist teilbar
                            ! 'f' = Zahl N ist pseudoprim zur Basis 2
                            ! 'a' = Zahl N ist absolut pseudoprim

      REAL*8 FM( 3, 3 )          ! Matrix
      REAL*8 V( 3 )              ! Start-Vektor

      INTEGER*4 iBAS
      REAL*8 BAS                 ! Basis fuer Test auf pseudoprim

      INTEGER*4 IST_KZ           ! Auswahlkriterium fuer Zahlen N
      ! Auswaehlen Zahlen N mit iST_KZ:
      ! iST_KZ = 0 : nur prime      Zahlen N auswaehlen
      ! iST_KZ = 1 : alle teilbaren Zahlen N auswaehlen
      ! iST_KZ = 2 : nur psp        Zahlen N auswaehlen
      ! iST_KZ = 3 : nur apsp       Zahlen N auswaehlen
      ! iST_KZ = 4 : nur quadrat.   Zahlen N auswaehlen

      REAL*8 b, Kx               ! Basis-Zahlen fuer FRS-Matrizen
      INTEGER*4 b_anf, b_end, ib ! Basis-Zahlen fuer FRS-Matrizen

      INTEGER*4 dX, dY, dZ       ! Deltas zu X, Y, Z

      REAL*8 P, RS               ! Hz

      REAL*8 FMN( 3, 3 )         ! FMN == FM^(n-2) ( Kongruenz-Matrix )
      COMMON / TEST / FMN        !

      LOGICAL*4 LMAT             ! True, wenn FRS-Matrizen. zu drucken
      LOGICAL*4 LMOD             ! True, wenn Kongruenzmat. zu drucken
      LOGICAL*4 LPSP             ! True, wenn Zahl N psp
      LOGICAL*4 LAPSP            ! True, wenn Zahl N absolut psp
      LOGICAL*4 LTF              ! True, wenn Teiler eines N gefunden
      LOGICAL*4 LMP              ! True, wenn Muster prim/pseudoprim gefunden
      LOGICAL*4 LNT              ! True, wenn N definitiv teilbar

      INTEGER*4 FT( 25 ), IANZ   ! Feld fuer alle IANZ Teiler von N
      INTEGER*4 FD( 25 ), JANZ   ! Feld fuer Teiler von N, keine doppelten

      INTEGER*4 I0, I, J

      CHARACTER*76 TXT     ! Text fuer Ausgabe im Programm

      CHARACTER*(*) FMT1
      PARAMETER ( FMT1 = '(4X,5E14.7)' )   ! Real Ausgaben

      INTEGER*4 IO_LI          ! Unit zu FILE_LI
      INTEGER*4 IO_DAT         ! Unit zu FILE_DAT
      CHARACTER*80 FILE_DAT    ! Dateiname zu IO_DAT
      CHARACTER*80 FILE_LI     ! Dateiname zu IO_LI

      DATA N_MAX/20 000 000 /  ! ungefaehres Maximum fuer Real*8 Rechn.
!     DATA N_MAX/ 9 999 999 /  ! ungefaehres Maximum fuer Real*8 Rechn.
      DATA BAS/ 2 /
      DATA I0/ 0 /, M/ 3 /

      IO_DAT = 19   ! I/O Units setzen
      IO_LI  = 22   !

      ! Dateinamen:
      FILE_DAT = 'pascal_it.dat'
      FILE_LI  = 'pascal_it.ls'

      OPEN( UNIT=IO_DAT, FILE = FILE_DAT )
      OPEN( UNIT=IO_LI,  FILE = FILE_LI )   ! F77 Standard

C  Daten von Datafile lesen

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! IO_DAT auf Datenzeile pos.
      READ(IO_DAT, '(A)' ) TXT          ! Text zur Aufgabe

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Anfangs- und Endwert N
      READ(IO_DAT, * ) NA, NE
      IF( (NA.LT.3) .OR. (NE.GT.N_MAX) .OR. (NA.GT. NE) ) THEN
         WRITE(*,*) 'Na = ', NA, ' Ne = ', NE, ' nicht erlaubt.'
         STOP
      END IF
      IF( MOD( NA, 2 ) .EQ. 0 ) THEN
      !  WRITE(*,*) 'Na = ', NA, ' Nur ungerades Na ist erlaubt.'
      !  STOP
      END IF

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Kongruenzmatrix drucken ?
      READ(IO_DAT, * ) LMAT, LMOD       ! LMAT fuer FRS-Matrizen
                                        ! LMOD fuer Kongruenzmatrizen

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Auswahlkriterium N
      READ(IO_DAT, * ) IST_KZ

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Basis fuer Test N auf psp
      READ(IO_DAT, * ) iBAS

      CALL UP_IN_POS( IO_DAT, IO_LI )   ! Basis-Zahlen fuer FRS-Matrizen
      READ(IO_DAT, * ) b_anf, b_end
      IF( (b_anf.LT.-1).OR.(b_end.GT.200).OR.(b_anf.GT.b_end) ) THEN
         WRITE(*,*)'b_anf = ',b_anf, ' b_end = ',b_end,' nicht erlaubt.'
         STOP
      END IF

      CLOSE ( IO_DAT )

      WRITE(IO_LI,*) 'Programm:  pascal_it.exe'
      WRITE(IO_LI,*)

      N = LEN( TXT )
      DO I = N, 1, -1
         IF( TXT(I:I) .NE. ' ' ) GO TO 10
      END DO
      I = 1
   10 CONTINUE
      WRITE(IO_LI,*) TXT(1:I)   ! keine Space drucken

      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Test fuer N im Bereich Na bis Ne.'
      WRITE(IO_LI,*)
 2030 FORMAT('Na = ',I7,'   Ne = ',I7,/)
      WRITE(IO_LI,2030) NA, NE

      WRITE(IO_LI,*) 'LMAT      = ', LMAT
      WRITE(IO_LI,*) 'LMOD      = ', LMOD
      WRITE(IO_LI,*)

      IF( iST_KZ .EQ. 1 ) THEN
         WRITE(IO_LI,*)  'iST_KZ = 1: Es werden alle teilbaren N ',
     +                   'untersucht.'
      ELSE IF( iST_KZ .EQ. 2 ) THEN
         WRITE(IO_LI,*)  'iST_KZ = 2: Es werden nur psp N ',
     +                   'untersucht.'
      ELSE IF( iST_KZ .EQ. 3 ) THEN
         WRITE(IO_LI,*)  'iST_KZ = 3: Es werden nur apsp N ',
     +                   'untersucht.'
      ELSE IF( iST_KZ .EQ. 0 ) THEN
         WRITE(IO_LI,*)  'iST_KZ = 0: Es werden nur prime N ',
     +                   'untersucht.'
      ELSE IF( iST_KZ .EQ. 4 ) THEN
         WRITE(IO_LI,*)  'iST_KZ = 4: Es werden nur quadr. N ',
     +                   'untersucht.'
      END IF

      WRITE(IO_LI,*)
      WRITE(IO_LI,*)  'Basis psp-Kriterium = ', iBAS

      WRITE(IO_LI,*)
      WRITE(IO_LI,*) 'Basis-Zahlen fuer FRS-Matrizen:'
 2040 FORMAT('b_anf = ',I4,'     b_end = ',I4)
      WRITE(IO_LI,2040) b_anf, b_end
      WRITE(IO_LI,*)


      ! Zur Erinnerung: zwischen 2 und 100 000 liegen 9592 Primzahlen
      !                          2   1 000 000    "   78 498   "

      N_COUNT    = 0   ! Anzahl untersuchter Zahlen N
      PRIM_COUNT = 0   ! davon Anzahl Primzahlen
      PSP _COUNT = 0   ! davon Anzahl frs-Pseudoprimzahlen
      APSP_COUNT = 0   ! davon Anzahl absolute Pseudoprimzahlen
      T_COUNT    = 0   ! Anzahl N mit gefundenen Teilern
      NT_COUNT   = 0   ! Anzahl teilbare N

      ! FRS-Matrizen vorbesetzen
      FM(1,1) = 0.0
      FM(1,2) = 1.0
      FM(1,3) = 0.0
      FM(2,1) = 0.0
      FM(2,2) = 0.0
      FM(2,3) = 1.0
       V(1)   = 1.0
       V(2)   = 0.0

      IF( LMAT ) THEN   ! FRS-Matrizen drucken ?
         DO iB = b_anf, b_end
            IF( iB .NE. 0 ) THEN
               b = iB
               Kx = ( 10.0D0 + 7.0D0*b + b*b ) / 2.0D0
               FM(3,1) =  1.0D0   ! u
               FM(3,2) = -Kx      ! v
               FM(3,3) =  Kx      ! w
               WRITE(IO_LI,*) 'b = ', iB
               CALL DPUT( FM, IO_LI, FMT1, M, M, I0, I0 )
            END IF
         END DO
         WRITE(IO_LI,*)
      END IF

      WRITE(IO_LI,*)
     +   '    N p/t/f/a    x       y       z'
      WRITE(IO_LI,*)

      DO 200, N = NA, NE, 2      ! Werte-Bereich N

         P = N                   ! P = Real*8
         N_COUNT = N_COUNT + 1   ! Anzahl untersuchter N
         LTF = .FALSE.           ! Reset, Teiler eines N gefunden

         LAPSP = .FALSE.
         L PSP = .FALSE.

         LP = LPRIM( (N), T )    ! LP=True/False, T = Teiler N
         IF( LP ) THEN           ! N prim ?
            PRIM_COUNT = PRIM_COUNT + 1
            CH_P = 'p'
         ELSE
            CH_P = 't'
            ! pruefen ob N pseudoprim zur Basis 2, 3, 4, ...
            BAS = iBAS
            CALL SIEB( BAS, P, -BAS, P, RS )  ! 2^P-2 == RS mod P
               LPSP  = .FALSE.
               ! pruefen ob N absolut pseudoprim ( apsp )
               CALL TEILER( (N), FT, IANZ, LAPSP )
            DO I = 1, IANZ    ! FD = FT
               FD(I) = FT(I)
            END DO
            JANZ = IANZ
  100       CONTINUE
            DO I = 1, Janz-1    ! Gleiche Teiler aus FD( ) entfernen !
            DO J = I+1, JANZ    ! Sortierung nicht mehr aufsteigend  !
               IF( FD(I) .EQ. FD(J) ) THEN
                   FD(J) = FD(IANZ)
                   JANZ = JANZ - 1
                   GO TO 100
               END IF
            END DO
            END DO
            IF( RS .EQ. 0.0D0 ) THEN
               CH_P  = 'f'       ! P psp bzgl. Basis: 2,3,4, ...
               LPSP  = .TRUE.
               IF( LAPSP ) THEN
                  CH_P = 'a'     ! 'a' fuer apsp
                  APSP_COUNT = APSP_COUNT + 1
               ELSE
                  PSP_COUNT = PSP_COUNT + 1
               END IF
            END IF
         END IF

         ! Auswaehlen Zahlen N
         ! iST_KZ = 0 : nur prime      Zahlen N auswaehlen
         ! iST_KZ = 1 : alle teilbaren Zahlen N auswaehlen
         ! iST_KZ = 2 : nur psp        Zahlen N auswaehlen
         ! iST_KZ = 3 : nur apsp       Zahlen N auswaehlen
         ! iST_KZ = 4 : nur quadrat.   Zahlen N auswaehlen

         IF( IST_KZ.EQ.0 .AND. .NOT. LP    ) GO TO 200
         IF( IST_KZ.EQ.1 .AND.       LP    ) GO TO 200
         IF( IST_KZ.EQ.2 .AND. (     LP
     +        .OR. LAPSP .OR.  .NOT. LPSP )) GO TO 200
         IF( IST_KZ.EQ.3 .AND. .NOT. LAPSP ) GO TO 200
         IF( IST_KZ.EQ.4 ) THEN
            iQ = DSQRT( P )
            IF( iQ*iQ .NE. P ) GO TO 200
         END IF

         IF( .NOT. LP ) THEN
            WRITE(IO_LI,*) 'Teiler N:'
            WRITE(IO_LI,2020) (FT(I),I=1,IANZ)  ! alle Teiler N
            WRITE(IO_LI,*)
         END IF

         LNT = .FALSE.
         CH_P_alt = CH_P

         DO b = b_anf, b_end

            iB = b

!           IF( iB .EQ. -2 ) GO TO 190   ! b = -2 ueberlesen

               Kx = ( 10.0D0 + 7.0D0*b + b*b ) / 2.0D0
               FM(3,1) =  1.0D0   ! u
               FM(3,2) = -Kx      ! v
               FM(3,3) =  Kx      ! w
               V(3)    = FM(3,2)

            ! Fixpunkte berechnen ( F^(N-2) * V  modulo N )
            CALL FN_AB( FM, V, (N), FN_1, FN, FN1, (N) )

            ! x,y,z: Fixpunkte, Sattelpunkte, Summenpunkte ?
            X = FN_1
            Y = FN
            Z = FN1

            CALL UP_MP( N, x, y, z, Kx, LMP )   ! N prim/pseudoprim
            IF( .NOT. LMP ) THEN
               LNT = .TRUE.
               CH_P = 'T'
            ELSE
               CH_P = CH_P_alt
            END IF

            IF( .NOT. LP ) THEN
               WRITE(IO_LI,2000) N, CH_P, FN_1, FN, FN1, iB
               IF( IST_KZ .EQ. 4 ) THEN   ! N quadratisch ?
                  CALL UP_IT( dX, X, iQ )
                  CALL UP_IT( dY, Y, iQ )
                  CALL UP_IT( dZ, Z, iQ )
                  WRITE(IO_LI,2010) iQ, dX, dY, dZ
                  IF( (x.GT.1) .AND. (dx.EQ.0) ) LTF = .TRUE.   ! standard
                  IF( (y.GT.1) .AND. (dy.EQ.-1)) LTF = .TRUE.   ! standard
                  IF( (z.GT.1) .AND. (dz.EQ.0) ) LTF = .TRUE.   ! standard
!                 IF( (z.GT.1) .AND. (dz.EQ.1) ) LTF = .TRUE.   ! extra
               ELSE
                  DO I = 1, JANZ
                     CALL UP_IT( dX, X, FD(I) )
                     CALL UP_IT( dY, Y, FD(I) )
                     CALL UP_IT( dZ, Z, FD(I) )
                     WRITE(IO_LI,2010) FD(I), dX, dY, dZ
                     IF( (x.GT.1) .AND. (dx.EQ.0) ) LTF = .TRUE.   ! standard
                     IF( (y.GT.1) .AND. (dy.EQ.-1)) LTF = .TRUE.   ! standard
                     IF( (z.GT.1) .AND. (dz.EQ.0) ) LTF = .TRUE.   ! standard
!                    IF( (z.GT.1) .AND. (dz.EQ.1) ) LTF = .TRUE.   ! extra
                  END DO
               END IF
            ELSE
               WRITE(IO_LI,2000) N, CH_P, FN_1, FN, FN1, iB
            END IF

            IF( LMOD ) THEN   ! Kongruenzmatrix drucken ?
               CALL DPUT( FMN, IO_LI, FMT1, M, M, I0, I0 )
            END IF

  190    CONTINUE   ! Einsprung: b = 0 ueberlesen

         END DO     ! b-Schleife

         IF( LTF ) T_COUNT = T_COUNT + 1
         IF( LNT ) NT_COUNT = NT_COUNT + 1
         IF( .NOT. LTF ) NNT = N           ! Teiler N nicht gefunden

         WRITE(IO_LI,*)

 2000 FORMAT(1X,I7,1X,1A,3I8,'   b = ',I5)
 2010 FORMAT(1X,I9,3I8)
 2020 FORMAT(2X,5I8,9(/2X,5I8))

  200 CONTINUE    ! Ende, Schleife N

         WRITE(IO_LI,*)
         WRITE(IO_LI,*) '     N_COUNT   = ',      N_COUNT
         WRITE(IO_LI,*)
         WRITE(IO_LI,*) '  PRIM_COUNT   = ',   PRIM_COUNT
         WRITE(IO_LI,*)
         WRITE(IO_LI,*) '   PSP_COUNT   = ',   PSP _COUNT
         WRITE(IO_LI,*)
         WRITE(IO_LI,*) '  APSP_COUNT   = ',   APSP_COUNT
         WRITE(IO_LI,*)
         WRITE(IO_LI,*) '     T_COUNT   = ',      T_COUNT
         WRITE(IO_LI,*)
         WRITE(IO_LI,*) '    NT_COUNT   = ',     NT_COUNT

         IF( IST_KZ .NE. 0 ) THEN
            WRITE(IO_LI,*)
            WRITE(IO_LI,*) '         NNT   = ',    NNT
         END IF

      CLOSE ( IO_LI )

      STOP

      END
C  ---------------------------------------------------
C  Pruefen Reste x,y,z auf Muster fuer prim/pseudoprim
C  LMP = .TRUE. = Prim-Muster gefunden

      SUBROUTINE UP_MP( N, x, y, z, Kx, LMP )

      IMPLICIT NONE

      INTEGER*4 N, x, y, z
      LOGICAL*4 LMP
      REAL*8 Kx,   DN

      LMP = .FALSE.

      IF( ( X .EQ. 0 ) .AND.           ! Normalfall
     +    ( Y .EQ. 1 ) .AND.
     +    ( Z .EQ. 0 ) ) THEN
             LMP = .TRUE.
             RETURN                    ! N prim / pseudoprim
      END IF

      IF( ( X .EQ. DN-3.0D0 ) .AND.    ! N = 3, 11, ... prim
     +    ( Y .EQ. 0 )        .AND.
     +    ( Z .EQ. 1 ) ) THEN
             LMP = .TRUE.
             RETURN                    ! N prim / pseudoprim
      END IF

      ! x == -(Kx^2-1) mod n, y == -Kx mod n, z = 0
      DN = N
      IF( ( DMOD( Kx*Kx-1.0D0+x, DN ) .EQ. 0.0D0 ) .AND.
     +    ( DMOD( Kx+y, DN ) .EQ. 0.0D0 )          .AND.
     +    ( Z   .EQ.  0 ) ) THEN
             LMP = .TRUE.
             RETURN                    ! N prim / pseudoprim
      END IF

      RETURN

      END
C  --------------------------
C  LPRIM = true falls P prim.
C  Einfachst-Methode durch Probieren bis SQRT( P ).
C  T = Teiler von P oder 1

      LOGICAL*4 FUNCTION LPRIM( P, T )

      IMPLICIT NONE

      INTEGER*4 P, T, L, LE
      REAL*8 D

      T = 1

      IF( P .EQ. 2 ) THEN
         LPRIM = .TRUE.
         RETURN
      END IF

      LPRIM = .FALSE.

      IF( MOD( P, 2 ) .EQ. 0 ) THEN
         T = 2
         RETURN
      END IF

      D = P
      LE = DSQRT( DABS( D ) ) + .1D0

      DO 100, L = 3, LE, 2
         IF( MOD( P, L ) .EQ. 0 ) THEN
            T = L
            RETURN
         END IF
  100 CONTINUE

      LPRIM = .TRUE.

      RETURN

      END
C  -------------------------------------
C  Berechnen Folge Fn mit Test-Matrix FM
C  Berechnen F(n-1), F(n), F(n+1) modulo z
C  Max. Wert von n ist 2**23-1 = 8 388 607
C  Startwerte der Folge Fn stehen in V[3]

      SUBROUTINE FN_AB( FM, V, N, FN_1, FN, FN1, Z )

      IMPLICIT NONE

      INTEGER*4 N, FN_1, FN, FN1, Z
      REAL*8    FM(3,3), V(3)

      INTEGER*4 L, R, I
      REAL*8 RZ, A(3,3), B(3,3), FV(3), VV(3)

      REAL*8 E(3,3)           ! E = ( FM^(n-2) * V modulo N )
      COMMON / TEST / E

      FN_1 = 0
      FN   = 0
      FN1  = 0

      IF( N .LT.         2 ) RETURN    ! N zu klein
      IF( N .GT. 8 388 607 ) RETURN    ! N zu gross

      RZ = Z
      L  = N - 2   ! Achtung: L = Matrizenpotenz von FM ( nicht N-1 ! )

      E(1,1) = 1.0D0   ! E = I
      E(1,2) = 0.0D0
      E(1,3) = 0.0D0
      E(2,1) = 0.0D0
      E(2,2) = 1.0D0
      E(2,3) = 0.0D0
      E(3,1) = 0.0D0
      E(3,2) = 0.0D0
      E(3,3) = 1.0D0

      ! A aus: ( FM  modulo z )
      A(1,1) = DMOD( FM(1,1), RZ )
      A(1,2) = DMOD( FM(1,2), RZ )
      A(1,3) = DMOD( FM(1,3), RZ )
      A(2,1) = DMOD( FM(2,1), RZ )
      A(2,2) = DMOD( FM(2,2), RZ )
      A(2,3) = DMOD( FM(2,3), RZ )
      A(3,1) = DMOD( FM(3,1), RZ )
      A(3,2) = DMOD( FM(3,2), RZ )
      A(3,3) = DMOD( FM(3,3), RZ )

      ! VV = V  modulo z
      VV(1) =       V(1)
      VV(2) =       V(2)
      VV(3) = DMOD( V(3), RZ )

  100 CONTINUE
      IF( L .EQ. 0 ) THEN
         ! FV(3,1) = E(3,3) * VV(3,1); Startvektor in V[3]
         FV(1) = E(1,1)*VV(1) + E(1,2)*VV(2) + E(1,3)*VV(3)
         FV(2) = E(2,1)*VV(1) + E(2,2)*VV(2) + E(2,3)*VV(3)
         FV(3) = E(3,1)*VV(1) + E(3,2)*VV(2) + E(3,3)*VV(3)
         FN_1 = DMOD( FV(1), RZ )
         FN   = DMOD( FV(2), RZ )
         FN1  = DMOD( FV(3), RZ )
         IF( FN_1 .LT. 0 ) FN_1 = FN_1 + Z
         IF( FN   .LT. 0 ) FN   = FN   + Z
         IF( FN1  .LT. 0 ) FN1  = FN1  + Z
         RETURN
      END IF

      R = MOD( L, 2 )
      L = ( L - R ) / 2

      IF( R .EQ. 1 ) THEN
         ! B = A * E
         B(1,1) = A(1,1)*E(1,1) + A(1,2)*E(2,1) + A(1,3)*E(3,1)
         B(1,2) = A(1,1)*E(1,2) + A(1,2)*E(2,2) + A(1,3)*E(3,2)
         B(1,3) = A(1,1)*E(1,3) + A(1,2)*E(2,3) + A(1,3)*E(3,3)
         B(2,1) = A(2,1)*E(1,1) + A(2,2)*E(2,1) + A(2,3)*E(3,1)
         B(2,2) = A(2,1)*E(1,2) + A(2,2)*E(2,2) + A(2,3)*E(3,2)
         B(2,3) = A(2,1)*E(1,3) + A(2,2)*E(2,3) + A(2,3)*E(3,3)
         B(3,1) = A(3,1)*E(1,1) + A(3,2)*E(2,1) + A(3,3)*E(3,1)
         B(3,2) = A(3,1)*E(1,2) + A(3,2)*E(2,2) + A(3,3)*E(3,2)
         B(3,3) = A(3,1)*E(1,3) + A(3,2)*E(2,3) + A(3,3)*E(3,3)

         E(1,1) = DMOD( B(1,1), RZ )   ! E = ( B modulo z )
         E(1,2) = DMOD( B(1,2), RZ )
         E(1,3) = DMOD( B(1,3), RZ )
         E(2,1) = DMOD( B(2,1), RZ )
         E(2,2) = DMOD( B(2,2), RZ )
         E(2,3) = DMOD( B(2,3), RZ )
         E(3,1) = DMOD( B(3,1), RZ )
         E(3,2) = DMOD( B(3,2), RZ )
         E(3,3) = DMOD( B(3,3), RZ )
      END IF

      IF( L .GT. 0 ) THEN
         !  B = A * A
         B(1,1) = A(1,1)*A(1,1) + A(1,2)*A(2,1) + A(1,3)*A(3,1)
         B(1,2) = A(1,1)*A(1,2) + A(1,2)*A(2,2) + A(1,3)*A(3,2)
         B(1,3) = A(1,1)*A(1,3) + A(1,2)*A(2,3) + A(1,3)*A(3,3)
         B(2,1) = A(2,1)*A(1,1) + A(2,2)*A(2,1) + A(2,3)*A(3,1)
         B(2,2) = A(2,1)*A(1,2) + A(2,2)*A(2,2) + A(2,3)*A(3,2)
         B(2,3) = A(2,1)*A(1,3) + A(2,2)*A(2,3) + A(2,3)*A(3,3)
         B(3,1) = A(3,1)*A(1,1) + A(3,2)*A(2,1) + A(3,3)*A(3,1)
         B(3,2) = A(3,1)*A(1,2) + A(3,2)*A(2,2) + A(3,3)*A(3,2)
         B(3,3) = A(3,1)*A(1,3) + A(3,2)*A(2,3) + A(3,3)*A(3,3)

         A(1,1) = DMOD( B(1,1), RZ )   ! A = ( B modulo z )
         A(1,2) = DMOD( B(1,2), RZ )
         A(1,3) = DMOD( B(1,3), RZ )
         A(2,1) = DMOD( B(2,1), RZ )
         A(2,2) = DMOD( B(2,2), RZ )
         A(2,3) = DMOD( B(2,3), RZ )
         A(3,1) = DMOD( B(3,1), RZ )
         A(3,2) = DMOD( B(3,2), RZ )
         A(3,3) = DMOD( B(3,3), RZ )
      END IF
      I = 1
      IF( I .EQ. 1 ) GO TO 100
      END
C  ----------------------------------------------------
C  FILE_DAT = 'pascal_it.dat' fuers Lesen positionieren
C  und Kommentar- und Leer-Zeilen ueberlesen.

      SUBROUTINE UP_IN_POS( IO_IN, IO_LI )

      IMPLICIT NONE

      INTEGER*4 IO_IN, IO_LI, I

      CHARACTER*136 REC

   10 READ( IO_IN, '(A)', ERR=800, END=900 ) REC
      IF( REC(1:1) .EQ. '!' ) GO TO 10   ! Kommentarzeile ueberlesen
      DO 20, I = 1, 136
         IF( REC(I:I) .NE. ' ' ) THEN
            BACKSPACE IO_IN
            RETURN                       ! Datenzeile gefunden
         END IF
   20 CONTINUE
      GO TO 10                           ! Leerzeile ueberlesen

  800 WRITE( IO_LI, * ) 'Error beim Lesen von pascal_it.dat'
      STOP

  900 WRITE( IO_LI, * ) 'EOF erreicht beim Lesen von pascal_it.dat'
      STOP

      END
C  -------------------------------------------------------
C  Bestimmen Delta ID zu FRS-Rest X mit: (X+ID) = T * ganz

C  ID:  Delta
C  X :  FRS - Rest  (modulo N)
C  T :  Teiler von N

      SUBROUTINE UP_IT( ID, X, T )

      IMPLICIT NONE

      INTEGER*4 ID, X, T

      ! T = Teiler von N
      IF( T .LE. 1 ) THEN
         ID = 0
      ELSE
         ID = -MOD( X, T )
         IF( IABS( ID ) .GT. T/2 ) ID = ID + T
      END IF

      RETURN

      END
C  --------------------------
C  ( a^n + b ) == r  modulo m

      SUBROUTINE SIEB( A, N, B, M, R )

      IMPLICIT NONE

      REAL*8 A, N, B, M, R

      REAL*8 G, D, S, Q

      LOGICAL*4 START

      START = .TRUE.
      G     = N      ! G wird veraendert
      Q     = A * A

      D = DMOD( G, 2.0D0 )

      IF( D .EQ. 0.0D0 ) THEN
         S = 1.0D0
      ELSE
         S = A
      END IF

  100 CONTINUE
      G = ( G - D ) / 2.0D0

      IF( G .EQ. 0.0D0 ) GO TO 200   ! fertig

      D = DMOD( G, 2.0D0 )

      IF( START ) THEN
         START = .FALSE.
      ELSE
         Q = DMOD( Q*Q, M )
      END IF

      IF( D .NE. 0.0D0 ) THEN
         S = DMOD( Q * S, M )
      END IF

      GO TO 100

  200 R = DMOD( S + B, M )

      RETURN

      END
C  -------------------------------------------
C  Drucken Matrix oder Vektor FD[M,N],  Real*8
C  FD    = Matrix[M,N]
C  IOU   = Output-Unit
C  IVOR  = Anzahl Leer-Zeilen vor dem Drucken
C  INACH = Anzahl Leer-Zeilen nach dem Drucken
C  HFORM = Vektor der das Druck-Format enthaelt

      SUBROUTINE DPUT( FD, IOU, HFORM, M, N, IVOR, INACH )

      IMPLICIT NONE

      INTEGER*4 IOU
      INTEGER*4 N, M, IVOR, INACH, I, J
      REAL*8 FD(M,N)
      CHARACTER*(*) HFORM

      IF( IVOR .LE. 0 ) GO TO 9

      DO 5, I = 1, IVOR
         WRITE(IOU,2000)
    5 CONTINUE

    9 CONTINUE

      DO 10, I = 1, M
       WRITE(IOU,HFORM) ( FD(I,J), J = 1, N )
   10 CONTINUE

      IF( INACH .LE. 0 ) RETURN

      DO 15, I = 1, INACH
         WRITE(IOU,2000)
   15 CONTINUE

      RETURN

 2000 FORMAT(2H  )

      END
C  ---------------------------
C  Alle Teiler von P bestimmen
C  Anzahl der Teiler stehen in IANZ
C  IANZ = 1 wenn P prim
C  Teiler von P stehen in FT ( aufsteigend )
C  LAPSP = True wenn P absolut pseudoprim

C  Formeln:
C  Eine zusammengesetzte Zahl n ist absolut pseudoprim bzw.
C  eine Carmichael-Zahl wenn gilt:  n | a^n - a  fuer alle a mit
C  ggT( a, n ) = 1 .

C  und wenn n = q1 * q2 * ... * qk mit k >= 3,
C  wobei q1, q2, ... ,qk verschiedene Primzahlen
C  mit  qi-1 | n-1 ( i = 1, 2, ... ,k ) sind.

      SUBROUTINE TEILER( P, FT, IANZ, LAPSP )

      IMPLICIT NONE

      INTEGER*4 FT(*), P, IANZ,        I, G, A
      LOGICAL*4 LAPSP, LPRIM, L

      LAPSP = .FALSE.
      G = P
      I = 1
      IANZ = 1
      FT(1)= 1

      L = LPRIM( G, A )
      IF( L ) RETURN      ! P ist prim

  100 CONTINUE
      FT( I ) = A
      I = I + 1
      G = G / A

      L = LPRIM( G, A )
      IF( L ) THEN
         FT( I ) = G
         IANZ = I
         GO TO 200   ! alle Teiler bestimmt
      ELSE
         GO TO 100
      END IF

  200 CONTINUE
      IF(IANZ .LT. 3) RETURN   ! nicht abs. pseudoprim, Anzahl zu klein

      DO 250, I = 2, IANZ
         IF( FT(I) .LE. FT(I-1) ) RETURN   ! nicht alle Teiler ungleich
  250 CONTINUE

      G = P - 1
      DO 300, I = 1, IANZ
         IF( MOD( G, FT(I) - 1 ) .NE. 0 ) RETURN
  300 CONTINUE

      LAPSP = .TRUE.

      RETURN

      END
